      subroutine geteta(xt,yt,eta,theta,itime1,itime2,itime,indexf,
     +psurf,ngrid,indz1,indz2)        
C                       i  i  i/o   i     i      i      i     i
C       i     i     o     o
*****************************************************************************
*                                                                           *
*     Calculates eta for a given potential temperature.                     *
*     If profile is unstable, an eta region is given instead of a single    *
*     level.                                                                *
*                                                                           *
*     Author: A. Stohl                                                      *
*                                                                           *
*     27 April 1994                                                         *
*                                                                           *
*     Modified by Petra Seibert, 27 April 1995:                             *
*     indz1 and indz2 will contain indz on output instead of 1              *
*     in stable  case                                                       *
*                                                                           *
*****************************************************************************
*                                                                           *
* Variables:                                                                *
* akz,bkz(nuvzmax)     coefficients for computing the heights of the eta lev*
* deltazt              vertical displacement of trajectory in eta coordinate*
* dt,dt1,dt2           weighting factors                                    *
* eta                  old eta level of isentropic trajectory               *
* indexf               indicates the number of the wind field to be read in *
* indz1,indz2          indices of layer boundaries of unstable region       *
* itime                time index of trajectory position                    *
* itime1               time index of first temperature field                *
* itime2               time index of second temperature field               *
* ngrid                level of nested grid to be used                      *
* nx,ny,nuvz           field dimensions in x,y and z for (u,v) direction    *
* pp(nuvzmax) [Pa]     Pressure at the model levels                         *
* psurf [Pa]           Surface pressure                                     *
* theta [K]            theta level of trajectory calculation                *
* tt(0:nxmax-1,0:nymax-1,nuvzmax,3)  3-dim temperature field                *
* ttlev(nuvzmax) [K]   Potential temperature at the model levels            *
* xt,yt                Position of trajectory                               *
*                                                                           *
* Constants:                                                                *
* kappa                exponent for calculating potential temperature       *
* nuvzmax              maximum number of levels, where u,v and tt are given *
*                                                                           *
*****************************************************************************

      include 'includepar'
      include 'includecom'

      integer itime,itime1,itime2,indexf,k,indz,indz1,indz2,i,ngrid
      real xt,yt,zt,theta,zthelp,dt,dt1,dt2,deltazt,eta,thelp
      real psurf,pp(nuvzmax),ttlev(nuvzmax)


*********************************************
C 1. Calculate the pressure at all eta levels
********************************************* 

      do 10 k=1,nuvz
10      pp(k)=akz(k)+bkz(k)*psurf


************************************************
C 2. Calculate the temperature at all eta levels
************************************************

      do 16 k=1,nuvz
       if (ngrid.gt.0) then
         call levlininterpoln(ttn,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +   nxn,nyn,memind,xt,yt,k,itime1,itime2,itime,indexf,ttlev(k))
       else
         call levlininterpol(tt,nxmax,nymax,nuvzmax,nx,ny,memind,
     +   xt,yt,k,itime1,itime2,itime,indexf,ttlev(k))
       endif
16     continue


**********************************************************
C 3. Calculate the potential temperature at all eta levels
**********************************************************

      do 20 k=1,nuvz
20      ttlev(k)=ttlev(k)*(100000/pp(k))**kappa

*****************************************************************************
C 4. Search for the potential temperature that is equal to the temperature of
C trajectory calculation. If the region where this temperature can be found
C is unstable, find the lower and upper boundary of the unstable region.
*****************************************************************************

C Find the height where potential temp. is equal to trajectory level.
C If more levels exist, where this is valid, search for the one
C closest in eta coordinate to the eta coordinate of last time step.
*********************************************************************

      deltazt=999999.
      do 30 k=1,nuvz-1
        if (((ttlev(k).ge.theta).and.(ttlev(k+1).le.theta)).or.
     +  ((ttlev(k).le.theta).and.(ttlev(k+1).ge.theta))) then
          dt1=abs(theta-ttlev(k))
          dt2=abs(theta-ttlev(k+1))
          dt=dt1+dt2
          if (dt.lt.eps) then   ! Avoid division by zero error
            dt1=0.5             ! G.W., 10.4.1996
            dt2=0.5
            dt=1.0
          endif
          zthelp=(uvheight(k)*dt2+uvheight(k+1)*dt1)/dt
          if (abs(zthelp-eta).lt.deltazt) then
            deltazt=abs(zthelp-eta)
            zt=zthelp
            indz=k
          endif
        endif
30      continue


      if (deltazt.gt.999990.) then                 ! no level has been found
        if (abs(ttlev(1)-theta).lt.abs(ttlev(nuvz)-theta)) then
          indz=1
          zt=uvheight(1)
        else
          indz=nuvz-1
          zt=uvheight(nuvz)
        endif
      endif


C Determine if the air at trajectory level is stable or unstable stratified
C If it is stable -> just take the level
C If it is unstable -> take the whole unstable region and determine lower
C and upper boundary of this region
***************************************************************************

      if (ttlev(indz).lt.ttlev(indz+1)) then     ! stable region
        eta=zt
        indz1=indz       
        indz2=indz1       ! -----, indz1 and indz2 must be equal
      else                                       ! unstable region
        indz1=1
        do 40 k=indz-1,1,-1
          if (ttlev(k).lt.ttlev(k+1)) then
            indz1=k+1                     ! lower boundary of unstable region
            thelp=ttlev(indz1)
            goto 45
          endif
40        continue
45      continue
        indz2=indz+1
        do 50 k=indz+2,nuvz
          if (ttlev(k).gt.ttlev(indz1)) then
            indz2=k-1                     ! upper boundary of unstable region
            goto 55
          endif
50        continue
55      continue
        eta=uvheight(indz2)


C Calculate new mean potential temperature of the unstable layer
****************************************************************

        theta=0.
        do 60 i=indz1,indz2
60        theta=theta+ttlev(i)
        theta=theta/float(indz2-indz1+1)
      endif


      return
      end

      subroutine getwind(firststep,init,itime,levconst,xt,yt,zt,
     +lkind,lkindz,iter,ngrid,uint,vint,dzdt,idiff,indwz,nstop)
C                            i      i    i       i     i  i  i
C       i      i    i     i    o    o    o     o     o     o
********************************************************************************
*                                                                              *
*  This subroutine reads the wind fields and interpolates the wind fields to   *
*  the current trajectory position.                                            *
*  One has to distinguish between different types of trajectories, eg. isobaric*
*  on model layers or 3-dim. Interpolation is done separately for each of these*
*  types.                                                                      *
*                                                                              *
*    Author: A. Stohl                                                          *
*                                                                              *
*    26 April 1994                                                             *
*                                                                              *
*     Update: 23 December 1998 (Use of global domain and nesting)              *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* uint,vint,dzdt     wind components in grid units per second                  *
* firststep          .true. for first iteration of petterssen                  *
* idiff [s]          Temporal distance between the windfields used for interpol*
* indwz              index of the model layer beneath current position of traj.*
* init               .true. for first time step of trajectory                  *
* iter               number of iteration step                                  *
* itime [s]          current temporal position                                 *
* levconst           height of trajectory in Pa, m or K, depending on type of t*
* lkind              kind of trajectory (e.g. isobaric, 3-dimensional)         *
* lkindz             unit of z coordinate (1:masl, 2:magl, 3:hPa)              *
* memtime(3) [s]     times of the wind fields in memory                        *
* ngrid              points towards which grid shall be used                   *
* nstop              =greater 0, if trajectory calculation is finished         *
* xt,yt,zt           coordinates position for which wind data shall be calculat*
*                                                                              *
* Constants:                                                                   *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer itime,idiff,indexf,indwz,nstop,lkind,lkindz,iter,ngrid
      real xt,yt,zt,levconst,uint,vint,dzdt
      logical firststep,init


C Update of the wind fields that are currently kept in memory.
C If a new wind field is necessary, read it.
**************************************************************

      call getfields(firststep,itime,indexf,idiff,nstop)

      if (nstop.ge.3) return       ! error has occurred

C Call interpolation of the different types of trajectories.
************************************************************
     
      if (lkind.eq.1) then         ! full 3-dimensional trajectories
        call inter3d(xt,yt,zt,indexf,itime,init,firststep,
     +  iter,lkindz,ngrid,uint,vint,dzdt,indwz)
      else if (lkind.eq.2) then    ! trajectories on model layers
        call intermod(xt,yt,zt,indexf,itime,init,firststep,
     +  iter,lkindz,ngrid,uint,vint)
        dzdt=0.
      else if (lkind.eq.3) then    ! mixing layer trajectories
        call intermix(xt,yt,zt,levconst,indexf,itime,iter,ngrid,
     +  uint,vint)
        dzdt=0.
      else if (lkind.eq.4) then    ! isobaric trajectories
        call interisobar(xt,yt,zt,levconst,indexf,itime,init,firststep,
     +  iter,lkindz,ngrid,uint,vint)
        dzdt=0.
      else if (lkind.eq.5) then    ! isentropic trajectories
        call interisentrop(xt,yt,zt,levconst,indexf,itime,init,
     +  firststep,iter,lkindz,ngrid,uint,vint)
      endif

      return
      end

      subroutine levinterpol(yy,nxmax,nymax,nzmax,nx,ny,memind,
     +xt,yt,level,itime1,itime2,itime,indexf,yint)
C                               i    i     i     i   i  i    i
C     i  i    i     i      i      i     i    o
*****************************************************************************
*                                                                           *
*  Interpolation of 3-dimensional meteorological fields.                    *
*  In horizontal direction bicubic interpolation interpolation is used.     *
*  In the temporal direction linear interpolation is used.                  *
*  These interpolation techniques have been found to be most accurate.      *
*                                                                           *
*  The interpolation routines have been taken from:                         *
*  Press W.H. et al. (1992): Numerical Recipes in FORTRAN. The art of       *
*  scientific computing. 2nd edition. Cambridge University Press.           *
*                                                                           *
*  But they have been modified for faster performance.                      *
*                                                                           *
*  4-3                                                                      *
*  | |  The points are numbered in this order. Values and gradients are     *
*  1-2  stored in fields with dimension 4.                                  *
*                                                                           *
*  1 is the first time                                                      *
*  2 is the second time                                                     *
*                                                                           *
*                                                                           *
*     Author: A. Stohl                                                      *
*                                                                           *
*     30 May 1994                                                           *
*                                                                           *
*****************************************************************************
*                                                                           *
* Variables:                                                                *
*                                                                           *
* dt1,dt2              time differences between fields and current position *
* indexf                indicates the number of the wind field to be read in *
* indexfh               help variable                                        *
* level                help variable                                        *
* itime                current time                                         *
* itime1               time of the first wind field                         *
* itime2               time of the second wind field                        *
* ix,jy                x,y coordinates of lower left subgrid point          *
* level                level for which interpolation shall be done          *
* memind(3)            points to the places of the wind fields              *
* nx,ny                actual field dimensions in x,y and z direction       *
* nxmax,nymax,nzmax    maximum field dimensions in x,y and z direction      *
* x1l,x2l              x,y coordinates of lower left subgrid point          *
* x1u,x2u              x,y coordinates of upper right subgrid point         *
* xt                   current x coordinate                                 *
* y(4,2,1)             subset of 4 points for 2 times and 1 level           *
* ygx(4,2,1)           x gradients at 4 points for 2 times and 1 level      *
* ygy(4,2,1)           y gradients at 4 points for 2 times and 1 level      *
* ygxy(4,2,1)          x,y gradients at 4 points for 2 times and 1 level    *
* yhelp(2,1)           the interpolated values for 2 times and 1 level      *
* yint                 the final interpolated value                         *
* yt                   current y coordinate                                 *
* yy(0:nxmax,0:nymax,nzmax,3) meteorological field used for interpolation   *
*                                                                           *
*****************************************************************************

      implicit none

      integer nx,ny,nxmax,nymax,nzmax,memind(3),i,j,l,m,n,ix,jy
      integer level,itime,itime1,itime2,indexf,indexfh,im,ip,jm,jp
      real yy(0:nxmax-1,0:nymax-1,nzmax,3)
      real y(4,2,1),ygx(4,2,1),ygy(4,2,1),ygxy(4,2,1),yhelp(2,1)
      real x1l,x1u,x2l,x2u,dt1,dt2
      real xt,yt,yint
     


C If point at border of grid -> small displacement into grid
************************************************************

      if (xt.ge.float(nx-1)) xt=float(nx-1)-0.00001
      if (yt.ge.float(ny-1)) yt=float(ny-1)-0.00001



***********************************************************************
C 1.) Bicubic horizontal interpolation
C This has to be done separately for 2 fields (Temporal)
***********************************************************************

C Determine the lower left corner
********************************* 

      ix=int(xt)
      jy=int(yt)

      x1l=float(ix)
      x1u=float(ix+1)
      x2l=float(jy)
      x2u=float(jy+1)


C Loop over the 2*2 grid points
*******************************

      do 10 l=1,4
        if (l.eq.1) then
          i=ix
          j=jy
        else if (l.eq.2) then
          i=ix+1
          j=jy
        else if (l.eq.3) then
          i=ix+1
          j=jy+1
        else if (l.eq.4) then
          i=ix
          j=jy+1
        endif
        ip=i+1
        im=i-1
        jp=j+1
        jm=j-1


C Loop over 2 time steps and 3 levels
*************************************
 
        do 10 m=1,2
        do 10 n=1,1        ! this loop and dimension is necessary to be in 
                           ! agreement with the full 3-d interpolation

          indexfh=memind(indexf+m-1)


C Values at the 2*2 subgrid
***************************

          y(l,m,n)=yy(i,j,level,indexfh)   


C Calculate derivatives in x-direction on the 2*2 subgrid
*********************************************************

          if (i.eq.0) then
            ygx(l,m,n) = yy(ip,j ,level,indexfh)
     +                 - yy(i ,j ,level,indexfh)
          else if (i.eq.nx-1) then
            ygx(l,m,n) = yy(i ,j ,level,indexfh)
     +                 - yy(im,j ,level,indexfh)
          else
            ygx(l,m,n) =(yy(ip,j ,level,indexfh)
     +                 - yy(im,j ,level,indexfh))/2.
          endif


C Calculate derivatives in y-direction on the 2*2 subgrid
*********************************************************

          if (j.eq.0) then
            ygy(l,m,n) = yy(i ,jp,level,indexfh)
     +                 - yy(i ,j ,level,indexfh)
          else if (j.eq.ny-1) then
            ygy(l,m,n) = yy(i ,j ,level,indexfh)
     +                 - yy(i ,jm,level,indexfh)
          else
            ygy(l,m,n) =(yy(i ,jp,level,indexfh)
     +                 - yy(i ,jm,level,indexfh))/2.
          endif


C Calculate cross derivative on the 2*2 subgrid
***********************************************

          if ((i.eq.0).and.(j.eq.0)) then
            ygxy(l,m,n)= yy(ip,jp,level,indexfh)-
     +                   yy(ip,j ,level,indexfh)-
     +                   yy(i ,jp,level,indexfh)+
     +                   yy(i ,j ,level,indexfh)
          else if ((i.eq.nx-1).and.(j.eq.ny-1)) then
            ygxy(l,m,n)= yy(i ,j ,level,indexfh)-
     +                   yy(i ,jm,level,indexfh)-
     +                   yy(im,j ,level,indexfh)+
     +                   yy(im,jm,level,indexfh)
          else if ((i.eq.0).and.(j.eq.ny-1)) then
            ygxy(l,m,n)= yy(ip,j ,level,indexfh)-
     +                   yy(ip,jm,level,indexfh)-
     +                   yy(i ,j ,level,indexfh)+
     +                   yy(i ,jm,level,indexfh)
          else if ((i.eq.nx-1).and.(j.eq.0)) then
            ygxy(l,m,n)= yy(i ,jp,level,indexfh)-
     +                   yy(i ,j ,level,indexfh)-
     +                   yy(im,jp,level,indexfh)+
     +                   yy(im,j ,level,indexfh)
          else if (i.eq.nx-1) then
            ygxy(l,m,n)=(yy(i ,jp,level,indexfh)-
     +                   yy(i ,jm,level,indexfh)-
     +                   yy(im,jp,level,indexfh)+
     +                   yy(im,jm,level,indexfh))/2.
          else if (i.eq.0) then
            ygxy(l,m,n)=(yy(ip,jp,level,indexfh)-
     +                   yy(ip,jm,level,indexfh)-
     +                   yy(i ,jp,level,indexfh)+
     +                   yy(i ,jm,level,indexfh))/2.
          else if (j.eq.ny-1) then
            ygxy(l,m,n)=(yy(ip,j ,level,indexfh)-
     +                   yy(ip,jm,level,indexfh)-
     +                   yy(im,j ,level,indexfh)+
     +                   yy(im,jm,level,indexfh))/2.
          else if (j.eq.0) then
            ygxy(l,m,n)=(yy(ip,jp,level,indexfh)-
     +                   yy(ip,j ,level,indexfh)-
     +                   yy(im,jp,level,indexfh)+
     +                   yy(im,j ,level,indexfh))/2.
          else
            ygxy(l,m,n)=(yy(ip,jp,level,indexfh)-
     +                   yy(ip,jm,level,indexfh)-
     +                   yy(im,jp,level,indexfh)+
     +                   yy(im,jm,level,indexfh))/4.
          endif

10        continue


C Call bicubic interpolation
****************************

      call bicubic(y,ygx,ygy,ygxy,x1l,x1u,x2l,x2u,xt,yt,yhelp,2,1)



*************************************
C 2.) Temporal interpolation (linear)
*************************************

      dt1=float(itime-itime1)
      dt2=float(itime2-itime)

      yint=(yhelp(1,1)*dt2+yhelp(2,1)*dt1)/(dt1+dt2)


      return
      end

      subroutine etatrafo(xt,yt,zt,itime1,itime2,itime,indexf,ngrid,
     +psint)
***********************************************************************
*                                                                     *
*             TRAJECTORY MODEL SUBROUTINE ETATRAFO                    *
*                                                                     *
***********************************************************************
*                                                                     *
*             AUTHOR:      G. WOTAWA                                  *
*             DATE:        1994-04-06                                 *
*             LAST UPDATE: ----------                                 *
*                                                                     *
***********************************************************************
*                                                                     *
* DESCRIPTION: This subroutine transforms the vertical coordinate     *
*              from z-coordinate system [m] to eta-coordinate         *
*              system [ECMWF]                                         *
*              Remark: Just call after initialization of a new        *
*              trajectory (first call of getwind)                     *
*                                                                     *
***********************************************************************
*                                                                     *
* INPUT:                                                              *
*                                                                     *
* xt                         x-coordinate of point [grid units]       *
* yt                         y-coordinate of point [grid units]       *
* zt                         z-coordinate of point [m]                *
* itime1                     time [s] of first windfield              *
* itime2                     time [s] of second windfield             *
* itime                      time [s] of calculation                  *
* indexf                     time index of field xx                   *
* psint                      surface pressure at point (xt,yt) [Pa]   *
*                                                                     *
***********************************************************************
*                                                                     *
* OUTPUT:                                                             *
*                                                                     *
* zt                         z-coordinate of point [eta ECMWF]        *
*                                                                     *
***********************************************************************
*
      include 'includepar'
      include 'includecom'

      integer itime1,itime2,itime,indexf,k,ngrid
      real xt,yt,zt,psint,fract,pp1,pp2,tv
      real tlev(nuvzmax),zzlev(nwzmax)
*
* calculate interpolated vertical temperature profile on model levels
*
      do 10 k=1,nuvz
       if (ngrid.gt.0) then
         call levlininterpoln(ttn,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +   nxn,nyn,memind,xt,yt,k,itime1,itime2,itime,indexf,tlev(k))
       else
         call levlininterpol(tt,nxmax,nymax,nuvzmax,nx,ny,memind,
     +   xt,yt,k,itime1,itime2,itime,indexf,tlev(k))
       endif
10     continue
*
* calculate geometric height on model levels
*
      zzlev(1)=0.
      if (zt.lt.zzlev(1)) then
        write(*,*) ' TRAJECTORY MODEL: NOTICE - STARTING POINT OUT'//
     &             ' OF MODEL DOMAIN'
        write(*,*) ' (VERTICAL) HAS BEEN DETECTED --> IT IS SET TO'//
     &             ' THE BOTTOM OF THE MODEL ...'
        zt=uvheight(1)
        return
      endif
      do 15 k=2,nwz
        pp1=akm(k-1)+bkm(k-1)*psint
        pp2=akm(k)+bkm(k)*psint
        tv=tlev(k-1)      !! NO HUMIDITY INFORMATION AVAILABLE IN FLEXTRA
        zzlev(k)=zzlev(k-1)+r_air/ga*log(pp1/pp2)*tv
        if(zt.lt.zzlev(k)) goto 20
15    continue
      write(*,*) ' TRAJECTORY MODEL: NOTICE - STARTING POINT OUT'//
     &           ' OF MODEL DOMAIN'
      write(*,*) ' (VERTICAL) HAS BEEN DETECTED --> IT IS SET TO'//
     &           ' THE TOP OF THE MODEL ...'
      zt=uvheight(nuvz)
      return
20    fract=(zt-zzlev(k-1))/(zzlev(k)-zzlev(k-1))
      zt=wheight(k-1)*(1.-fract)+wheight(k)*fract
      if(zt.lt.uvheight(1)) zt=uvheight(1)
      if(zt.gt.uvheight(nuvz)) zt=uvheight(nuvz)
      return
      end

      program flextra
********************************************************************************
*                                                                              *
*     This program calculates trajectories for various input wind fields.      *
*                                                                              *
*     Authors: A. Stohl, G. Wotawa                                             *
*                                                                              *
*     2 February 1994                                                          *
*                                                                              *
*     Update: January 1999: A. Stohl                                           *
*     Use of global fields, CET option, etc.                                   *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* error                .true., if error ocurred in subprogram, else .false.    *
*                                                                              *
* Constants:                                                                   *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      logical error,oronew


C Read the pathnames where input/output files are stored
********************************************************

      call readpaths(error)
      if (error) goto 999


C Read the user specifications for the current model run
********************************************************

      call readcommand(error)
      if (error) goto 999

C Read, which wind fields are available within the modelling period
*******************************************************************

      call readavailable(error)
      if(error) goto 999

C Determine the grid specifications and the vertical discretization
*******************************************************************
 
      call gridcheck(oronew,error)
      if(error) goto 999
      call gridcheck_nests(error)
      if(error) goto 999
 
 
C Read the orography used by the ECMWF model
********************************************
 
      if(.not.oronew) call readoro(error)
      if(error) goto 999

C Read the coordinates of trajectory beginning/ending points for the
C current model run
C Alternatively, if CET is to be calculated read CET starting domain
********************************************************************

      if (modecet.eq.1) then
        call readpoints(error)
      else if (modecet.eq.2) then
        call readcet(error)
      else
        call readflight(error)
      endif
      if(error) goto 999


C Check, if user selected options don't exceed the current dimension limits
***************************************************************************

      call checklimits(error)
      if(error) goto 999

C Conversion of the startpoints from geografical to grid coordinates
********************************************************************

      call coordtrafo(error)
      if(error) goto 999


C Fix the coordinates of the uncertainty trajectories
*****************************************************

      if (modecet.eq.1) call uncertcoor()

 
C Subtract the orography from the height above sea level
********************************************************

      call subtractoro()


C Open the output files
***********************

      if (modecet.eq.1) then
        call openoutput(error)
      else if (modecet.eq.2) then
        call opencetoutput(error)
      else
        call openflightoutput(error)
      endif
      if(error) goto 999


C Calculate trajectories
************************
      
      call timemanager()


C Close output and reverse direction of back trajectory output
**************************************************************

      if (modecet.eq.1) call lastprocessor()

      write(*,*) 'CONGRATULATIONS: YOU HAVE SUCCESSFULLY COMPLETED A  FL
     +EXTRA  MODEL RUN!'

      goto 1000

999   write(*,*) 'FLEXTRA MODEL ERROR: EXECUTION HAD TO BE TERMINATED'

1000  continue

      end

      subroutine gridcheck(oronew,error)
***********************************************************************
*                                                                     * 
*             TRAJECTORY MODEL SUBROUTINE GRIDCHECK                   *
*                                                                     *
***********************************************************************
*                                                                     * 
*             AUTHOR:      G. WOTAWA                                  *
*             DATE:        1997-08-06                                 *
*                                                                     * 
*             Update:      1998-12, global fields allowed, A. Stohl   *
*             Modification:2001-01, NCEP Pressure level data,         *
*                          G. Wotawa                                  * 
*             Sabine Eckhardt, Jan 2008 update to read GRIB2 with     *
*                              Grib Api                               *
*                                                                     * 
***********************************************************************
*                                                                     *
* DESCRIPTION:                                                        *
*                                                                     *
* THIS SUBROUTINE DETERMINES THE GRID SPECIFICATIONS (LOWER LEFT      *
* LONGITUDE, LOWER LEFT LATITUDE, NUMBER OF GRID POINTS, GRID DIST-   *
* ANCE AND VERTICAL DISCRETIZATION OF THE ECMWF MODEL) FROM THE       *
* GRIB HEADER OF THE FIRST INPUT FILE. THE CONSISTANCY (NO CHANGES    *
* WITHIN ONE FLEXTRA RUN) IS CHECKED IN THE ROUTINE "READWIND" AT ANY *
* CALL.                                                               *
*                                                                     *
* OUTPUT       error .true.   - can not read grid specifications      *
*              error .false.  - normal                                *
*              oronew .true.  - Terrain heights given in grib files   *
*              oronew .false. - Terrain heights not specified in the  *
*                               grib files (old file standard)        *
*                                                                     * 
* XLON0                geographical longitude of lower left gridpoint *
* XLAT0                geographical latitude of lower left gridpoint  *
* NX                   number of grid points x-direction              *
* NY                   number of grid points y-direction              *
* DX                   grid distance x-direction                      *
* DY                   grid distance y-direction                      *
* NUVZ                 number of grid points for horizontal wind      *
*                      components in z direction                      *
* NWZ                  number of grid points for vertical wind        *
* sizesouth, sizenorth give the map scale (i.e. number of virtual grid*
*                      points of the polar stereographic grid):       *
*                      used to check the CFL criterion                *
*                      component in z direction                       *
* UVHEIGHT(1)-         heights of gridpoints where u and v are        *
* UVHEIGHT(NUVZ)       given                                          *
* WHEIGHT(1)-          heights of gridpoints where w is given         *
* WHEIGHT(NWZ)                                                        *
*                                                                     *
***********************************************************************
*
      include 'includepar'
      include 'includecom'
      include 'grib_api_f77.h'



      integer i,ifn,ifield,j,k,iumax,iwmax,numskip
      real sizesouth,sizenorth,xauxa
      real plev(nwzmax),help
      logical error,oronew

* VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

C dimension of isec2 at least (22+n), where n is the number of parallels or
C meridians in a quasi-regular (reduced) Gaussian or lat/long grid

C dimension of zsec2 at least (10+nn), where nn is the number of vertical
C coordinate parameters

      integer isec1(56),isec2(22+nxmax+nymax)
      real zsec4(jpunp)

!HSO  parameters for grib_api 
      integer ifile
      integer iret
      integer igrib
      integer*4 isize
      real*4  xaux1,xaux2,yaux1,yaux2
      real*8  xaux1in,xaux2in,yaux1in,yaux2in,zsecn4(jpunp*4)
      integer gribVer,parCat,parNum,typSurf,valSurf
!HSO  end

      integer i179,i180,i181
      real akm_usort(nwzmax)

      error=.false.
      oronew=.false.
      iumax=0
      iwmax=0
*
      if(ideltas.gt.0) then
        ifn=1
      else
        ifn=numbwf
      endif

*
* OPENING OF DATA FILE (GRIB CODE)
*
      ifile=5
5     iret=grib_open_file(ifile,path(3)(1:len(3))//
     >trim(wfname(ifn)),'r')
      call grib_check(iret)
!     turn on support for multi fields messages */
      call grib_check(grib_multi_support_on())
!HSO 5    call pbopen(lunit,path(3)(1:len(3))//wfname(ifn),'r',ierr)
!     if(ierr.lt.0) goto 999
!HSO fin

      ifield=0   
10    ifield=ifield+1

*
* GET NEXT FIELDS
*
      iret = grib_new_from_file(ifile,igrib)
      if (igrib .eq. -1 )  then         
        if (iret .ne. -1) then
          call grib_check(iret)
          goto 999   ! ERROR DETECTED
        endif
        goto 30    ! EOF DETECTED
      endif



C Check whether we are on a little endian or on a big endian computer
*********************************************************************

c     if (inbuff(1).eq.1112101447) then         ! little endian, swap bytes
c       iswap=1+ilen/4
c       call swap32(inbuff,iswap)
c     else if (inbuff(1).ne.1196575042) then    ! big endian
c       stop 'subroutine gridcheck: corrupt GRIB data'
c     endif



!     first see if we read GRIB1 or GRIB2
      call grib_check(grib_get_int(  igrib,
     >'editionNumber',gribVer))

!     get the size and data of the values array
      call grib_check(grib_get_size(igrib,'values',isize))
      call grib_check(grib_get_real8_array(igrib,'values',zsecn4,isize))
      do  i=1,isize
        zsec4(i)=zsecn4(i)
      enddo

      if (gribVer.eq.1) then ! GRIB Edition 1

!     read the grib1 identifiers
      call grib_check(grib_get_int(  igrib,
     >'indicatorOfParameter',isec1(6)))
      call grib_check(grib_get_int(  igrib,
     >'indicatorOfTypeOfLevel',isec1(7)))
      call grib_check(grib_get_int(  igrib,
     >'level',isec1(8)))

      else ! GRIB Edition 2

!     read the grib2 identifiers
      call grib_check(grib_get_int(  igrib,
     >'parameterCategory',parCat))
      call grib_check(grib_get_int(  igrib,
     >'parameterNumber',parNum))
      call grib_check(grib_get_int(  igrib,
     >'typeOfFirstFixedSurface',typSurf))
      call grib_check(grib_get_int(  igrib,
     >'scaledValueOfFirstFixedSurface',valSurf))

!     convert to grib1 identifiers
      isec1(6)=-1
      isec1(7)=-1
      isec1(8)=-1
      if ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.100)) then ! U
        isec1(6)=33          ! indicatorOfParameter
        isec1(7)=100         ! indicatorOfTypeOfLevel
        isec1(8)=valSurf/100 ! level, convert to hPa
      elseif ((parCat.eq.3).and.(parNum.eq.5).and.(typSurf.eq.1)) then ! TOPO 
        isec1(6)=7           ! indicatorOfParameter
        isec1(7)=1           ! indicatorOfTypeOfLevel
        isec1(8)=0
      elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.1)) then ! LSM
        isec1(6)=81          ! indicatorOfParameter
        isec1(7)=1           ! indicatorOfTypeOfLevel
        isec1(8)=0
      endif

      endif ! gribVer

      if(ifield.eq.1) then

!     get the required fields from section 2 
!     store compatible to gribex input
        call grib_check(grib_get_int(  igrib,
     >'numberOfPointsAlongAParallel',isec2(2)))
        call grib_check(grib_get_int(  igrib,
     >'numberOfPointsAlongAMeridian',isec2(3)))
        call grib_check(grib_get_real8(igrib,
     >'latitudeOfFirstGridPointInDegrees',yaux2in))
        call grib_check(grib_get_real8(igrib,
     >'longitudeOfFirstGridPointInDegrees',xaux1in))
        call grib_check(grib_get_real8(igrib,
     >'latitudeOfLastGridPointInDegrees',yaux1in))
        call grib_check(grib_get_real8(igrib,
     >'longitudeOfLastGridPointInDegrees',xaux2in))
      xaux1=xaux1in
      xaux2=xaux2in
      yaux1=yaux1in
      yaux2=yaux2in

c     if (ierr.ne.0) goto 10    ! ERROR DETECTED



        nxfield=isec2(2)
        ny=isec2(3)
        if((abs(xaux1).lt.eps).and.(xaux2.ge.359)) then ! NCEP DATA FROM 0 TO
          xaux1=-179.0                             ! 359 DEG EAST ->
          xaux2=-179.0+360.-360./float(nxfield)    ! TRANSFORMED TO -179
        endif                                      ! TO 180 DEG EAST
        if (xaux1.gt.180) xaux1=xaux1-360.0
        if (xaux2.gt.180) xaux2=xaux2-360.0
        if (xaux1.lt.-180) xaux1=xaux1+360.0
        if (xaux2.lt.-180) xaux2=xaux2+360.0
        if (xaux2.lt.xaux1) xaux2=xaux2+360.
        xlon0=xaux1
        ylat0=yaux1
        dx=(xaux2-xaux1)/float(nxfield-1)
        dy=(yaux2-yaux1)/float(ny-1)

        i179=nint(179./dx)
        i180=nint(179./dx)+1
        i181=i180+1

C Check whether fields are global
C If they contain the poles, specify polar stereographic map 
C projections using the stlmbr- and stcm2p-calls
************************************************************

        xauxa=abs(xaux2+dx-360.-xaux1)
        if (xauxa.lt.0.001) then
          nx=nxfield+1                 ! field is cyclic
          xglobal=.true.
        else
          nx=nxfield
          xglobal=.false.
        endif
        xauxa=abs(yaux1+90.)
        if (xglobal.and.xauxa.lt.0.001) then
          sglobal=.true.               ! field contains south pole
C Enhance the map scale by factor 3 (*2=6) compared to north-south
C map scale
          sizesouth=6.*(switchsouth+90.)/dy
          call stlmbr(southpolemap,-90.,0.)
          call stcm2p(southpolemap,0.,0.,switchsouth,0.,sizesouth,
     +    sizesouth,switchsouth,180.)
          switchsouthg=(switchsouth-ylat0)/dy
        else
          sglobal=.false.
          switchsouthg=999999.
        endif
        xauxa=abs(yaux2-90.)
        if (xglobal.and.xauxa.lt.0.001) then
          nglobal=.true.               ! field contains north pole
C Enhance the map scale by factor 3 (*2=6) compared to north-south
C map scale
          sizenorth=6.*(90.-switchnorth)/dy
          call stlmbr(northpolemap,90.,0.)
          call stcm2p(northpolemap,0.,0.,switchnorth,0.,sizenorth,
     +    sizenorth,switchnorth,180.)
          switchnorthg=(switchnorth-ylat0)/dy
        else
          nglobal=.false.
          switchnorthg=999999.
        endif
      endif

     
      if((isec1(6).eq.007).and.(isec1(7).eq.001)) oronew=.true.
*      k=isec1(8)
*      if(isec1(6).eq. 33) iumax=max(iumax,nlev_ec-k+1)
*      if(isec1(6).eq. 39) iwmax=max(iwmax,nlev_ec-k+1) 
      if((isec1(6).eq.33).and.(isec1(7).eq.100)) then
        iumax=iumax+1
        plev(iumax)=float(isec1(8))*100.0
      endif

      if((isec1(6).eq.007).and.(isec1(7).eq.001)) then
* TOPOGRAPHY
        do 20 j=0,ny-1
          do 21 i=0,nxfield-1
            help=zsec4(nxfield*(ny-j-1)+i+1)
            if(i.le.180) then
              oro(i179+i,j)=help
            else
              oro(i-i181,j)=help
            endif
21        continue
20        continue
      endif

      if (igrib.ne.-1) then
        call grib_check(grib_release(igrib)) 
      endif

      goto 10                      !! READ NEXT LEVEL OR PARAMETER
      
30    continue

*
* CLOSING OF INPUT DATA FILE
*
      call grib_check(grib_close_file(ifile))

      nuvz=iumax
      nwz =iumax
      nlev_ec=iumax

      if (nx.gt.nxmax) then                         
      write(*,*) 'FLEXTRA error: Too many grid points in x direction.'
      write(*,*) 'Reduce resolution of wind fields (file GRIDSPEC).'
      error=.true.
      return
      endif

      if (ny.gt.nymax) then                         
      write(*,*) 'FLEXTRA error: Too many grid points in y direction.'
      write(*,*) 'Reduce resolution of wind fields (file GRIDSPEC).'
      error=.true.
      return
      endif

      if (nuvz.gt.nuvzmax) then                         
      write(*,*) 'FLEXTRA error: Too many u,v grid points in z '//
     +'direction.'
      write(*,*) 'Reduce resolution of wind fields (file GRIDSPEC).'
      error=.true.
      return
      endif

      if (nwz.gt.nwzmax) then                         
      write(*,*) 'FLEXTRA error: Too many w grid points in z '//
     +'direction.'
      write(*,*) 'Reduce resolution of wind fields (file GRIDSPEC).'
      error=.true.
      return
      endif

C Output of grid info
*********************

      write(*,*)
      write(*,*)
      write(*,'(a,2i7)') '# of vertical levels: ',nuvz,nwz
      write(*,*)
      write(*,'(a)') 'Mother domain:'
      write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Longitude range: ',
     +xlon0,' to ',xlon0+(nx-1)*dx,'   Grid distance: ',dx
      write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range:  ',
     +ylat0,' to ',ylat0+(ny-1)*dy,'   Grid distance: ',dy
      write(*,*)

 
C Compute often used aux variables to convert geografical into grid coord.
***************************************************************************

      xthelp=180./pi/r_earth/dx
      ythelp=180./pi/r_earth/dy

 

* CALCULATE VERTICAL DISCRETIZATION OF ECMWF MODEL
* PARAMETER akm,bkm DESCRIBE THE HYBRID "ETA" COORDINATE SYSTEM
* wheight(i) IS THE HEIGHT OF THE i-th MODEL HALF LEVEL (=INTERFACE BETWEEN
* 2 MODEL LEVELS) IN THE "ETA" SYSTEM

      numskip=nlev_ec-nuvz  ! number of ecmwf model layers not used
                            ! by trajectory model
      do 40 i=1,nwz
        j=numskip+i
        k=nlev_ec+1+numskip+i
        akm_usort(nwz-i+1)=plev(nwz-i+1)
40      bkm(nwz-i+1)=0.0

*******************************
* change Sabine Eckhardt: akm should always be in descending order ... readwind adapted!
*******************************
          do 41 i=1,nwz
             if (akm_usort(1).gt.akm_usort(2)) then
                akm(i)=akm_usort(i)
             else
                akm(i)=akm_usort(nwz-i+1)
             endif
41        continue


* CALCULATION OF uvheight, akz, bkz
* akz,bkz ARE THE DISCRETIZATION PARAMETERS FOR THE MODEL LEVELS
* uvheight(i) IS THE HEIGHT OF THE i-th MODEL LEVEL IN THE "ETA" SYSTEM

      do 43 i=1,nwz
43      wheight(nwz-i+1)=akm(nwz-i+1)/p0+bkm(nwz-i+1)

      do 45 i=1,nuvz
        uvheight(i)=wheight(i)
        akz(i)=akm(i)
        bkz(i)=bkm(i)
45      continue

C If vertical coordinates decrease with increasing altitude, multiply by -1.
C This means that also the vertical velocities have to be multiplied by -1.
****************************************************************************

      if (uvheight(1).lt.uvheight(nuvz)) then
        zdirect=1.
      else
        zdirect=-1.
        do 55 i=1,nuvz
55        uvheight(i)=zdirect*uvheight(i)
        do 65 i=1,nwz
65        wheight(i)=zdirect*wheight(i)
      endif

C Compute minimum and maximum height of modelling domain
********************************************************

      heightmin=max(uvheight(1),wheight(1))
      heightmax=min(uvheight(nuvz),wheight(nwz))


      return

999   write(*,*)  
      write(*,*) ' ###########################################'//
     &           '###### '
      write(*,*) '       TRAJECTORY MODEL SUBROUTINE GRIDCHECK:'
      write(*,*) ' CAN NOT OPEN INPUT DATA FILE '//wfname(ifn)
      write(*,*) ' ###########################################'//
     &           '###### '
      error=.true.

      return
      end

      subroutine orolininterpol(yy,nxmax,nymax,nx,ny,xt,yt,yint)
C                               i    i     i   i  i  i  i   o
*****************************************************************************
*                                                                           *
*  Interpolation of meteorological fields on 2-d model layers.              *
*  A bilinear interpolation interpolation is used.                          *
*                                                                           *
*                                                                           *
*     Author: A. Stohl                                                      *
*                                                                           *
*     30 May 1994                                                           *
*                                                                           *
*****************************************************************************
*                                                                           *
* Variables:                                                                *
*                                                                           *
* height(nzmax)        heights of the model levels                          *
* ix,jy                x,y coordinates of lower left subgrid point          *
* nx,ny                actual field dimensions in x,y and z direction       *
* nxmax,nymax,nzmax    maximum field dimensions in x,y and z direction      *
* xt                   current x coordinate                                 *
* yint                 the final interpolated value                         *
* yt                   current y coordinate                                 *
* yy(0:nxmax-1,0:nymax-1) meteorological field used for interpolation       *
* zt                   current z coordinate                                 *
*                                                                           *
*****************************************************************************

      implicit none

      integer nx,ny,nxmax,nymax,ix,jy,ixp,jyp
      real yy(0:nxmax-1,0:nymax-1)
      real ddx,ddy,rddx,rddy
      real xt,yt,yint
     


C If point at border of grid -> small displacement into grid
************************************************************

      if (xt.ge.float(nx-1)) xt=float(nx-1)-0.00001
      if (yt.ge.float(ny-1)) yt=float(ny-1)-0.00001



***********************************************************************
C 1.) Bilinear horizontal interpolation
C This has to be done separately for 2 fields (Temporal)
********************************************************

C Determine the lower left corner and its distance to the current position
************************************************************************** 

      ix=int(xt)
      jy=int(yt)
      ixp=ix+1
      jyp=jy+1
      ddx=xt-float(ix)
      ddy=yt-float(jy)
      rddx=1.-ddx
      rddy=1.-ddy
     

C Loop over 2 time steps
************************
 
      yint=rddx*rddy*yy(ix ,jy )
     +    + ddx*rddy*yy(ixp,jy )
     +    +rddx* ddy*yy(ix ,jyp)
     +    + ddx* ddy*yy(ixp,jyp)



      return
      end

      subroutine gridcheck_nests(error)
C                                  o
********************************************************************************
*                                                                              *
*     This routine checks the grid specification for the nested model domains. *
*     It is similar to subroutine gridcheck, which checks the mother domain.   *
*                                                                              *
*     Authors: A. Stohl, G. Wotawa                                             *
*                                                                              *
*     30 December 1998                                                         *
********************************************************************************

      include 'includepar'
      include 'includecom'

      logical error

      if (numbnests.ne.0)
     +    stop 'FLEXTRA GFS cannot be operated with nested windfields'

      end

      subroutine interisentrop(xt,yt,zt,thetaconst,indexf,itime,init,
     +firststep,iter,lkindz,ngrid,uint,vint)
C                              i  i  i/o    i/o      i     i    i
C         i      i     i      i    o    o
********************************************************************************
*                                                                              *
*     Interpolation routine for isentropic trajectories.                       *
*                                                                              *
* The user gives the vertical coordinate in metres. In the first time step of  *
* the trajectory, metres are transformed to Kelvin. In all time steps these    *
* Kelvin are kept constant and transformed onward to the eta coordinate.       *
*                                                                              *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     27 April 1994                                                            *
*                                                                              *
*     Update: 23 December 1998 (Use of global domain and nesting)              *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* firststep          .true. for first step of petterssen, .false. for iteration*
* idiff [s]          Temporal distance between the windfields used for interpol*
* indz1,indz2        indices of boundary of unstable region                    *
* init               .true. for first time step of trajectory, .false. for othe*
* iter               number of iteration step                                  *
* itime [s]          current temporal position                                 *
* lkindz             unit of z coordinate (1:masl, 2:magl, 3:hPa)              *
* memtime(3) [s]     times of the wind fields in memory                        *
* ngrid              index which grid is to be used                            *
* nstop              =greater 0, if trajectory calculation is finished         *
* psint [Pa]         interpolated surface pressure                             *
* temp [K]           temperature at trajectory position                        *
* thetaconst [Pa]    theta level, for which trajectories shall be calculated   *
* uint,vint [m/s]    interpolated wind components                              *
* uvheight           heights in which u,v and t are given                      *
* xt,yt,zt           coordinates position for which wind data shall be calculat*
*                                                                              *
* Constants:                                                                   *
* kappa              exponent for calculating potential temperature            *
*                                                                              *
* Function:                                                                    *
* pp                 calculates the pressure at a given eta level              *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer itime,indexf,iter,indz1,indz2,i,lkindz,ngrid
      real xt,yt,zt,uint,vint,psint,thetaconst,phelp,pp,xtn,ytn
      real weight,uhelp,vhelp,qhelp,ph1,ph2,eta
      logical init,firststep

      indz1=0
      indz2=0

C Determine nested grid coordinates
***********************************

      if (ngrid.gt.0) then
        xtn=(xt-xln(ngrid))*xresoln(ngrid)
        ytn=(yt-yln(ngrid))*yresoln(ngrid)
      endif

C Calculate the surface pressure.
*********************************

      if (ngrid.gt.0) then         ! nested grid
        call levlininterpoln(psn,maxnests,nxmaxn,nymaxn,1,ngrid,nxn,nyn,
     +  memind,xtn,ytn,1,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,psint)
      else                         ! mother grid
        call levlininterpol(ps,nxmax,nymax,1,nx,ny,memind,xt,yt,
     +  1,memtime(indexf),memtime(indexf+1),itime,indexf,psint)
      endif


******************************************************************************
C For a new trajectory and the first iteration of petterssen:
C thetaconst is given in [m]
C 1. Transformation from height in [m] coordinate to height in eta coordinate.
C    Or: Transformation from hPa to eta.
C 2. Transformation from height in eta to height in theta [K] coordinate.
******************************************************************************

      if (init.and.firststep) then
        if ((lkindz.eq.1).or.(lkindz.eq.2)) then
          if (ngrid.gt.0) then       ! nested grid
            call etatrafo(xtn,ytn,thetaconst,memtime(indexf),
     +      memtime(indexf+1),itime,indexf,ngrid,psint)
          else                       ! mother grid
            call etatrafo(xt,yt,thetaconst,memtime(indexf),
     +      memtime(indexf+1),itime,indexf,ngrid,psint)
          endif
          zt=thetaconst              ! now thetaconst is given in eta
        else if (lkindz.eq.3) then
          zt=eta(psint,zt)
        endif

C Calculate pressure and potential temperature for current position
*******************************************************************

        phelp=pp(psint,zt)
        if (ngrid.gt.0) then       ! nested grid
          call lininterpoln(thn,maxnests,nxmaxn,nymaxn,nuvzmax,
     +    ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +    memtime(indexf+1),itime,indexf,thetaconst)
        else                       ! mother grid
          call lininterpol(th,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +    uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +    indexf,thetaconst)
        endif
      else

********************************************************************************
C For all other time steps:
C Transformation from height in theta [K] coordinate to height in eta coordinate
********************************************************************************

        if (ngrid.gt.0) then       ! nested grid
          call geteta(xtn,ytn,zt,thetaconst,memtime(indexf),
     +    memtime(indexf+1),itime,indexf,psint,ngrid,indz1,indz2)
        else                       ! mother grid
          call geteta(xt,yt,zt,thetaconst,memtime(indexf),
     +    memtime(indexf+1),itime,indexf,psint,ngrid,indz1,indz2)
        endif
      endif


C Interpolation of wind field data is done.
*****************************************************************************

      if (indz1.eq.indz2) then         ! stable level
      if (ngrid.eq.0) then          ! mother grid
      if ((inpolkind.eq.1).and.(iter.ne.1)) then
        call interpol(uu,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,uvheight,
     +  xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,indexf,uint)
        call interpol(vv,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,uvheight,
     +  xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,indexf,vint)
      else                               ! bilinear interpolation
        call lininterpol(uu,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,uint)
        call lininterpol(vv,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,vint)
      endif

      else if (ngrid.gt.0) then      ! nested grid

        if ((inpolkind.eq.1).and.(iter.ne.1)) then
        call interpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,uint)
        call interpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,vint)
        else                               ! bilinear interpolation
        call lininterpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,uint)
        call lininterpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,vint)
        endif

      else                          ! polar stereographic grid
                                    ! only linear interpolation used
        call lininterpol(uupol,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,uint)
        call lininterpol(vvpol,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,vint)
      endif

      else                             ! unstable layer

C -> take the layer averaged wind velocity (weighted with pressure increments)
******************************************************************************

        weight=0.
        uhelp=0.
        vhelp=0.
        qhelp=0.
        ph1=akz(indz1)+bkz(indz1)*psint

        do 10 i=indz1,indz2-1
          if (ngrid.ge.0) then          ! mother grid
          if ((inpolkind.eq.1).and.(iter.ne.1)) then
            call levinterpol(uu,nxmax,nymax,nuvzmax,nx,ny,memind,
     +      xt,yt,i,memtime(indexf),memtime(indexf+1),itime,indexf,
     +      uint)
            call levinterpol(vv,nxmax,nymax,nuvzmax,nx,ny,memind,
     +      xt,yt,i,memtime(indexf),memtime(indexf+1),itime,indexf,
     +      vint)
          else                               ! bilinear interpolation
            call levlininterpol(uu,nxmax,nymax,nuvzmax,nx,ny,memind,
     +      xt,yt,i,memtime(indexf),memtime(indexf+1),itime,indexf,
     +      uint)
            call levlininterpol(vv,nxmax,nymax,nuvzmax,nx,ny,memind,
     +      xt,yt,i,memtime(indexf),memtime(indexf+1),itime,indexf,
     +      vint)
          endif

          else if (ngrid.gt.0) then      ! nested grid

            if ((inpolkind.eq.1).and.(iter.ne.1)) then
          call levinterpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,i,memtime(indexf),memtime(indexf+1),
     +    itime,indexf,uint)
          call levinterpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,i,memtime(indexf),memtime(indexf+1),
     +    itime,indexf,vint)
            else                               ! linear interpolation
          call levlininterpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,i,memtime(indexf),memtime(indexf+1),
     +    itime,indexf,uint)
          call levlininterpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,i,memtime(indexf),memtime(indexf+1),
     +    itime,indexf,vint)
            endif

          else                          ! polar stereographic grid
                                        ! only linear interpolation used
            call levlininterpol(uupol,nxmax,nymax,nuvzmax,nx,ny,memind,
     +      xt,yt,i,memtime(indexf),memtime(indexf+1),itime,indexf,
     +      uint)
            call levlininterpol(vvpol,nxmax,nymax,nuvzmax,nx,ny,memind,
     +      xt,yt,i,memtime(indexf),memtime(indexf+1),itime,indexf,
     +      vint)
          endif
          ph2=akm(i+1)+bkm(i+1)*psint
          weight=weight+ph1-ph2
          uhelp=uhelp+uint*(ph1-ph2)
          vhelp=vhelp+vint*(ph1-ph2)
10        ph1=ph2

        if (ngrid.ge.0) then          ! mother grid
        if ((inpolkind.eq.1).and.(iter.ne.1)) then
          call levinterpol(uu,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,indz2,memtime(indexf),memtime(indexf+1),itime,indexf,
     +    uint)
          call levinterpol(vv,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,indz2,memtime(indexf),memtime(indexf+1),itime,indexf,
     +    vint)
        else                               ! bilinear interpolation
          call levlininterpol(uu,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,indz2,memtime(indexf),memtime(indexf+1),itime,indexf,
     +    uint)
          call levlininterpol(vv,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,indz2,memtime(indexf),memtime(indexf+1),itime,indexf,
     +    vint)
        endif

        else if (ngrid.gt.0) then      ! nested grid

          if ((inpolkind.eq.1).and.(iter.ne.1)) then
          call levinterpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,indz2,memtime(indexf),
     +    memtime(indexf+1),itime,indexf,uint)
          call levinterpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,indz2,memtime(indexf),
     +    memtime(indexf+1),itime,indexf,vint)
          else                               ! linear interpolation
          call levlininterpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,indz2,memtime(indexf),
     +    memtime(indexf+1),itime,indexf,uint)
          call levlininterpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,indz2,memtime(indexf),
     +    memtime(indexf+1),itime,indexf,vint)
          endif

        else                          ! polar stereographic grid
          call levlininterpol(uupol,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,indz2,memtime(indexf),memtime(indexf+1),itime,indexf,
     +    uint)
          call levlininterpol(vvpol,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,indz2,memtime(indexf),memtime(indexf+1),itime,indexf,
     +    vint)
        endif

        ph2=akz(indz2)+bkz(indz2)*psint
        weight=weight+ph1-ph2
        uhelp=uhelp+uint*(ph1-ph2)
        vhelp=vhelp+vint*(ph1-ph2)

        uint=uhelp/weight
        vint=vhelp/weight
      endif


      return
      end

      subroutine readoro(error)
C                          o
********************************************************************************
*                                                                              *
*     This routine reads the orography used by the ECMWF model.                *
*                                                                              *
*     Authors: A. Stohl                                                        *
*                                                                              *
*     30 April 1994                                                            *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* error                .true., if file OROGRAPHY cannot be opened              *
* nx,ny                number of grid points in x and y direction, respectively*
* oro(0:nxmax-1,0:nymax-1) [m]  orography of ECMWF model                       *
*                                                                              *
* Constants:                                                                   *
* unitoro              unit connected to file OROGRAPHY                        *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer ix,jy
      logical error


      error=.false.

C Open the orography file and read grid
***************************************

      write(*,*) 'NOTICE: OROGRAPHY WAS READ FROM FILE "OROGRAPHY"'


      open(unitoro,file=path(3)(1:len(3))//'OROGRAPHY',
     +status='old',err=999)
      do 10 ix=0,nx-1
        do 10 jy=0,ny-1
10        read(unitoro,*) oro(ix,jy)
      close(unitoro)

      return    

999   write(*,*) ' #### FLEXTRA MODEL ERROR! FILE "OROGRAPHY"   #### ' 
      write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
      write(*,*) ' #### xxx/trajec/windfields                   #### '
      error=.true.

      return
      end

      subroutine readflight(error)
C                             o
***********************************************************************
*                                                                     * 
*             TRAJECTORY MODEL SUBROUTINE READCET                     *
*                                                                     *
***********************************************************************
*                                                                     * 
*             AUTHOR:      A. STOHL                                   *
*             DATE:        1999-02-01                                 *
*                                                                     * 
* Update: Vertical coordinate can now be given in meters above sea    * 
* level, meters above ground, and in hPa.                             * 
*                                                                     * 
***********************************************************************
*                                                                     *
* DESCRIPTION:                                                        *
*                                                                     *
* READING OF TRAJECTORY STARTING/ENDING POINTS FROM DATA FILE         *
*                                                                     * 
* LINE                  a line of text                                * 
* NUMPOINT              number of trajectory starting/ending points   *
* XPOINT(maxpoint)      x-coordinates of starting/ending points       *
* YPOINT(maxpoint)      y-coordinates of starting/ending points       *
* ZPOINT(maxpoint)      z-coordinates of starting/ending points       *
* KINDZ(maxpoint)       kind of z coordinate (1:masl, 2:magl, 3:hPa)  *
* KIND(maxpoint)        kind of trajectory                            *
* COMPOINT(maxpoint)    comment for trajectory output                 *
*                                                                     *
***********************************************************************
*
      include 'includepar'
      include 'includecom'

      logical error
      integer ldat,ltim
      double precision juldate

      error=.false.

* Open file 'STARTFLIGHT'
*************************

      open(unitpoin,file=path(1)(1:len(1))//'STARTFLIGHT',
     +status='old',err=999)

      call skplin(27,unitpoin)
      read(unitpoin,'(a)',err=998,end=998) compoint(1)(1:40)
      read(unitpoin,*,err=998,end=998) kind(1)
      read(unitpoin,*,err=998,end=998) kindz(1)
      call skplin(1,unitpoin)

C Read the first starting point
*******************************

      read(unitpoin,*,err=998,end=998) ldat,ltim
      read(unitpoin,*,err=998,end=998) xpoint(1)
      read(unitpoin,*,err=998,end=998) ypoint(1)
      read(unitpoin,*,err=998,end=998) zpoint(1)
      call skplin(1,unitpoin)
      nextflight=nint(sngl(juldate(ldat,ltim)-bdate)*86400.)
      if (kindz(1).eq.3) zpoint(1)=zpoint(1)*100.

      numpoint=1

  
C Forbid mixing layer trajectories
**********************************

      if (kind(1).eq.3) then
        write(*,*) '### Mixing layer trajectories not allowed ###'
        write(*,*) '### for FLIGHT calculations. Select a     ###'
        write(*,*) '### different trajectory type!            ###'
        error=.true.
        return
      endif

      return

998   error=.true.
         write(*,*) '#### TRAJECTORY MODEL SUBROUTINE READFLIGHT: '//
     &              '#### '
         write(*,*) '#### FATAL ERROR - FILE "STARTFLIGHT" IS     '//
     &              '#### '
         write(*,*) '#### CORRUPT. PLEASE CHECK YOUR INPUTS FOR   '//
     &              '#### '
         write(*,*) '#### MISTAKES OR GET A NEW "STARTPOINTS"-    '//
     &              '#### '
         write(*,*) '#### FILE ...                                '//
     &              '#### '
      return

999   error=.true.
      write(*,*)  
      write(*,*) ' ###########################################'//
     &           '###### '
      write(*,*) '    TRAJECTORY MODEL SUBROUTINE READFLIGHT:'
      write(*,*)
      write(*,*) ' FATAL ERROR - FILE STARTFLIGHT IS NOT AVAILABLE'
      write(*,*) ' OR YOU ARE NOT PERMITTED FOR ANY ACCESS'
      write(*,*) ' ###########################################'//
     &           '###### '

      return
      end

      subroutine getheight(itime,xt,yt,zt,pt,ht)
***********************************************************************
*                                                                     * 
*             TRAJECTORY MODEL SUBROUTINE GETHEIGHT                   *
*                                                                     *
***********************************************************************
*                                                                     * 
*             AUTHOR:      G. WOTAWA                                  *
*             DATE:        1994-04-07                                 *
*             Adaptation to Nesting: A. Stohl, 1999-01-07             * 
*             More efficient determination of wind field index,       * 
*             A. Stohl, 2000-01-30                                    * 
***********************************************************************
*                                                                     *
* DESCRIPTION: This subroutine calculates pressure [Pa] and geometric *
*              height [m] along trajectory for a given vertical       *
*              coordinate zt (eta ECMWF) on a given position (xt,yt). *
*                                                                     *
***********************************************************************
*                                                                     *
* INPUT:                                                              *
*                                                                     *
* itime     time relative to beginning of calculation period          *
* xt        x coordinate of point [grid units]                        *
* yt        y coordinate of point [grid units]                        *
* zt        z coordinate of point [units]                             *
*                                                                     *
***********************************************************************
*                                                                     *
* OUTPUT:                                                             *
*                                                                     *
* pt        pressure [Pa]                                             *
* ht        geometric height [m]                                      *
*                                                                     *
***********************************************************************
*
      include 'includepar'
      include 'includecom'

      integer itime,indexf,j,ngrid

      real pp,xt,yt,zt,pt,ht,psint,xtn,ytn


C  Determine the times of the wind fields needed for interpolation
******************************************************************

      if ((ldirect*memtime(1).lt.ldirect*itime).and.
     +(ldirect*memtime(2).ge.ldirect*itime)) then ! between 1st and 2nd
        indexf=1
      else if((ldirect*memtime(2).lt.ldirect*itime).and.
     +(ldirect*memtime(3).ge.ldirect*itime)) then ! between 2nd and 3rd
        indexf=2
      endif


C Determine which nesting level to be used
******************************************

      ngrid=0
      do 12 j=numbnests,1,-1
        if ((xt.gt.xln(j)).and.(xt.lt.xrn(j)).and.
     +  (yt.gt.yln(j)).and.(yt.lt.yrn(j))) then
          ngrid=j
          goto 13
        endif
12      continue
13    continue

      if (ngrid.eq.0) then
        xtn=xt
        ytn=yt
        call levlininterpol(ps,nxmax,nymax,1,nx,ny,memind,
     +  xt,yt,1,memtime(indexf),memtime(indexf+1),itime,indexf,psint)
      else
        xtn=(xt-xln(ngrid))*xresoln(ngrid)
        ytn=(yt-yln(ngrid))*yresoln(ngrid)
        call levlininterpoln(psn,maxnests,nxmaxn,nymaxn,1,ngrid,
     +  nxn,nyn,memind,xtn,ytn,1,memtime(indexf),memtime(indexf+1),
     +  itime,indexf,psint)
      endif

      pt=pp(psint,zt)

      call zztrafo(ngrid,xtn,ytn,zt,memtime(indexf),memtime(indexf+1),
     +itime,indexf,psint,ht)

      return
      end

      subroutine inter3d(xt,yt,zt,indexf,itime,init,firststep,
     +iter,lkindz,ngrid,uint,vint,dzdt,indwz)
C                        i  i  i    i     i    i       i
C      i     i      i    o    o    o     o
********************************************************************************
*                                                                              *
*     Interpolation routine for 3-dimensional trajectories.                    *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     27 April 1994                                                            *
*                                                                              *
*     Update: 23 December 1998 (Use of global domain and nesting)              *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* dzdt               wind components in grid units per second                  *
* firstep            .true. for first iteration of petterssen                  *
* idiff [s]          Temporal distance between the windfields used for interpol*
* indwz              index of the model layer beneath current position of traj.*
* init               .true. for first time step of trajectory                  *
* iter               number of time iteration step                             *
* itime [s]          current temporal position                                 *
* memtime(3) [s]     times for the wind fields in memory                       *
* ngrid              index which grid is to be used                            *
* nstop              =greater 0, if trajectory calculation is finished         *
* uint,vint,wint [m/s] interpolated wind components                            *
* xt,yt,zt           coordinates position for which wind data shall be calculat*
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer i,itime,indexf,indwz,iter,lkindz,ngrid
      real xt,yt,zt,dzdt,uint,vint,wint,psint,eta,xtn,ytn
      logical firststep,init


C Determine nested grid coordinates
***********************************

      if (ngrid.gt.0) then
        xtn=(xt-xln(ngrid))*xresoln(ngrid)
        ytn=(yt-yln(ngrid))*yresoln(ngrid)
      endif

C Calculate the surface pressure.
*********************************

      if (ngrid.gt.0) then         ! nested grid
        call levlininterpoln(psn,maxnests,nxmaxn,nymaxn,1,ngrid,nxn,nyn,
     +  memind,xtn,ytn,1,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,psint)
      else                         ! mother grid
        call levlininterpol(ps,nxmax,nymax,1,nx,ny,memind,xt,yt,
     +  1,memtime(indexf),memtime(indexf+1),itime,indexf,psint)
      endif


C For a new trajectory and the first iteration of petterssen:
C Transformation from height in [m] coordinate to height in eta coordinate.
C Or: transformation from height in [Pa] to height in eta coordinate.
***************************************************************************

      if (init.and.firststep) then
        if ((lkindz.eq.1).or.(lkindz.eq.2)) then
          if (ngrid.gt.0) then       ! nested grid
            call etatrafo(xtn,ytn,zt,memtime(indexf),memtime(indexf+1),
     +      itime,indexf,ngrid,psint)
          else                       ! mother grid
            call etatrafo(xt,yt,zt,memtime(indexf),memtime(indexf+1),
     +      itime,indexf,ngrid,psint)
          endif
        else if (lkindz.eq.3) then
          zt=eta(psint,zt)
        endif
      endif


C Calculate index of (w) layers between the trajectory point is situated.
C Trajectory point is located between wheight(indwz) and wheight(indwz+1)
*************************************************************************

      do 95 i=2,nwz
        if (wheight(i).ge.zt) goto 96
95      continue
96    indwz=i-1



C Interpolation of wind field data is done.
C Either linear interpolation (if selected and for first iteration
C of petterssen) or bicubic interpolation
*******************************************

      if (ngrid.eq.0) then           ! mother grid
        if ((inpolkind.eq.1).and.(iter.ne.1)) then
        call interpol(uu,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,uvheight,
     +  xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,indexf,uint)
        call interpol(vv,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,uvheight,
     +  xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,indexf,vint)
        call interpol(ww,nxmax,nymax,nwzmax,nx,ny,nwz,memind,wheight,
     +  xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,indexf,wint)
        else                               ! bilinear interpolation
        call lininterpol(uu,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,uint)
        call lininterpol(vv,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,vint)
        call lininterpol(ww,nxmax,nymax,nwzmax,nx,ny,nwz,memind,
     +  wheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,wint)
        endif

      else if (ngrid.gt.0) then      ! nested grid

        if ((inpolkind.eq.1).and.(iter.ne.1)) then
        call interpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,uint)
        call interpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,vint)
        call interpoln(wwn,maxnests,nxmaxn,nymaxn,nwzmax,
     +  ngrid,nxn,nyn,nwz,memind,wheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,wint)

        else                               ! bilinear interpolation
        call lininterpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,uint)
        call lininterpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,vint)
        call lininterpoln(wwn,maxnests,nxmaxn,nymaxn,nwzmax,
     +  ngrid,nxn,nyn,nwz,memind,wheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,wint)
        endif

      else                           ! polar stereographic grid
                                     ! only linear interpolation used

        call lininterpol(uupol,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,uint)
        call lininterpol(vvpol,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,vint)
        call lininterpol(ww,nxmax,nymax,nwzmax,nx,ny,nwz,memind,
     +  wheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,wint)
      endif


      call wtransform(wint,psint,zt,indwz,dzdt)
      
      return
      end

      subroutine lastprocessor()
********************************************************************************
*                                                                              *
*   Back trajectories are produced in the wrong temporal direction by the      *
*   trajectory model. This means the first trajectory is the last one in the   *
*   file and the last one is the first one.                                    *
*   This routine reverses the direction so that the first date is also first   *
*   in the file.                                                               *
*                                                                              *
*   Author: A. Stohl                                                           *
*                                                                              *
*   8 April 1994                                                               *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* data(maximum)       data content of file                                     *
* header              header of file                                           *
* inter               index, if trajectory is interpolated or not              *
* last,numbmax        help variables                                           *
* numpoint            number of starting positions = number of output files    *
*                                                                              *
* Constants:                                                                   *
* maximum             maximum number of lines the procedure can handle         *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer maximum,numbmax,last,i,j,k
      parameter(maximum=50000)
      character header(98)*70,data(maximum)*80



C First: original trajectories (flexible time step)
*************************************************** 

      if ((inter.eq.0).or.(inter.eq.2)) then

C Reverse direction only for back trajectories.
C Read whole output file and store it in memory.
************************************************

      if (ldirect.eq.-1) then
        do 10 i=1,numpoint               ! loop over all starting points=files
          rewind(unittraj+i)
          do 20 j=1,42+4*numbnests
20          read(unittraj+i,'(a)') header(j)
          do 30 j=1,maximum
30          read(unittraj+i,'(a)',end=35) data(j)

35        numbmax=j-1


C If content of file exceeds available memory, don't reverse file
*****************************************************************

          if (numbmax.eq.maximum) then
            k=index(compoint(i),' ')-1
            k=min(k,7)                        
            write(*,*) '!!! Warning !!!  The content of file:'
            if (compoint(i)(41:41).ne.'U') then     ! no uncertainty trajectory
              write(*,*) 'T_'//compoint(i)(1:k)
            else
              write(*,*) 'T_'//compoint(i)(1:k)//'_U'//compoint(i)
     +        (42:45)
            endif
            write(*,*) 'is too long for postprocessing.'
            write(*,*) 'Please use manual postprocessor!'
            write(*,*)
            goto 10
          endif

C Rewind file and write it new with reversed direction
******************************************************

          rewind(unittraj+i)
          do 40 j=1,42+4*numbnests
40          write(unittraj+i,'(a)') header(j)
          last=numbmax
          do 50 j=numbmax,1,-1
            if (data(j)(1:1).eq.'D') then
              write(unittraj+i,'(a)') data(j)
              do 60 k=j+1,last
60              write(unittraj+i,'(a)') data(k)
              last=j-1
            endif
50          continue
10        continue

      endif

C Close output files
********************

      do 70 i=1,numpoint
70      close(unittraj+i)
      endif



C Second: interpolated trajectories (constant time step)
********************************************************

      if (inter.ge.1) then

C Reverse direction only for back trajectories.
C Read whole output file and store it in memory.
************************************************

      if (ldirect.eq.-1) then
        do 110 i=1,numpoint               ! loop over all starting points=files
          rewind(unittraji+i)
          do 120 j=1,42+4*numbnests
120         read(unittraji+i,'(a)') header(j)
          do 130 j=1,maximum
130         read(unittraji+i,'(a)',end=135) data(j)

135       numbmax=j-1


C If content of file exceeds available memory, don't reverse file
*****************************************************************

          if (numbmax.eq.maximum) then
            k=index(compoint(i),' ')-1
            k=min(k,7)                        
            write(*,*) '!!! Warning !!!  The content of file:'
            if (compoint(i)(41:41).ne.'U') then     ! no uncertainty trajectory
              write(*,*) 'TI_'//compoint(i)(1:k)
            else
              write(*,*) 'TI_'//compoint(i)(1:k)//'_U'//compoint(i)
     +        (42:45)
            endif
            write(*,*) 'is too long for postprocessing.'
            write(*,*) 'Please use manual postprocessor!'
            write(*,*)
            goto 110
          endif


C Rewind file and write it new with reversed direction
******************************************************

          rewind(unittraji+i)
          do 140 j=1,42+4*numbnests
140         write(unittraji+i,'(a)') header(j)
          last=numbmax
          do 150 j=numbmax,1,-1
            if (data(j)(1:1).eq.'D') then
              write(unittraji+i,'(a)') data(j)
              do 160 k=j+1,last
160             write(unittraji+i,'(a)') data(k)
              last=j-1
            endif
150         continue
110       continue

      endif


C Close output files and go for a coffee
****************************************

      do 170 i=1,numpoint
170     close(unittraji+i)
      endif



      return
      end

      subroutine petters(minstep,nt,itime,xold,yold,zold,pold,hold,
     +qqold,pvold,thold,xnew,ynew,znew,pnew,hnew,qqnew,pvnew,thnew,
     +ntstep,nstop,levconst,init,lkind,lkindz,unc,trerroru,
     +trerrorv,trerrorw)
C                           i    i    i    i    i    i    o    o
C       o      o    o    o    o    o    o    o     o     o     o
C       o      o      i      i     i     i     i     o
C        o        o
********************************************************************************
*                                                                              *
*  Calculation of trajectories utilizing the Petterssen scheme.                *
*  The time step is determined by the Courant-Friedrichs-Lewy (CFL) criterion. *
*  This means that the time step must be so small that the displacement within *
*  this time step is smaller than 1 grid distance. Additionally, a temporal    *
*  CFL criterion is introduced: the time step must be smaller than the time    *
*  interval of the wind fields used for interpolation.                         *
*  The CFL criterion is only used for the initialization of the iteration      *
*  scheme. Within the Petterssen iteration scheme this time step is not        *
*  corrected, but kept constant.                                               *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     1 February 1994                                                          *
*                                                                              *
*     Update: 16 February 1997: limitation of the estimated truncation error   *
*                                                                              *
*     Update: 29 July 1998: use of global data                                 *
*                                                                              *
*  Literature:                                                                 *
*  Petterssen (1940): Weather Analysis and Forecasting. McGraw-Hill Book       *
*                     Company, Inc.                                            *
*  Seibert P. (1993): Convergence and Accuracy of Numerical Methods for        *
*                     Trajectory Calculation. J. Appl. Met. 32, 558-566.       *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* corr               correlation coefficient of random errors                  *
* epsu,epsv,epsw     magnitude of random errors for uncertainty trajecories    *
* idiff [s]          Temporal distance between the windfields used for interpol*
* init               .true. for first time step of trajectory                  *
* indwz              index of the model layer beneath current position of traj.*
* itermax            maximum number of iterations used in the integration schem*
* itime [s]          current temporal position                                 *
* ldirect            Temporal direction of trajectories (-1=backward,1=forward)*
* levconst           height of trajectory in Pa, m or K depending on type of t.*
* lkind              kind of trajectory (e.g. isobaric, 3-dimensional)         *
* lkindz             unit of z coordinate (1:masl, 2:magl, 3:hPa)              *
* minstep [s]        minimum possible time step=not to exceed dimension maxtime*
* ngrid              index which grid is to be used                            *
* nstop              =greater 0, if trajectory calculation is finished         *
* nt [s]             Current age of trajectory                                 *
* ntstep             final time step of trajectory calculation                 *
* ntstep1            time step determined by horizontal CFL-criterion          *
* ntstep2            time step determined by vertical CFL-criterion            *
* ntstep3            time step determined by temporal CFL-criterion            *
* pnew,hnew          height at next time steps position in pressure and z coor *
* pold,hold          height at current time steps position in p and z coordina *
* pvold,pvnew [Ks-1Pa-1] potential vorticity at old and new position           *
* qqold,qqnew        specific humidity at old and new position                 *
* thold,thnew        potential temperature at old and new position             *
* trerroru, trerrorv, trerrorw   memory of random errors added at last timestep*
* unew,vnew,wnew     Wind components at next time steps position of trajectory *
* uold,vold,wold     Wind components at current position of trajectory         *
* vvmax              maximum of u and v, help variable                         *
* wheight(nwzmax)    Heights of the model layers for w component               *
* xhelp,yhelp,zhelp  help variables                                            *
* xnew,ynew,znew     Next time step's spatial position of trajectory           *
* xold,yold,zold     Actual spatial position of trajectory                     *
* zdist              vertical grid distance at current position of trajectory  *
*                                                                              *
* Constants:                                                                   *
* cfl                factor, by which the time step has to be smaller than the *
*                    spatial CFL-criterion                                     *
* cflt               factor, by which the time step has to be smaller than the *
*                    temporal CFL-criterion                                    *
* deltahormax        maximum horizontal distance between two iterations        *
* deltavermax        maximum vertical distance between two iterations          *
* eps1               tiny number                                               *
* itermax            maximum number of iterations                              *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer i,j,nt,itime,nstop,idiff,indwz,ntstep,ntstep1,ntstep2
      integer ntstep3,minstep,lkind,lkindz,idummy,ngrid
      real xold,yold,zold,xnew,ynew,znew,xhelp,yhelp,zhelp,uint,vint
      real unew,vnew,wnew,uold,vold,wold,vvmax,zdist,levconst
      real pold,hold,pnew,hnew,pvold,pvnew,thold,thnew,qqold,qqnew
      real gasdev,xlon,ylat,xpol,ypol,gridsize
      real cgszll,xpolold,ypolold,corr,trerroru,trerrorv,trerrorw
      logical init,unc
      save idummy
      data idummy/-7/

      nstop=0
      ntstep=0

C Determine whether lat/long grid or polarstereographic projection
C is to be used
C Furthermore, determine which nesting level to be used
******************************************************************
c     write (*,*) 'petters',nglobal,yold,switchnorthg
      if (nglobal.and.(yold.gt.switchnorthg)) then
        ngrid=-1
      else if (sglobal.and.(yold.lt.switchsouthg)) then
        ngrid=-2
      else
        ngrid=0
        do 12 j=numbnests,1,-1
          if ((xold.gt.xln(j)).and.(xold.lt.xrn(j)).and.
     +    (yold.gt.yln(j)).and.(yold.lt.yrn(j))) then
            ngrid=j
            goto 13
          endif
12        continue
13      continue
      endif


C Get wind data at the current trajectory position
**************************************************

      call getwind(.true.,init,itime,levconst,xold,yold,zold,lkind,
     +lkindz,2,ngrid,uint,vint,wold,idiff,indwz,nstop)

      if (nstop.gt.1) return

C Transformation m/s --> grid units/time unit
*********************************************

      if (ngrid.ge.0) then          ! mother domain
        call utransform(uint,yold,uold)
        call vtransform(vint,vold)
      else if (ngrid.eq.-1) then    ! around north pole
        xlon=xlon0+xold*dx
        ylat=ylat0+yold*dy
        gridsize=1000.*cgszll(northpolemap,ylat,xlon)
        uold=uint/gridsize
        vold=vint/gridsize
      else if (ngrid.eq.-2) then    ! around south pole
        xlon=xlon0+xold*dx
        ylat=ylat0+yold*dy
        gridsize=1000.*cgszll(southpolemap,ylat,xlon)
        uold=uint/gridsize
        vold=vint/gridsize
      endif



C Calculate the time step determined by the CFL criterion
C Three independent CFL-criteria are used: 
C 1) In horizontal direction = displacement smaller than grid distance
C 2) In vertical direction = displacement smaller than grid distance
C 3) In temporal direction = distance between the 2 windfields used for interpol
C The final time step is the minimum of 1,2 and 3
********************************************************************************

      if (ngrid.lt.0) then
        ntstep1=999999
      else
      vvmax=max(abs(uold)*xresoln(ngrid),abs(vold)*yresoln(ngrid),eps1)
      ntstep1=int(min(1./vvmax/cfl,999999.))    ! 1
      endif

      if (lkind.eq.1) then
        zdist=wheight(indwz+1)-wheight(indwz)
        if (abs(wold).lt.eps1) wold=eps1
        ntstep2=int(min(zdist/abs(wold)/cfl,999999.)) ! 2
      else
        ntstep2=999999
      endif

      ntstep3=int(float(idiff)/cflt)                  ! 3

      ntstep=min(ntstep1,ntstep2,ntstep3)

      if (ntstep.lt.1) ntstep=1                       ! minimum step = 1 second


C Check, if such a short time step is possible. Under the assumption
C that all following time steps have the same length, check if this
C would lead to an exceedance of field dimensions. If this is the case
C increase the time step. However the time step cannot be greater than
C the time difference between 2 wind fields
**********************************************************************

      if ((inter.ne.1).and.(ntstep.lt.minstep)) then             
        ntstep=min(minstep,idiff)
        write(*,*) 'Warning: time step exceeds CFL-criterion!'
      endif

      if (ldirect.eq.-1) ntstep=-1*ntstep            ! backward t. -> negative


C If the last step of trajectory is reached, give nstop code 1
C Reduce the time step, so that trajectory ends exactly after lentra seconds
****************************************************************************

      if (abs(nt+ntstep).ge.abs(lentra)) then
        ntstep=ldirect*(abs(lentra-nt))
        nstop=1
      endif


C Calculate first guess position at time step nt+ntstep
*******************************************************

      if (ngrid.ge.0) then          ! mother domain
        xnew=xold+uold*float(ntstep)
        ynew=yold+vold*float(ntstep)
      else if (ngrid.eq.-1) then    ! around north pole
        call cll2xy(northpolemap,ylat,xlon,xpolold,ypolold)
        xpol=xpolold+uold*float(ntstep)
        ypol=ypolold+vold*float(ntstep)
        call cxy2ll(northpolemap,xpol,ypol,ylat,xlon)
        xnew=(xlon-xlon0)/dx
        ynew=(ylat-ylat0)/dy
      else if (ngrid.eq.-2) then    ! around south pole
        call cll2xy(southpolemap,ylat,xlon,xpolold,ypolold)
        xpol=xpolold+uold*float(ntstep)
        ypol=ypolold+vold*float(ntstep)
        call cxy2ll(southpolemap,xpol,ypol,ylat,xlon)
        xnew=(xlon-xlon0)/dx
        ynew=(ylat-ylat0)/dy
      endif
      if(lkind.eq.1) then
        znew=zold+wold*float(ntstep)
      else
        znew=zold
      endif


C Check position: If trajectory outside model domain, terminate it
******************************************************************

      if (znew.gt.heightmax) znew=heightmax
      if (znew.lt.heightmin) znew=heightmin


C If global data are available, use cyclic boundary condition
*************************************************************

      if (xglobal) then
        if (xnew.gt.float(nx-1)) xnew=xnew-float(nx-1)
        if (xnew.lt.0.) xnew=xnew+float(nx-1)
      endif


      if ((xnew.lt.0.).or.(xnew.gt.float(nx-1)).or.(ynew.lt.0.).or.
     +(ynew.gt.float(ny-1))) then
        nstop=2
        return
      endif


C Iteration. A maximum of itermax iterations is allowed. Iteration is
C terminated, when distance between two iterations is less than the maximum
C allowable distance deltadistmax
***************************************************************************

      do 10 i=1,itermax
        xhelp=xnew
        yhelp=ynew
        zhelp=znew

C Check whether position is within a nest
*****************************************

        if (ngrid.ge.0) then
          ngrid=0
          do 22 j=numbnests,1,-1
            if ((xnew.gt.xln(j)).and.(xnew.lt.xrn(j)).and.
     +      (ynew.gt.yln(j)).and.(ynew.lt.yrn(j))) then
              ngrid=j
              goto 23
            endif
22          continue
23        continue
        endif

C Get wind data at trajectory position at time step nt+ntstep
*************************************************************

        call getwind(.false.,init,itime+ntstep,levconst,xnew,ynew,
     +  znew,lkind,lkindz,i,ngrid,uint,vint,wnew,idiff,indwz,nstop)

        if (nstop.gt.1) return

C Transformation m/s --> grid units/time unit and advection
***********************************************************

        if (ngrid.ge.0) then
          call utransform(uint,ynew,unew)
          call vtransform(vint,vnew)
          xnew=xold+(uold+unew)*float(ntstep)/2.
          ynew=yold+(vold+vnew)*float(ntstep)/2.
        else if (ngrid.eq.-1) then    ! around north pole
          xlon=xlon0+xnew*dx
          ylat=ylat0+ynew*dy
          gridsize=1000.*cgszll(northpolemap,ylat,xlon)
          unew=uint/gridsize
          vnew=vint/gridsize
          xpol=xpolold+(uold+unew)*float(ntstep)/2.
          ypol=ypolold+(vold+vnew)*float(ntstep)/2.
          call cxy2ll(northpolemap,xpol,ypol,ylat,xlon)
          xnew=(xlon-xlon0)/dx
          ynew=(ylat-ylat0)/dy
        else if (ngrid.eq.-2) then    ! around south pole
          xlon=xlon0+xnew*dx
          ylat=ylat0+ynew*dy
          gridsize=1000.*cgszll(southpolemap,ylat,xlon)
          unew=uint/gridsize
          vnew=vint/gridsize
          xpol=xpolold+(uold+unew)*float(ntstep)/2.
          ypol=ypolold+(vold+vnew)*float(ntstep)/2.
          call cxy2ll(southpolemap,xpol,ypol,ylat,xlon)
          xnew=(xlon-xlon0)/dx
          ynew=(ylat-ylat0)/dy
        endif

        if(lkind.eq.1) then
          znew=zold+(wold+wnew)*float(ntstep)/2.
        endif

C Check position: If trajectory outside model domain, terminate it
******************************************************************

        if (znew.gt.heightmax) znew=heightmax
        if (znew.lt.heightmin) znew=heightmin


C If global data are available, use cyclic boundary condition
*************************************************************

        if (xglobal) then
          if (xnew.gt.float(nx-1)) xnew=xnew-float(nx-1)
          if (xnew.lt.0.) xnew=xnew+float(nx-1)
        endif


        if ((xnew.lt.0.).or.(xnew.gt.float(nx-1)).or.(ynew.lt.0.).or.
     +  (ynew.gt.float(ny-1))) then
          nstop=2
          return
        endif



C If the distance between two iterations is less than the maximum allowable
C one (in vertical and horizontal direction), leave the loop.
***************************************************************************

        if (lkind.eq.1) then
          if ((sqrt((xhelp-xnew)*(xhelp-xnew)+(yhelp-ynew)*(yhelp-ynew))      
     +    .lt.deltahormax).and.
     +    (abs(zhelp-znew).lt.deltavermax*zdist)) goto 20
        else
          if (sqrt((xhelp-xnew)*(xhelp-xnew)+(yhelp-ynew)*(yhelp-ynew))      
     +    .lt.deltahormax) goto 20
        endif

10      continue

20    continue


C Calculate random displacement for uncertainty trajectories
C using a Langevin equation
C For this, an autocorrelation of wind errors is calculated.
C This is not done near the poles!
************************************************************

      if (unc.and.(ngrid.ge.0)) then
        corr=exp(-1./(relaxtime*max(cfl,cflt)))
        trerroru=corr*trerroru+gasdev(idummy)*epsu*sqrt(1.-corr**2)
        xnew=xnew+trerroru*(uold+unew)*float(ntstep)/2.
        trerrorv=corr*trerrorv+gasdev(idummy)*epsv*sqrt(1.-corr**2)
        ynew=ynew+trerrorv*(vold+vnew)*float(ntstep)/2.
        trerrorw=corr*trerrorw+gasdev(idummy)*epsw*sqrt(1.-corr**2)
        znew=znew+trerrorw*(wold+wnew)*float(ntstep)/2.
        if (xglobal) then
          if (xnew.gt.float(nx-1)) xnew=xnew-float(nx-1)
          if (xnew.lt.0.) xnew=xnew+float(nx-1)
        endif
        if ((xnew.lt.0.).or.(xnew.gt.float(nx-1)).or.(ynew.lt.0.).or.
     +  (ynew.gt.float(ny-1))) then
          nstop=2
          return
        endif
        if (znew.gt.heightmax) znew=heightmax
        if (znew.lt.heightmin) znew=heightmin
      endif



C Calculate vertical position of trajectory in pressure and z coordinates.
C Interpolate also additional meteo data (PV, THETA, Spec. Hum.) to
C trajectory position.
C This is always done for the new positions, only for the first position
C of the trajectory it is necessary to calculate the old positions.
*************************************************************************
       
      if (init) then
        call getheight(itime,xold,yold,zold,pold,hold)
        call getmet(itime,xold,yold,zold,qqold,pvold,thold)
      endif
      call getheight(itime+ntstep,xnew,ynew,znew,pnew,hnew)
      call getmet(itime+ntstep,xnew,ynew,znew,qqnew,pvnew,thnew)

      return
      end

      subroutine readcet(error)
C                          o
***********************************************************************
*                                                                     * 
*             TRAJECTORY MODEL SUBROUTINE READCET                     *
*                                                                     *
***********************************************************************
*                                                                     * 
*             AUTHOR:      A. STOHL                                   *
*             DATE:        1999-01-11                                 *
*                                                                     * 
* Update: Vertical coordinate can now be given in meters above sea    * 
* level, meters above ground, and in hPa.                             * 
*                                                                     * 
***********************************************************************
*                                                                     *
* DESCRIPTION:                                                        *
*                                                                     *
* READING OF TRAJECTORY STARTING/ENDING POINTS FROM DATA FILE         *
*                                                                     * 
* LINE                  a line of text                                * 
* NUMPOINT              number of trajectory starting/ending points   *
* XPOINT(maxpoint)      x-coordinates of starting/ending points       *
* YPOINT(maxpoint)      y-coordinates of starting/ending points       *
* ZPOINT(maxpoint)      z-coordinates of starting/ending points       *
* KINDZ(maxpoint)       kind of z coordinate (1:masl, 2:magl, 3:hPa)  *
* KIND(maxpoint)        kind of trajectory                            *
* COMPOINT(maxpoint)    comment for trajectory output                 *
*                                                                     *
***********************************************************************
*
      include 'includepar'
      include 'includecom'

      integer isum
      logical error,old
      integer kindhelp,kindzhelp
      real xhelpleft,xhelpright,yhelpleft,yhelpright,deltax
      real deltay,zhelplower,zhelpupper,deltaz,xi,yj,zk
      character*45 comhelp,line

      error=.false.
*
* OPENING OF FILE 'STARTCET'
*

      open(unitpoin,file=path(1)(1:len(1))//'STARTCET',
     +status='old',err=999)

C Check the format of the STARTCET file (either in free format,
C or using formatted mask)
C Use of formatted mask is assumed if line 28 contains the word '____'
**********************************************************************

      call skplin(27,unitpoin)
      read (unitpoin,901) line
901   format (a)
      if (index(line,'____') .eq. 0) then
        old = .false.
      else
        old = .true.
      endif
      rewind(unitpoin)

*
* READING OF STARTING/ENDING POINTS OF TRAJECTORIES
*
      call skplin(26,unitpoin)

      read(unitpoin,*,err=998,end=998) xhelpleft
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=998) yhelpleft
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=998) xhelpright
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=998) yhelpright
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=998) deltax    
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=998) deltay    
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=998) kindhelp
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=998) kindzhelp
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=998) zhelplower
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=998) zhelpupper
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=998) deltaz
      if (old) call skplin(2,unitpoin)
      if (old) then
        read(unitpoin,'(a40)',err=998,end=998) comhelp(1:40)
      else
        read(unitpoin,*,err=998,end=998) comhelp(1:40)
      endif
      if (old) call skplin(1,unitpoin)
      close(unitpoin)
1     format(1x,a17,i6,a28)


      if (zhelpupper.lt.zhelplower) stop 'Upper level must be greater 
     +than lower level'


C Forbid mixing layer trajectories
**********************************

      if (kindhelp.eq.3) then
        write(*,*) '### Mixing layer trajectories not allowed ###'
        write(*,*) '### for CET calculations. Select a        ###'
        write(*,*) '### different trajectory type!            ###'
        error=.true.
        return
      endif


C Check field dimension
***********************

      isum=int(((xhelpright-xhelpleft)/deltax+1.)*((yhelpright-
     +yhelpleft)/deltay+1.)*(abs(zhelpupper-zhelplower)/deltaz +1.))


      if (isum.gt.maxtra) then
        write(*,*) ' #### TRAJECTORY MODEL ERROR! MODEL CAN NOT   #### ' 
        write(*,*) ' #### KEEP SO MANY TRAJECTORIES IN MEMORY.    #### '
        write(*,1) ' #### CURRENTLY: ',isum,'                     ####
     + '
        write(*,1) ' #### MAXIMUM:   ',maxtra,'                     ####
     + '
        write(*,*) ' #### REDUCE CET DOMAIN OR RESOLUTION.        #### '
        error=.true.
      endif


C Initialize CET starting points
********************************

      isum=0
      do 10 xi=xhelpleft,xhelpright,deltax
        do 10 yj=yhelpleft,yhelpright,deltay
          do 10 zk=zhelplower,zhelpupper,deltaz
            isum=isum+1
            xpoint(isum)=xi
            ypoint(isum)=yj
            kind(isum)=kindhelp
            kindz(isum)=kindzhelp
            zpoint(isum)=zk
            compoint(isum)(1:40)=comhelp(1:40)

C Conversion from hPa to Pa, if z coordinate is given in pressure units
            if (kindz(isum).eq.3) zpoint(isum)=zpoint(isum)*100. 
10          continue

      numpoint=isum

      return

998   error=.true.
         write(*,*) '#### TRAJECTORY MODEL SUBROUTINE READCET:    '//
     &              '#### '
         write(*,*) '#### FATAL ERROR - FILE "STARTCET" IS        '//
     &              '#### '
         write(*,*) '#### CORRUPT. PLEASE CHECK YOUR INPUTS FOR   '//
     &              '#### '
         write(*,*) '#### MISTAKES OR GET A NEW "STARTPOINTS"-    '//
     &              '#### '
         write(*,*) '#### FILE ...                                '//
     &              '#### '
      return

999   error=.true.
      write(*,*)  
      write(*,*) ' ###########################################'//
     &           '###### '
      write(*,*) '    TRAJECTORY MODEL SUBROUTINE READCET:'
      write(*,*)
      write(*,*) ' FATAL ERROR - FILE STARTCET IS NOT AVAILABLE'
      write(*,*) ' OR YOU ARE NOT PERMITTED FOR ANY ACCESS'
      write(*,*) ' ###########################################'//
     &           '###### '

      return
      end

      subroutine interisobar(xt,yt,zt,pconst,indexf,itime,init,
     +firststep,iter,lkindz,ngrid,uint,vint)
C                            i  i  i/o  i      i      i    i
C         i      i     i      i    o    o
********************************************************************************
*                                                                              *
*     Interpolation routine for isobaric trajectories.                         *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     27 April 1994                                                            *
*                                                                              *
*     Update: 23 December 1998 (Use of global domain and nesting)              *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* eta                eta coordinate of pressure level                          *
* firststep          .true. for first iteration of petterssen                  *
* idiff [s]          Temporal distance between the windfields used for interpol*
* init               .true. for first time step of trajectory                  *
* iter               number of iteration step                                  *
* itime [s]          current temporal position                                 *
* lkindz             unit of z coordinate (1:masl, 2:magl, 3:hPa)              *
* memtime(3) [s]     times of the wind fields in memory                        *
* ngrid              index which grid is to be used                            *

* nstop              =greater 0, if trajectory calculation is finished         *
* pconst [Pa]        pressure level, for which trajectories shall be calculated*
* uint,vint [m/s]    interpolated wind components                              *
* xt,yt,zt           coordinates position for which wind data shall be calculat*
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer itime,indexf,iter,lkindz,ngrid
      real xt,yt,zt,uint,vint,psint,eta,pconst,pp,xtn,ytn
      logical init,firststep


C Determine nested grid coordinates
***********************************

      if (ngrid.gt.0) then
        xtn=(xt-xln(ngrid))*xresoln(ngrid)
        ytn=(yt-yln(ngrid))*yresoln(ngrid)
      endif


C For a new trajectory and the first iteration of petterssen:
C Transformation from height in [m] coordinate to height in eta coordinate.
C Or: Transformation from hPa to eta.
C For this it is necessary to know the surface pressure.
***************************************************************************

      if (init.and.firststep) then
C Calculate the surface pressure.
*********************************

        if (ngrid.gt.0) then        ! nested grid
          call levlininterpoln(psn,maxnests,nxmaxn,nymaxn,1,ngrid,
     +    nxn,nyn,memind,xtn,ytn,1,memtime(indexf),memtime(indexf+1),
     +    itime,indexf,psint)
        else                        ! mother grid
          call levlininterpol(ps,nxmax,nymax,1,nx,ny,memind,xt,yt,
     +    1,memtime(indexf),memtime(indexf+1),itime,indexf,psint)
        endif

        if ((lkindz.eq.1).or.(lkindz.eq.2)) then
          if (ngrid.gt.0) then      ! nested grid
            call etatrafo(xtn,ytn,zt,memtime(indexf),memtime(indexf+1),
     +      itime,indexf,ngrid,psint)
          else                      ! mother grid
            call etatrafo(xt,yt,zt,memtime(indexf),memtime(indexf+1),
     +      itime,indexf,ngrid,psint)
          endif
          pconst=pp(psint,zt)
        else if (lkindz.eq.3) then
          zt=eta(psint,zt)
        endif
      endif


C Transformation from height in pressure coordinate to height in eta coordinate.
C For this it is necessary to know the surface pressure.
*********************************************************************************

      if (ngrid.gt.0) then
        call levlininterpoln(psn,maxnests,nxmaxn,nymaxn,1,ngrid,
     +  nxn,nyn,memind,xtn,ytn,1,memtime(indexf),memtime(indexf+1),
     +  itime,indexf,psint)
      else
        call levlininterpol(ps,nxmax,nymax,1,nx,ny,memind,xt,yt,
     +  1,memtime(indexf),memtime(indexf+1),itime,indexf,psint)
      endif
      zt=eta(psint,pconst)


C Interpolation of wind field data is done.
*****************************************************************************

      if (ngrid.eq.0) then            ! mother grid
        if ((inpolkind.eq.1).and.(iter.ne.1)) then
        call interpol(uu,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,uvheight,
     +  xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,indexf,uint)
        call interpol(vv,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,uvheight,
     +  xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,indexf,vint)
        else                               ! bilinear interpolation
        call lininterpol(uu,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,uint)
        call lininterpol(vv,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,vint)
        endif

      else if (ngrid.gt.0) then      ! nested grid

        if ((inpolkind.eq.1).and.(iter.ne.1)) then
        call interpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,uint)
        call interpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,vint)
        else                               ! bilinear interpolation
        call lininterpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,uint)
        call lininterpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,vint)
        endif

      else                            ! polar stereographic grid

        call lininterpol(uupol,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,uint)
        call lininterpol(vvpol,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,vint)
      endif

      return
      end

      subroutine zztrafo(ngrid,xt,yt,zt,itime1,itime2,itime,indexf,
     +psint,ht)
***********************************************************************
*                                                                     *
*             TRAJECTORY MODEL SUBROUTINE ZZTRAFO                     *
*                                                                     *
***********************************************************************
*                                                                     *
*             AUTHOR:      G. WOTAWA                                  *
*             DATE:        1994-04-07                                 *
*             LAST UPDATE: 1999-01-07 Adaptation to nesting           *
*                                                                     *
***********************************************************************
*                                                                     *
* DESCRIPTION: This subroutine transforms the vertical coordinate     *
*              eta (ECMWF) to geometric height [m] above model        *
*              orography (relative height)                            *
*              Method: vertical integration of hydrostatic equation   *
*                                                                     *
* REMARK: For the calculation of geometric height, the virtual        *
*         temperature difference has been neglected. The gas constant *
*         for dry air has been used.                                  *
*                                                                     *
***********************************************************************
*                                                                     *
* INPUT:                                                              *
*                                                                     *
* ngrid                      number of nesting level to be used       *
* xt                         x-coordinate of point [grid units]       *
* yt                         y-coordinate of point [grid units]       *
* zt                         z-coordinate of point [eta (ECMWF)]      *
* itime1                     time [s] of first windfield              *
* itime2                     time [s] of second windfield             *
* itime                      time [s] of calculation                  *
* indexf                     time index of field xx                   *
* psint                      surface pressure at point (xt,yt) [Pa]   *
*                                                                     *
***********************************************************************
*                                                                     *
* OUTPUT:                                                             *
*                                                                     *
* ht                         geometric height [m]                     *
*                                                                     *
***********************************************************************
*
      include 'includepar'
      include 'includecom'

      integer itime1,itime2,itime,indexf,i,k,ngrid
      real xt,yt,zt,ht,psint,fract,pp1,pp2,tv
  
      real tlev(nuvzmax)
      real zzlev1,zzlev2

      do 10 k=2,nwz
         if(zt.le.wheight(k)) goto 20
10    continue
      k=nwz
20    fract=(zt-wheight(k-1))/(wheight(k)-wheight(k-1))
*
* calculate interpolated vertical temperature profile on model levels
*
      do 30 i=1,k-1
        if (ngrid.gt.0) then
          call levlininterpoln(ttn,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xt,yt,i,itime1,itime2,itime,indexf,tlev(i))
        else
          call levlininterpol(tt,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,i,itime1,itime2,itime,indexf,tlev(i))
        endif
30      continue
*
* calculate layer indices between which zt is situated
*
      zzlev1=0
      do 40 i=2,k-1
        pp1=akm(i-1)+bkm(i-1)*psint
        pp2=akm(i)+bkm(i)*psint
        tv=tlev(i-1)
40      zzlev1=zzlev1+r_air/ga*log(pp1/pp2)*tv
      pp1=akm(k-1)+bkm(k-1)*psint
      pp2=akm(k)  +bkm(k)*psint
      tv=tlev(k-1)
      zzlev2=zzlev1+r_air/ga*log(pp1/pp2)*tv

      ht=zzlev1*(1.-fract)+zzlev2*fract
      return
      end

      subroutine readwind(indj,n)
***********************************************************************
*                                                                     * 
*             TRAJECTORY MODEL SUBROUTINE READWIND                    *
*                                                                     *
***********************************************************************
*                                                                     * 
*             AUTHOR:      G. WOTAWA                                  *
*             DATE:        1997-08-05                                 *
*             LAST UPDATE: ----------                                 *
*             Update:      1998-07-29, global fields allowed          *
*             A. Stohl, G. Wotawa                                     *
*             Update:      2001-01-05 NCEP Data Pressure levels       * 
*                                                                     * 
***********************************************************************
*                                                                     *
* DESCRIPTION:                                                        *
*                                                                     *
* READING OF ECMWF METEOROLOGICAL FIELDS FROM INPUT DATA FILES. THE   *
* INPUT DATA FILES ARE EXPECTED TO BE AVAILABLE IN GRIB CODE          *
*                                                                     *
* INPUT:                                                              *
* indj               indicates number of the wind field to be read in *
* n                  temporal index for meteorological fields (1 to 3)*
*                                                                     *
* IMPORTANT VARIABLES FROM COMMON BLOCK:                              *
*                                                                     *
* wfname             File name of data to be read in                  *
* nxfield,ny,nuvz,nwz     expected field dimensions                   *
* nlev_ec            number of vertical levels ecmwf model            *
* uu,vv,ww           wind fields                                      *
* tt,qq              temperature and specific humidity                *
* ps                 surface pressure                                 *
*                                                                     *
***********************************************************************

      include 'includepar'
      include 'includecom'
      include 'grib_api_f77.h'

      integer ii,indj,i,j,k,n,ifield,iumax
      integer ix,jy,induvz,indwz,numpt,numpu,numpv,numpw,numprh
      real help,temp,plev,ew,elev

* VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

C dimension of isec2 at least (22+n), where n is the number of parallels or
C meridians in a quasi-regular (reduced) Gaussian or lat/long grid

C dimension of zsec2 at least (10+nn), where nn is the number of vertical
C coordinate parameters

      integer isec1(56),isec2(22+nxmax+nymax)
      real zsec4(jpunp)
      real xaux,yaux,xaux0,yaux0
      real ylat,xlon,wdummy,ffpol,ddpol,xlonr
      real uuaux,vvaux,uupolaux,vvpolaux

      logical error

!     parameters for grib_api 
      integer ifile
      integer iret
      integer igrib
      integer*4 isize
      integer gribVer,parCat,parNum,typSurf,valSurf
      real*8 zsecn4(jpunp*4) 
      real*8 xauxin,yauxin

      integer i179,i180,i181

      iumax=0
*
* OPENING OF DATA FILE (GRIB CODE)
*
*
* OPENING OF DATA FILE (GRIB CODE)
*
!HSO
!     print*,'reading winds from ',path(3)(1:len(3))
!    >//trim(wfname(indj)),'|'
5     iret=grib_open_file(ifile,path(3)(1:len(3))
     >//trim(wfname(indj)),'r')
      call grib_check(iret)
!     turn on support for multi fields messages
      call grib_check(grib_multi_support_on())


      numpt=0
      numpu=0
      numpv=0
      numpw=0
      numprh=0
      ifield=0
10    ifield=ifield+1
*
* GET NEXT FIELDS
*

      iret=grib_new_from_file(ifile,igrib)      
      if (igrib .eq. -1 )  then         
        if (iret .ne. -1) then
          call grib_check(iret)
          goto 888   ! ERROR DETECTED
        endif
        goto 50    ! EOF DETECTED
      endif

!     first see if we read GRIB1 or GRIB2
      call grib_check(grib_get_int(  igrib,
     >'editionNumber',gribVer))

!     get the size and data of the values array
      call grib_check(grib_get_size(igrib,'values',isize))
      call grib_check(grib_get_real8_array(igrib,'values',zsecn4,isize))
      do  i=1,isize
        zsec4(i)=zsecn4(i)
      enddo

      if (gribVer.eq.1) then ! GRIB Edition 1

!     read the grib1 identifiers
      call grib_check(grib_get_int(  igrib,
     >'indicatorOfParameter',isec1(6)))
      call grib_check(grib_get_int(  igrib,
     >'indicatorOfTypeOfLevel',isec1(7)))
      call grib_check(grib_get_int(  igrib,
     >'level',isec1(8)))

      else ! GRIB Edition 2

!     read the grib2 identifiers
      call grib_check(grib_get_int(  igrib,
     >'parameterCategory',parCat))
      call grib_check(grib_get_int(  igrib,
     >'parameterNumber',parNum))
      call grib_check(grib_get_int(  igrib,
     >'typeOfFirstFixedSurface',typSurf))
      call grib_check(grib_get_int(  igrib,
     >'scaledValueOfFirstFixedSurface',valSurf))

!     convert to grib1 identifiers
      isec1(6)=-1
      isec1(7)=-1
      isec1(8)=-1
      if ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.100)) then ! T
        isec1(6)=11          ! indicatorOfParameter
        isec1(7)=100         ! indicatorOfTypeOfLevel
        isec1(8)=valSurf/100 ! level, convert to hPa
      elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.100)) then ! U
        isec1(6)=33          ! indicatorOfParameter
        isec1(7)=100         ! indicatorOfTypeOfLevel
        isec1(8)=valSurf/100 ! level, convert to hPa
      elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.100)) then ! V
        isec1(6)=34          ! indicatorOfParameter
        isec1(7)=100         ! indicatorOfTypeOfLevel
        isec1(8)=valSurf/100 ! level, convert to hPa
      elseif ((parCat.eq.2).and.(parNum.eq.8).and.(typSurf.eq.100)) then ! W
        isec1(6)=39          ! indicatorOfParameter
        isec1(7)=100         ! indicatorOfTypeOfLevel
        isec1(8)=valSurf/100 ! level, convert to hPa
      elseif ((parCat.eq.1).and.(parNum.eq.1).and.(typSurf.eq.100)) then ! RH
        isec1(6)=52          ! indicatorOfParameter
        isec1(7)=100         ! indicatorOfTypeOfLevel
        isec1(8)=valSurf/100 ! level, convert to hPa
      elseif ((parCat.eq.1).and.(parNum.eq.1).and.(typSurf.eq.103)) then ! RH2
        isec1(6)=52          ! indicatorOfParameter
        isec1(7)=105         ! indicatorOfTypeOfLevel
        isec1(8)=2
      elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.103)) then ! T2
        isec1(6)=11          ! indicatorOfParameter
        isec1(7)=105         ! indicatorOfTypeOfLevel
        isec1(8)=2
      elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.103)) then ! U10
        isec1(6)=33          ! indicatorOfParameter
        isec1(7)=105         ! indicatorOfTypeOfLevel
        isec1(8)=10
      elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.103)) then ! V10
        isec1(6)=34          ! indicatorOfParameter
        isec1(7)=105         ! indicatorOfTypeOfLevel
        isec1(8)=10
      elseif ((parCat.eq.3).and.(parNum.eq.1).and.(typSurf.eq.101)) then ! SLP
        isec1(6)=2           ! indicatorOfParameter
        isec1(7)=102         ! indicatorOfTypeOfLevel
        isec1(8)=0
      elseif ((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.1)) then ! SP
        isec1(6)=1           ! indicatorOfParameter
        isec1(7)=1           ! indicatorOfTypeOfLevel
        isec1(8)=0
      elseif ((parCat.eq.1).and.(parNum.eq.13).and.(typSurf.eq.1)) then ! SNOW
        isec1(6)=66          ! indicatorOfParameter
        isec1(7)=1           ! indicatorOfTypeOfLevel
        isec1(8)=0
      elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.104)) then ! T sigma 0
        isec1(6)=11          ! indicatorOfParameter
        isec1(7)=107         ! indicatorOfTypeOfLevel
        isec1(8)=0.995       ! lowest sigma level
      elseif ((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.104)) then ! U sigma 0
        isec1(6)=33          ! indicatorOfParameter
        isec1(7)=107         ! indicatorOfTypeOfLevel
        isec1(8)=0.995       ! lowest sigma level
      elseif ((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.104)) then ! V sigma 0
        isec1(6)=34          ! indicatorOfParameter
        isec1(7)=107         ! indicatorOfTypeOfLevel
        isec1(8)=0.995       ! lowest sigma level
      elseif ((parCat.eq.3).and.(parNum.eq.5).and.(typSurf.eq.1)) then ! TOPO 
        isec1(6)=7           ! indicatorOfParameter
        isec1(7)=1           ! indicatorOfTypeOfLevel
        isec1(8)=0
      elseif ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.1)) then ! LSM
        isec1(6)=81          ! indicatorOfParameter
        isec1(7)=1           ! indicatorOfTypeOfLevel
        isec1(8)=0
      elseif ((parCat.eq.3).and.(parNum.eq.196).and.(typSurf.eq.1)) then ! BLH
        isec1(6)=221         ! indicatorOfParameter
        isec1(7)=1           ! indicatorOfTypeOfLevel
        isec1(8)=0
      elseif ((parCat.eq.1).and.(parNum.eq.7).and.(typSurf.eq.1)) then ! LSP/TP
        isec1(6)=62          ! indicatorOfParameter
        isec1(7)=1           ! indicatorOfTypeOfLevel
        isec1(8)=0
      elseif ((parCat.eq.1).and.(parNum.eq.196).and.(typSurf.eq.1)) then ! CP
        isec1(6)=63          ! indicatorOfParameter
        isec1(7)=1           ! indicatorOfTypeOfLevel
        isec1(8)=0
      endif

      endif ! gribVer


C Check whether we are on a little endian or on a big endian computer
*********************************************************************

c     if (inbuff(1).eq.1112101447) then         ! little endian, swap bytes
c       iswap=1+ilen/4
c       call swap32(inbuff,iswap)
c     else if (inbuff(1).ne.1196575042) then    ! big endian
c       stop 'subroutine gridcheck: corrupt GRIB data'
c     endif

c     if (ierr.ne.0) goto 10    ! ERROR DETECTED

      if(ifield.eq.1) then

!     get the required fields from section 2 
!     store compatible to gribex input
      call grib_check(grib_get_int(  igrib,
     >'numberOfPointsAlongAParallel',isec2(2)))
      call grib_check(grib_get_int(  igrib,
     >'numberOfPointsAlongAMeridian',isec2(3)))
      call grib_check(grib_get_real8(igrib,
     >'longitudeOfFirstGridPointInDegrees',xauxin))
      call grib_check(grib_get_real8(igrib,
     >'latitudeOfLastGridPointInDegrees',yauxin))
      xaux=xauxin
      yaux=yauxin

* CHECK GRID SPECIFICATIONS

         if(isec2(2).ne.nxfield) stop 'READWIND: NX NOT CONSISTENT'
        if(isec2(3).ne.ny) stop 'READWIND: NY NOT CONSISTENT'
        if(xaux.eq.0.) xaux=-179.0     ! NCEP DATA
        xaux0=xlon0
        yaux0=ylat0
        if(xaux.lt.0.) xaux=xaux+360.
        if(yaux.lt.0.) yaux=yaux+360.
        if(xaux0.lt.0.) xaux0=xaux0+360.
        if(yaux0.lt.0.) yaux0=yaux0+360.
        if(abs(xaux-xaux0).gt.eps) 
     &    stop 'READWIND: LOWER LEFT LONGITUDE NOT CONSISTENT'
        if(abs(yaux-yaux0).gt.eps)
     &    stop 'READWIND: LOWER LEFT LATITUDE NOT CONSISTENT'
      endif
!HSO end of edits

      i179=nint(179./dx)
      i180=nint(179./dx)+1
      i181=i180+1

      do 20 j=0,ny-1
        do 20 i=0,nxfield-1

          if((isec1(6).eq.011).and.(isec1(7).eq.100)) then
* TEMPERATURE
           if((i.eq.0).and.(j.eq.0)) then
                do 21 ii=1,nuvz
                  if ((isec1(8)*100.0).eq.akz(ii)) numpt=ii
21              continue
            endif
            help=zsec4(nxfield*(ny-j-1)+i+1)
            if(i.le.i180) then
              tt(i179+i,j,numpt,n)=help
            else
              tt(i-i181,j,numpt,n)=help
            endif
          endif

          if((isec1(6).eq.033).and.(isec1(7).eq.100)) then
* U VELOCITY
             if((i.eq.0).and.(j.eq.0)) then
                do 22 ii=1,nuvz
                  if ((isec1(8)*100.0).eq.akz(ii)) numpu=ii
22              continue
            endif

            help=zsec4(nxfield*(ny-j-1)+i+1)
            if(i.le.i180) then
              uu(i179+i,j,numpu,n)=help
            else
              uu(i-i181,j,numpu,n)=help
            endif
          endif

          if((isec1(6).eq.034).and.(isec1(7).eq.100)) then
* V VELOCITY
             if((i.eq.0).and.(j.eq.0)) then
                do 23 ii=1,nuvz
                  if ((isec1(8)*100.0).eq.akz(ii)) numpv=ii
23              continue
            endif
            help=zsec4(nxfield*(ny-j-1)+i+1)
            if(i.le.i180) then
              vv(i179+i,j,numpv,n)=help
            else
              vv(i-i181,j,numpv,n)=help
            endif
          endif

          if((isec1(6).eq.039).and.(isec1(7).eq.100)) then
* W VELOCITY
             if((i.eq.0).and.(j.eq.0)) then
                do 25 ii=1,nuvz
                  if ((isec1(8)*100.0).eq.akz(ii)) numpw=ii
25              continue
            endif
            help=zsec4(nxfield*(ny-j-1)+i+1)
            if(i.le.i180) then
              ww(i179+i,j,numpw,n)=help
            else
              ww(i-i181,j,numpw,n)=help
            endif
          endif

          if((isec1(6).eq.052).and.(isec1(7).eq.100)) then
* RELATIVE HUMIDITY -> CONVERT TO SPECIFIC HUMIDITY
          if((i.eq.0).and.(j.eq.0)) then
                do 24 ii=1,nuvz
                  if ((isec1(8)*100.0).eq.akz(ii)) numprh=ii
24              continue
            endif
            help=zsec4(nxfield*(ny-j-1)+i+1)
            if(i.le.i180) then
              qq(i179+i,j,numprh,n)=help
            else
              qq(i-i181,j,numprh,n)=help
            endif
          endif

          if((isec1(6).eq.001).and.(isec1(7).eq.001)) then
* SURFACE PRESSURE
            help=zsec4(nxfield*(ny-j-1)+i+1)
            if(i.le.i180) then
              ps(i179+i,j,1,n)=help
            else
              ps(i-i181,j,1,n)=help
            endif
          endif

          if((isec1(6).eq.007).and.(isec1(7).eq.001)) then
* TOPOGRAPHY
            help=zsec4(nxfield*(ny-j-1)+i+1)
            if(i.le.i180) then
              oro(i179+i,j)=help
            else
              oro(i-i181,j)=help
            endif
          endif

20        continue

          if((isec1(6).eq.33).and.(isec1(7).eq.100)) iumax=iumax+1

      if (igrib.ne.-1) then
        call grib_check(grib_release(igrib)) 
      endif

      goto 10                      !! READ NEXT LEVEL OR PARAMETER

50    continue
*
* CLOSING OF INPUT DATA FILE
*
      call grib_check(grib_close_file(ifile))



* TRANSFORM RH TO SPECIFIC HUMIDITY AS NEEDED

      do 65 j=0,ny-1
        do 65 i=0,nxfield-1
          do 65 k=1,nuvz
            help=qq(i,j,k,n)
            temp=tt(i,j,k,n)
            plev=akm(k)
            elev=ew(temp)*help/100.0
            qq(i,j,k,n)=xmwml*(elev/(plev-((1.0-xmwml)*elev)))
65    continue

C For global fields, assign rightmost grid point the value of the
C leftmost point
*****************************************************************

      if (xglobal) then
        do 70 j=0,ny-1
          oro(nx-1,j)=oro(0,j)
          ps(nx-1,j,1,n)=ps(0,j,1,n)
          do 71 induvz=1,nuvz
            tt(nx-1,j,induvz,n)=tt(0,j,induvz,n)
            qq(nx-1,j,induvz,n)=qq(0,j,induvz,n)
            uu(nx-1,j,induvz,n)=uu(0,j,induvz,n)
71          vv(nx-1,j,induvz,n)=vv(0,j,induvz,n)
          do 70 indwz=1,nwz
70          ww(nx-1,j,indwz,n)=ww(0,j,indwz,n)
      endif


C If north pole is in the domain, calculate wind velocities in polar
C stereographic coordinates
********************************************************************

      if (nglobal) then
        do 74 jy=int(switchnorthg)-2,ny-1
          ylat=ylat0+float(jy)*dy
          do 74 ix=0,nx-1
            xlon=xlon0+float(ix)*dx
            do 74 induvz=1,nuvz
74            call cc2gll(northpolemap,ylat,xlon,uu(ix,jy,induvz,n),
     +        vv(ix,jy,induvz,n),uupol(ix,jy,induvz,n),
     +        vvpol(ix,jy,induvz,n))


        do 76 induvz=1,nuvz

* CALCULATE FFPOL, DDPOL FOR CENTRAL GRID POINT
          xlon=xlon0+float(nx/2-1)*dx
          xlonr=xlon*pi/180.
          ffpol=sqrt(uu(nx/2-1,ny-1,induvz,n)**2+
     &               vv(nx/2-1,ny-1,induvz,n)**2)
          if(vv(nx/2-1,ny-1,induvz,n).lt.0.) then
            if(vv(nx/2-1,ny-1,induvz,n).gt.-0.00001)
     &         vv(nx/2-1,ny-1,induvz,n)=-0.00001
            ddpol=atan(uu(nx/2-1,ny-1,induvz,n)/
     &                 vv(nx/2-1,ny-1,induvz,n))-xlonr
          else
            if(vv(nx/2-1,ny-1,induvz,n).lt. 0.00001)
     &         vv(nx/2-1,ny-1,induvz,n)= 0.00001
            ddpol=pi+atan(uu(nx/2-1,ny-1,induvz,n)/
     &                    vv(nx/2-1,ny-1,induvz,n))-xlonr
          endif
          if(ddpol.lt.0.) ddpol=2.0*pi+ddpol
          if(ddpol.gt.2.0*pi) ddpol=ddpol-2.0*pi

* CALCULATE U,V FOR 180 DEG, TRANSFORM TO POLAR STEREOGRAPHIC GRID
          xlon=180.0
          xlonr=xlon*pi/180.
          ylat=90.0
          uuaux=-ffpol*sin(xlonr+ddpol)
          vvaux=-ffpol*cos(xlonr+ddpol)
          call cc2gll(northpolemap,ylat,xlon,uuaux,vvaux,uupolaux,
     +      vvpolaux)

          jy=ny-1
          do 76 ix=0,nx-1
            uupol(ix,jy,induvz,n)=uupolaux
            vvpol(ix,jy,induvz,n)=vvpolaux
76      continue


* Fix: Set W at pole to the zonally averaged W of the next equator-
* ward parallel of latitude
 
      do 85 indwz=1,nwz
          wdummy=0.
          jy=ny-2
          do 80 ix=0,nx-1
80          wdummy=wdummy+ww(ix,jy,indwz,n)
          wdummy=wdummy/float(nx)
          jy=ny-1
          do 85 ix=0,nx-1
85          ww(ix,jy,indwz,n)=wdummy

      endif

C If south pole is in the domain, calculate wind velocities in polar
C stereographic coordinates
********************************************************************

      if (sglobal) then
        do 77 jy=0,int(switchsouthg)+3
          ylat=ylat0+float(jy)*dy
          do 77 ix=0,nx-1
            xlon=xlon0+float(ix)*dx
            do 77 induvz=1,nuvz
77            call cc2gll(southpolemap,ylat,xlon,uu(ix,jy,induvz,n),
     +        vv(ix,jy,induvz,n),uupol(ix,jy,induvz,n),
     +        vvpol(ix,jy,induvz,n))

        do 79 induvz=1,nuvz

* CALCULATE FFPOL, DDPOL FOR CENTRAL GRID POINT
          xlon=xlon0+float(nx/2-1)*dx
          xlonr=xlon*pi/180.
          ffpol=sqrt(uu(nx/2-1,0,induvz,n)**2+
     &               vv(nx/2-1,0,induvz,n)**2)
          if(vv(nx/2-1,0,induvz,n).lt.0.) then
            if(vv(nx/2-1,0,induvz,n).gt.-0.00001) 
     &        vv(nx/2-1,0,induvz,n)=-0.00001
            ddpol=atan(uu(nx/2-1,0,induvz,n)/
     &                 vv(nx/2-1,0,induvz,n))+xlonr
          else
            if(vv(nx/2-1,0,induvz,n).lt. 0.00001) 
     &        vv(nx/2-1,0,induvz,n)= 0.00001
            ddpol=pi+atan(uu(nx/2-1,0,induvz,n)/
     &                    vv(nx/2-1,0,induvz,n))+xlonr
          endif
          if(ddpol.lt.0.) ddpol=2.0*pi+ddpol
          if(ddpol.gt.2.0*pi) ddpol=ddpol-2.0*pi

* CALCULATE U,V FOR 180 DEG, TRANSFORM TO POLAR STEREOGRAPHIC GRID
          xlon=180.0
          xlonr=xlon*pi/180.
          ylat=-90.0
          uuaux=+ffpol*sin(xlonr-ddpol)
          vvaux=-ffpol*cos(xlonr-ddpol)
          call cc2gll(northpolemap,ylat,xlon,uuaux,vvaux,uupolaux,
     +      vvpolaux)

          jy=0
          do 79 ix=0,nx-1
            uupol(ix,jy,induvz,n)=uupolaux
79          vvpol(ix,jy,induvz,n)=vvpolaux


* Fix: Set W at pole to the zonally averaged W of the next equator-
* ward parallel of latitude
 
        do 95 indwz=1,nwz
          wdummy=0.
          jy=1
          do 90 ix=0,nx-1
90          wdummy=wdummy+ww(ix,jy,indwz,n)
          wdummy=wdummy/float(nx)
          jy=0
          do 95 ix=0,nx-1
95          ww(ix,jy,indwz,n)=wdummy
      endif

      WRITE(*,*) WFTIME(INDJ),' SEC ',WFTIME(INDJ)/3600,' HRS ',
     +WFTIME(INDJ)/3600/24,' DAYS  ', WFNAME(INDJ)
      if(iumax.ne.nuvz) stop 'READWIND: NUVZ NOT CONSISTENT'
      if(iumax.ne.nwz)  stop 'READWIND: NWZ NOT CONSISTENT'


C Calculate potential temperature and potential vorticity on whole grid
***********************************************************************

      call calcpv(n)


      return    
888   write(*,*) ' #### TRAJECTORY MODEL ERROR! WINDFIELD       #### ' 
      write(*,*) ' #### ',wfname(indj),'                    #### '
      write(*,*) ' #### IS NOT GRIB FORMAT !!!                  #### '
      stop 'Execution terminated'

999   write(*,*) ' #### TRAJECTORY MODEL ERROR! WINDFIELD       #### ' 
      write(*,*) ' #### ',wfname(indj),'                    #### '
      write(*,*) ' #### CANNOT BE OPENED !!!                    #### '
      error=1

      end

C  Taken from Press et al., Numerical Recipes

      FUNCTION RAN1(IDUM)
      INTEGER IDUM,IA,IM,IQ,IR,NTAB,NDIV
      REAL RAN1,AM,EPS,RNMX
      PARAMETER(IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,
     +NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2E-7,RNMX=1.-EPS)
      INTEGER J,K,IV(NTAB),IY
      SAVE IV,IY
      DATA IV/NTAB*0/,IY/0/
      IF (IDUM.LE.0.OR.IY.EQ.0) THEN
        IDUM=MAX(-IDUM,1)
        DO J=NTAB+8,1,-1
          K=IDUM/IQ
          IDUM=IA*(IDUM-K*IQ)-IR*K
          IF (IDUM.LT.0) IDUM=IDUM+IM
          IF (J.LE.NTAB) IV(J)=IDUM
        ENDDO
        IY=IV(1)
      ENDIF
      K=IDUM/IQ
      IDUM=IA*(IDUM-K*IQ)-IR*K
      IF (IDUM.LT.0) IDUM=IDUM+IM
      J=1+IY/NDIV
      IY=IV(J)
      IV(J)=IDUM
      RAN1=MIN(AM*IY,RNMX)
      RETURN
      END



      FUNCTION GASDEV(IDUM)
      INTEGER IDUM,ISET
      REAL GASDEV
      DATA ISET/0/
      SAVE ISET,GSET
      IF (ISET.EQ.0) THEN
1       V1=2.*RAN1(IDUM)-1.
        V2=2.*RAN1(IDUM)-1.
        R=V1**2+V2**2
        IF(R.GE.1.0 .OR. R.EQ.0.0) GO TO 1
        FAC=SQRT(-2.*LOG(R)/R)
        GSET=V1*FAC
        GASDEV=V2*FAC
        ISET=1
      ELSE
        GASDEV=GSET
        ISET=0
      ENDIF
      RETURN
      END

      subroutine readwind(indj,n)
***********************************************************************
*                                                                     *
*             TRAJECTORY MODEL SUBROUTINE READWIND                    *
*                                                                     *
***********************************************************************
*                                                                     *
*             AUTHOR:      G. WOTAWA                                  *
*             DATE:        1997-08-05                                 *
*             LAST UPDATE: ----------                                 *
*             Update:      1998-07-29, global fields allowed          *
*             A. Stohl, G. Wotawa                                     *
*                          2011-06, implemented reading of grib2 format*
*                                   analog to FLEXPART 8.22 routines  *
*                                                                     *
***********************************************************************
*                                                                     *
* DESCRIPTION:                                                        *
*                                                                     *
* READING OF ECMWF METEOROLOGICAL FIELDS FROM INPUT DATA FILES. THE   *
* INPUT DATA FILES ARE EXPECTED TO BE AVAILABLE IN GRIB CODE          *
*                                                                     *
* INPUT:                                                              *
* indj               indicates number of the wind field to be read in *
* n                  temporal index for meteorological fields (1 to 3)*
*                                                                     *
* IMPORTANT VARIABLES FROM COMMON BLOCK:                              *
*                                                                     *
* wfname             File name of data to be read in                  *
* nxfield,ny,nuvz,nwz     expected field dimensions                   *
* nlev_ec            number of vertical levels ecmwf model            *
* uu,vv,ww           wind fields                                      *
* tt,qq              temperature and specific humidity                *
* ps                 surface pressure                                 *
*                                                                     *
***********************************************************************

      use GRIB_API

      include 'includepar'
      include 'includecom'

!HSO  parameters for grib_api
      integer ifile
      integer iret
      integer igrib
      integer gribVer,parCat,parNum,typSurf,valSurf,discipl
      integer gotGrid
      character*24 gribErrorMsg
      character*20 gribFunction
!HSO  end

      integer indj,i,j,k,n,levdiff2,ifield,iumax,iwmax,lunit
      integer ix,jy,induvz,indwz

* VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

C dimension of isec2 at least (22+n), where n is the number of parallels or
C meridians in a quasi-regular (reduced) Gaussian or lat/long grid

C dimension of zsec2 at least (10+nn), where nn is the number of vertical
C coordinate parameters

      integer isec0(2),isec1(56),isec2(22+nxmax+nymax),isec3(2)
      integer isec4(64),inbuff(jpack),ilen,iswap,ierr,iword
      real*4 nsss(0:nxmax-1,0:nymax-1),ewss(0:nxmax-1,0:nymax-1)
      real zsec2(60+2*nuvzmax),zsec3(2),zsec4(jpunp)
      real xaux,yaux,xaux0,yaux0
      real*8 xauxin,yauxin
      real ylat,xlon,wdummy,ffpol,ddpol,xlonr
      real uuaux,vvaux,uupolaux,vvpolaux

      character*1 yoper,opt
      logical error

!HSO  grib api error messages
      data gribErrorMsg/'Error reading grib file'/
      data gribFunction/'readwind'/

      data yoper/'D'/

      levdiff2=nlev_ec-nwz+1
      iumax=0
      iwmax=0
*
* OPENING OF DATA FILE (GRIB CODE)
*

5     call grib_open_file(ifile,path(3)(1:len(3))
     >//trim(wfname(indj)),'r',iret)
      if (iret.ne.GRIB_SUCCESS) then
        goto 888   ! ERROR DETECTED
      endif

      gotGrid=0
      ifield=0
10    ifield=ifield+1
*
* GET NEXT FIELDS
*
      call grib_new_from_file(ifile,igrib,iret)
      if (iret.eq.GRIB_END_OF_FILE)  then
        goto 50    ! EOF DETECTED
      elseif (iret.ne.GRIB_SUCCESS) then
        goto 888   ! ERROR DETECTED
      endif

!     first see if we read GRIB1 or GRIB2
      call grib_get_int(igrib,'editionNumber',gribVer,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)

      if (gribVer.eq.1) then ! GRIB Edition 1
c     print*,'GRiB Edition 1'
c     read the grib2 identifiers
        call grib_get_int(igrib,'indicatorOfParameter',isec1(6),iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'level',isec1(8),iret)
        call grib_check(iret,gribFunction,gribErrorMsg)

c     change code for etadot to code for omega
        if (isec1(6).eq.77) then
          isec1(6)=135
        endif
      else
c     print*,'GRiB Edition 2'
c     read the grib2 identifiers
        call grib_get_int(igrib,'discipline',discipl,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'parameterCategory',parCat,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'parameterNumber',parNum,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'typeOfFirstFixedSurface',typSurf,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'level',valSurf,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
!     convert to grib1 identifiers
        isec1(6)=-1
        isec1(7)=-1
        isec1(8)=-1
        isec1(8)=valSurf     ! level
        if((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.105))then ! T
          isec1(6)=130         ! indicatorOfParameter
        elseif((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.105))then ! U
          isec1(6)=131         ! indicatorOfParameter
        elseif((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.105))then ! V
          isec1(6)=132         ! indicatorOfParameter
        elseif((parCat.eq.1).and.(parNum.eq.0).and.(typSurf.eq.105))then ! Q
          isec1(6)=133         ! indicatorOfParameter
        elseif((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.1))then !SP
          isec1(6)=134         ! indicatorOfParameter
        elseif((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually eta dot
          isec1(6)=135         ! indicatorOfParameter
        elseif((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101))then !SLP
          isec1(6)=151         ! indicatorOfParameter
        elseif((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.103))then ! 10U
          isec1(6)=165         ! indicatorOfParamete
        elseif((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.103))then ! 10V
          isec1(6)=166         ! indicatorOfParameter
        elseif((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.103))then ! 2T
          isec1(6)=167         ! indicatorOfParameter
        elseif((parCat.eq.0).and.(parNum.eq.6).and.(typSurf.eq.103))then ! 2D
          isec1(6)=168         ! indicatorOfParameter
        elseif((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1))then ! SD
          isec1(6)=141         ! indicatorOfParameter
        elseif((parCat.eq.6).and.(parNum.eq.1)) then ! CC
          isec1(6)=164         ! indicatorOfParameter
        elseif((parCat.eq.1).and.(parNum.eq.9)) then ! LSP
          isec1(6)=142         ! indicatorOfParameter
        elseif((parCat.eq.1).and.(parNum.eq.10)) then ! CP
          isec1(6)=143         ! indicatorOfParameter
        elseif((parCat.eq.0).and.(parNum.eq.11).and.(typSurf.eq.1))then ! SHF
          isec1(6)=146         ! indicatorOfParameter
        elseif((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1))then ! SR
          isec1(6)=176         ! indicatorOfParameter
        elseif((parCat.eq.2).and.(parNum.eq.17)) then ! EWSS
          isec1(6)=180         ! indicatorOfParameter
        elseif((parCat.eq.2).and.(parNum.eq.18)) then ! NSSS
          isec1(6)=181         ! indicatorOfParameter
        elseif((parCat.eq.3).and.(parNum.eq.4)) then ! ORO
          isec1(6)=129         ! indicatorOfParameter
        elseif((parCat.eq.3).and.(parNum.eq.7)) then ! SDO
          isec1(6)=160         ! indicatorOfParameter
        elseif((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and.
     +   (typSurf.eq.1)) then ! LSM
          isec1(6)=172         ! indicatorOfParameter
        else
          print*,'***ERROR: undefined GRiB2 message found!',discipl,
     +     parCat,parNum,typSurf
        endif
      endif

!HSO  get the size and data of the values array
      if (isec1(6).ne.-1) then
        call grib_get_real4_array(igrib,'values',zsec4,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
      endif

!HSO  get the required fields from section 2 in a gribex compatible manner
      if (ifield.eq.1) then
        call grib_get_int(igrib,'numberOfPointsAlongAParallel',
     +       isec2(2),iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'numberOfPointsAlongAMeridian',
     +       isec2(3),iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'numberOfVerticalCoordinateValues',
     +     isec2(12))
        call grib_check(iret,gribFunction,gribErrorMsg)
* CHECK GRID SPECIFICATIONS
        if(isec2(2).ne.nxfield) stop 'READWIND: NX NOT CONSISTENT'
        if(isec2(3).ne.ny) stop 'READWIND: NY NOT CONSISTENT'
        if(isec2(12)/2-1.ne.nlev_ec)
     +    stop 'READWIND: VERTICAL DISCRETIZATION NOT CONSISTENT'
      endif ! ifield

!HSO  get the second part of the grid dimensions only from GRiB1 messages
      if ((gribVer.eq.1).and.(gotGrid.eq.0)) then
        call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees',
     >     xauxin,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees',
     >     yauxin,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        xaux=xauxin
        yaux=yauxin
        xaux0=xlon0
        yaux0=ylat0
        if(xaux.lt.0.) xaux=xaux+360.
        if(yaux.lt.0.) yaux=yaux+360.
        if(xaux0.lt.0.) xaux0=xaux0+360.
        if(yaux0.lt.0.) yaux0=yaux0+360.
        if(abs(xaux-xaux0).gt.eps)
     &    stop 'READWIND: LOWER LEFT LONGITUDE NOT CONSISTENT'
        if(abs(yaux-yaux0).gt.eps)
     &    stop 'READWIND: LOWER LEFT LATITUDE NOT CONSISTENT'
        gotGrid=1
      endif ! gotGrid

      do 20 j=0,ny-1
        do 20 i=0,nxfield-1
          k=isec1(8)
          if(isec1(6).eq.130) tt(i,j,nlev_ec-k+1,n)=    !! TEMPERATURE
     &                        zsec4(nxfield*(ny-j-1)+i+1)
          if(isec1(6).eq.131) uu(i,j,nlev_ec-k+1,n)=    !! U VELOCITY
     &                        zsec4(nxfield*(ny-j-1)+i+1)
          if(isec1(6).eq.132) vv(i,j,nlev_ec-k+1,n)=    !! V VELOCITY
     &                        zsec4(nxfield*(ny-j-1)+i+1)
          if(isec1(6).eq.133) then
            qq(i,j,nlev_ec-k+1,n)=                      !! SPEC. HUMIDITY
     &                        zsec4(nxfield*(ny-j-1)+i+1)
            if (qq(i,j,nlev_ec-k+1,n).lt.0.) qq(i,j,nlev_ec-k+1,n)=0.
c             this is necessary because the gridded data may contain
c             spurious negative values
          endif
          if(isec1(6).eq.134) ps(i,j,1,n)=              !! SURF. PRESS.
     &                        zsec4(nxfield*(ny-j-1)+i+1)
          if(isec1(6).eq.135) ww(i,j,nlev_ec-k+1,n)=    !! W VELOCITY
     &                        zsec4(nxfield*(ny-j-1)+i+1)
          if(isec1(6).eq.129) oro(i,j)=                 !! ECMWF OROGRAPHY
     &                        zsec4(nxfield*(ny-j-1)+i+1)/ga
          if(isec1(6).eq.131) iumax=max(iumax,nlev_ec-k+1)
          if(isec1(6).eq.135) iwmax=max(iwmax,nlev_ec-k+1)

20        continue

      call grib_release(igrib)
      goto 10                      !! READ NEXT LEVEL OR PARAMETER
*
* CLOSING OF INPUT DATA FILE
*
50    call grib_close_file(ifile)

*     error message if no fields found with correct first longitude in it
      if (gotGrid.eq.0) then
        print*,'***ERROR: input file needs to contain GRiB1 formatted'//
     &'messages'
        stop
      endif

      if(levdiff2.eq.0) then
        iwmax=nlev_ec+1
        do 60 j=0,ny-1
          do 60 i=0,nx-1
60          ww(i,j,nlev_ec+1,n)=0.
      endif


C For global fields, assign rightmost grid point the value of the
C leftmost point
*****************************************************************

      if (xglobal) then
        do 70 j=0,ny-1
          oro(nx-1,j)=oro(0,j)
          ps(nx-1,j,1,n)=ps(0,j,1,n)
          do 71 induvz=1,nuvz
            tt(nx-1,j,induvz,n)=tt(0,j,induvz,n)
            qq(nx-1,j,induvz,n)=qq(0,j,induvz,n)
            uu(nx-1,j,induvz,n)=uu(0,j,induvz,n)
71          vv(nx-1,j,induvz,n)=vv(0,j,induvz,n)
          do 70 indwz=1,nwz
70          ww(nx-1,j,indwz,n)=ww(0,j,indwz,n)
      endif


C If north pole is in the domain, calculate wind velocities in polar
C stereographic coordinates
********************************************************************

      if (nglobal) then
        do 74 jy=int(switchnorthg)-2,ny-1
          ylat=ylat0+float(jy)*dy
          do 74 ix=0,nx-1
            xlon=xlon0+float(ix)*dx
            do 74 induvz=1,nuvz
74            call cc2gll(northpolemap,ylat,xlon,uu(ix,jy,induvz,n),
     +        vv(ix,jy,induvz,n),uupol(ix,jy,induvz,n),
     +        vvpol(ix,jy,induvz,n))


        do 76 induvz=1,nuvz

* CALCULATE FFPOL, DDPOL FOR CENTRAL GRID POINT
          xlon=xlon0+float(nx/2-1)*dx
          xlonr=xlon*pi/180.
          ffpol=sqrt(uu(nx/2-1,ny-1,induvz,n)**2+
     &               vv(nx/2-1,ny-1,induvz,n)**2)
          if(vv(nx/2-1,ny-1,induvz,n).lt.0.) then
            ddpol=atan(uu(nx/2-1,ny-1,induvz,n)/
     &                 vv(nx/2-1,ny-1,induvz,n))-xlonr
          else
            ddpol=pi+atan(uu(nx/2-1,ny-1,induvz,n)/
     &                    vv(nx/2-1,ny-1,induvz,n))-xlonr
          endif
          if(ddpol.lt.0.) ddpol=2.0*pi+ddpol
          if(ddpol.gt.2.0*pi) ddpol=ddpol-2.0*pi

* CALCULATE U,V FOR 180 DEG, TRANSFORM TO POLAR STEREOGRAPHIC GRID
          xlon=180.0
          xlonr=xlon*pi/180.
          ylat=90.0
          uuaux=-ffpol*sin(xlonr+ddpol)
          vvaux=-ffpol*cos(xlonr+ddpol)
          call cc2gll(northpolemap,ylat,xlon,uuaux,vvaux,uupolaux,
     +      vvpolaux)

          jy=ny-1
          do 76 ix=0,nx-1
            uupol(ix,jy,induvz,n)=uupolaux
            vvpol(ix,jy,induvz,n)=vvpolaux
76      continue


* Fix: Set W at pole to the zonally averaged W of the next equator-
* ward parallel of latitude

      do 85 indwz=1,nwz
          wdummy=0.
          jy=ny-2
          do 80 ix=0,nx-1
80          wdummy=wdummy+ww(ix,jy,indwz,n)
          wdummy=wdummy/float(nx)
          jy=ny-1
          do 85 ix=0,nx-1
85          ww(ix,jy,indwz,n)=wdummy

      endif

C If south pole is in the domain, calculate wind velocities in polar
C stereographic coordinates
********************************************************************

      if (sglobal) then
        do 77 jy=0,int(switchsouthg)+3
          ylat=ylat0+float(jy)*dy
          do 77 ix=0,nx-1
            xlon=xlon0+float(ix)*dx
            do 77 induvz=1,nuvz
77            call cc2gll(southpolemap,ylat,xlon,uu(ix,jy,induvz,n),
     +        vv(ix,jy,induvz,n),uupol(ix,jy,induvz,n),
     +        vvpol(ix,jy,induvz,n))

        do 79 induvz=1,nuvz

* CALCULATE FFPOL, DDPOL FOR CENTRAL GRID POINT
          xlon=xlon0+float(nx/2-1)*dx
          xlonr=xlon*pi/180.
          ffpol=sqrt(uu(nx/2-1,0,induvz,n)**2+
     &               vv(nx/2-1,0,induvz,n)**2)
          if(vv(nx/2-1,0,induvz,n).lt.0.) then
            ddpol=atan(uu(nx/2-1,0,induvz,n)/
     &                 vv(nx/2-1,0,induvz,n))+xlonr
          else
            ddpol=pi+atan(uu(nx/2-1,0,induvz,n)/
     &                    vv(nx/2-1,0,induvz,n))+xlonr
          endif
          if(ddpol.lt.0.) ddpol=2.0*pi+ddpol
          if(ddpol.gt.2.0*pi) ddpol=ddpol-2.0*pi

* CALCULATE U,V FOR 180 DEG, TRANSFORM TO POLAR STEREOGRAPHIC GRID
          xlon=180.0
          xlonr=xlon*pi/180.
          ylat=-90.0
          uuaux=+ffpol*sin(xlonr-ddpol)
          vvaux=-ffpol*cos(xlonr-ddpol)
          call cc2gll(northpolemap,ylat,xlon,uuaux,vvaux,uupolaux,
     +      vvpolaux)

          jy=0
          do 79 ix=0,nx-1
            uupol(ix,jy,induvz,n)=uupolaux
79          vvpol(ix,jy,induvz,n)=vvpolaux


* Fix: Set W at pole to the zonally averaged W of the next equator-
* ward parallel of latitude

        do 95 indwz=1,nwz
          wdummy=0.
          jy=1
          do 90 ix=0,nx-1
90          wdummy=wdummy+ww(ix,jy,indwz,n)
          wdummy=wdummy/float(nx)
          jy=0
          do 95 ix=0,nx-1
95          ww(ix,jy,indwz,n)=wdummy
      endif

      if(iumax.ne.nuvz) stop 'READWIND: NUVZ NOT CONSISTENT'
      if(iwmax.ne.nwz)  stop 'READWIND: NWZ NOT CONSISTENT'


C Calculate potential temperature and potential vorticity on whole grid
***********************************************************************

      call calcpv(n)


      return
888   write(*,*) ' #### TRAJECTORY MODEL ERROR! WINDFIELD       #### '
      write(*,*) ' #### ',wfname(indj),'                    #### '
      write(*,*) ' #### IS NOT GRIB FORMAT !!!                  #### '
      stop 'Execution terminated'

999   write(*,*) ' #### TRAJECTORY MODEL ERROR! WINDFIELD       #### '
      write(*,*) ' #### ',wfname(indj),'                    #### '
      write(*,*) ' #### CANNOT BE OPENED !!!                    #### '
      write(*,*)
      write(*,'(a)') '!!! PLEASE INSERT A NEW CD-ROM AND   !!!'
      write(*,'(a)') '!!! PRESS ANY KEY TO CONTINUE...     !!!'
      write(*,'(a)') '!!! ...OR TERMINATE FLEXTRA PRESSING !!!'
      write(*,'(a)') '!!! THE "X" KEY...                   !!!'
      write(*,'(a)') '!!! PLEASE CHECK CD-ROM LABEL AND    !!!'
      write(*,'(a)') '!!! CORRECT FILE "PATHNAMES"...      !!!'
      write(*,*)
      read(*,'(a)') opt
      if(opt.eq.'X') then
        stop 'Execution terminated'
      else
        call readpaths(error)
        if(error)
     &    stop 'Error reading "pathnames" --> execution terminated'
        goto 5
      endif

      end

      subroutine gridcheck(oronew,error)
************************************************************************
*                                                                      *
*             TRAJECTORY MODEL SUBROUTINE GRIDCHECK                    *
*                                                                      *
************************************************************************
*                                                                      *
*             AUTHOR:      G. WOTAWA                                   *
*             DATE:        1997-08-06                                  *
*                                                                      *
*             Update:      1998-12, global fields allowed, A. Stohl    *
*                          2011-06, implemented reading of grib2 format*
*                                   analog to FLEXPART 8.22 routines   *
*                                                                      *
************************************************************************
*                                                                     *
* DESCRIPTION:                                                        *
*                                                                     *
* THIS SUBROUTINE DETERMINES THE GRID SPECIFICATIONS (LOWER LEFT      *
* LONGITUDE, LOWER LEFT LATITUDE, NUMBER OF GRID POINTS, GRID DIST-   *
* ANCE AND VERTICAL DISCRETIZATION OF THE ECMWF MODEL) FROM THE       *
* GRIB HEADER OF THE FIRST INPUT FILE. THE CONSISTANCY (NO CHANGES    *
* WITHIN ONE FLEXTRA RUN) IS CHECKED IN THE ROUTINE "READWIND" AT ANY *
* CALL.                                                               *
*                                                                     *
* OUTPUT       error .true.   - can not read grid specifications      *
*              error .false.  - normal                                *
*              oronew .true.  - Terrain heights given in grib files   *
*              oronew .false. - Terrain heights not specified in the  *
*                               grib files (old file standard)        *
*                                                                     *
* XLON0                geographical longitude of lower left gridpoint *
* XLAT0                geographical latitude of lower left gridpoint  *
* NX                   number of grid points x-direction              *
* NY                   number of grid points y-direction              *
* DX                   grid distance x-direction                      *
* DY                   grid distance y-direction                      *
* NUVZ                 number of grid points for horizontal wind      *
*                      components in z direction                      *
* NWZ                  number of grid points for vertical wind        *
* sizesouth, sizenorth give the map scale (i.e. number of virtual grid*
*                      points of the polar stereographic grid):       *
*                      used to check the CFL criterion                *
*                      component in z direction                       *
* UVHEIGHT(1)-         heights of gridpoints where u and v are        *
* UVHEIGHT(NUVZ)       given                                          *
* WHEIGHT(1)-          heights of gridpoints where w is given         *
* WHEIGHT(NWZ)                                                        *
*                                                                     *
***********************************************************************
*
      use grib_api

      include 'includepar'
      include 'includecom'

      integer i,ifn,ifield,j,k,iumax,iwmax,numskip
      real sizesouth,sizenorth,xauxa
      logical error,oronew

!HSO  parameters for grib_api
      integer ifile
      integer iret
      integer igrib
      integer gotGrid
      real*4  xaux1,xaux2,yaux1,yaux2
      real*8  xaux1in,xaux2in,yaux1in,yaux2in
      integer gribVer,parCat,parNum,typSurf,valSurf,discipl
      character*24 gribErrorMsg
      character*20 gribFunction
!HSO  end

* VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

C dimension of isec2 at least (22+n), where n is the number of parallels or
C meridians in a quasi-regular (reduced) Gaussian or lat/long grid

C dimension of zsec2 at least (10+nn), where nn is the number of vertical
C coordinate parameters

      integer isec0(2),isec1(56),isec2(22+nxmax+nymax),isec3(2)
      integer isec4(64),inbuff(jpack),ilen,iswap,ierr,iword,lunit
      real zsec2(91+2*nuvzmax),zsec3(2),zsec4(jpunp)
      character*1 yoper,opt
      data yoper/'D'/

      error=.false.
      oronew=.false.
      iumax=0
      iwmax=0
*
      if(ideltas.gt.0) then
        ifn=1
      else
        ifn=numbwf
      endif
*
* OPENING OF DATA FILE (GRIB CODE)
*
5     call grib_open_file(ifile,path(3)(1:len(3))
     >//trim(wfname(ifn)),'r',iret)
      if (iret.ne.GRIB_SUCCESS) then
        goto 999   ! ERROR DETECTED
      endif
!     turn on support for multi fields messages
!     call grib_multi_support_on()

      gotGrid=0
      ifield=0
10    ifield=ifield+1

*
* GET NEXT FIELDS
*
      call grib_new_from_file(ifile,igrib,iret)
      if (iret.eq.GRIB_END_OF_FILE )  then
        goto 30    ! EOF DETECTED
      elseif (iret.ne.GRIB_SUCCESS) then
        goto 999   ! ERROR DETECTED
      endif

!     first see if we read GRIB1 or GRIB2
      call grib_get_int(igrib,'editionNumber',gribVer,iret)
      call grib_check(iret,gribFunction,gribErrorMsg)

C     GRIB 1
C *******************************************************************
      if (gribVer.eq.1) then
C        print*,'GRiB Edition 1'
c     read the grib2 identifiers
        call grib_get_int(igrib,'indicatorOfParameter',isec1(6),iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'level',isec1(8),iret)
        call grib_check(iret,gribFunction,gribErrorMsg)

c     change code for etadot to code for omega
        if (isec1(6).eq.77) then
          isec1(6)=135
        endif
C     GRIB 2
C *******************************************************************
      else
C        print*,'GRiB Edition 2'
c     read the grib2 identifiers
        call grib_get_int(igrib,'discipline',discipl,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'parameterCategory',parCat,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'parameterNumber',parNum,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'typeOfFirstFixedSurface',typSurf,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'level',valSurf,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)

!     convert to grib1 identifiers
        isec1(6)=-1
        isec1(7)=-1
        isec1(8)=-1
        isec1(8)=valSurf     ! level

        if ((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.105))then ! T
          isec1(6)=130         ! indicatorOfParameter
        elseif((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.105))then ! U
          isec1(6)=131         ! indicatorOfParameter
        elseif((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.105))then ! V
          isec1(6)=132         ! indicatorOfParameter
        elseif((parCat.eq.1).and.(parNum.eq.0).and.(typSurf.eq.105))then ! Q
          isec1(6)=133         ! indicatorOfParameter
        elseif((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.1))then !SP
          isec1(6)=134         ! indicatorOfParameter
        elseif((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually eta dot
          isec1(6)=135         ! indicatorOfParameter
        elseif((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101))then !SLP
          isec1(6)=151         ! indicatorOfParameter
        elseif((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.103))then ! 10U
          isec1(6)=165         ! indicatorOfParameter
        elseif((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.103))then ! 10V
          isec1(6)=166         ! indicatorOfParameter
        elseif((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.103))then ! 2T
          isec1(6)=167         ! indicatorOfParameter
        elseif((parCat.eq.0).and.(parNum.eq.6).and.(typSurf.eq.103))then ! 2D
          isec1(6)=168         ! indicatorOfParameter
        elseif((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1))then ! SD
          isec1(6)=141         ! indicatorOfParameter
        elseif((parCat.eq.6).and.(parNum.eq.1)) then ! CC
          isec1(6)=164         ! indicatorOfParameter
        elseif((parCat.eq.1).and.(parNum.eq.9)) then ! LSP
          isec1(6)=142         ! indicatorOfParameter
        elseif((parCat.eq.1).and.(parNum.eq.10)) then ! CP
          isec1(6)=143         ! indicatorOfParameter
        elseif((parCat.eq.0).and.(parNum.eq.11).and.(typSurf.eq.1))then ! SHF
          isec1(6)=146         ! indicatorOfParameter
        elseif((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1))then ! SR
          isec1(6)=176         ! indicatorOfParameter
        elseif((parCat.eq.2).and.(parNum.eq.17))then ! EWSS
          isec1(6)=180         ! indicatorOfParameter
        elseif((parCat.eq.2).and.(parNum.eq.18))then ! NSSS
          isec1(6)=181         ! indicatorOfParameter
        elseif((parCat.eq.3).and.(parNum.eq.4))then ! ORO
          isec1(6)=129         ! indicatorOfParameter
        elseif((parCat.eq.3).and.(parNum.eq.7))then ! SDO
          isec1(6)=160         ! indicatorOfParameter
        elseif((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and.
     +     (typSurf.eq.1)) then ! LSM
          isec1(6)=172         ! indicatorOfParameter
        else
          print*,'***ERROR: undefined GRiB2 message found!',discipl,
     +     parCat,parNum,typSurf
        endif


      endif

!     get the size and data of the values array
      if (isec1(6).ne.-1) then
        call grib_get_real4_array(igrib,'values',zsec4,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
      endif

      if(ifield.eq.1) then
!HSO  get the required fields from section 2 in a gribex compatible manner
        call grib_get_int(igrib,'numberOfPointsAlongAParallel',
     >       isec2(2),iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'numberOfPointsAlongAMeridian',
     >       isec2(3),iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees',
     >       xaux1in,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'numberOfVerticalCoordinateValues',
     >       isec2(12),iret)
        call grib_check(iret,gribFunction,gribErrorMsg)

!       get the size and data of the vertical coordinate array
        call grib_get_real4_array(igrib,'pv',zsec2,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)

        nxfield=isec2(2)
        ny=isec2(3)
        nlev_ec=isec2(12)/2-1
      endif

!HSO  get the second part of the grid dimensions only from GRiB1 messages
      if ((gribVer.eq.1).and.(gotGrid.eq.0)) then
        call grib_get_real8(igrib,'longitudeOfLastGridPointInDegrees',
     >       xaux2in,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees',
     >       yaux1in,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_real8(igrib,'latitudeOfFirstGridPointInDegrees',
     >       yaux2in,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        xaux1=xaux1in
        xaux2=xaux2in
        yaux1=yaux1in
        yaux2=yaux2in
        if (xaux1.gt.180.) xaux1=xaux1-360.0
        if (xaux2.gt.180.) xaux2=xaux2-360.0
        if (xaux1.lt.-180.) xaux1=xaux1+360.0
        if (xaux2.lt.-180.) xaux2=xaux2+360.0
        if (xaux2.lt.xaux1) xaux2=xaux2+360.0
        xlon0=xaux1
        ylat0=yaux1
        dx=(xaux2-xaux1)/float(nxfield-1)
        dy=(yaux2-yaux1)/float(ny-1)
        gotGrid=1

C Check whether fields are global
C If they contain the poles, specify polar stereographic map
C projections using the stlmbr- and stcm2p-calls
************************************************************

        if (xauxa.lt.0.001) then
          nx=nxfield+1                 ! field is cyclic
          xglobal=.true.
        else
          nx=nxfield
          xglobal=.false.
        endif
        if (xlon0.gt.180.) xlon0=xlon0-360.
        xauxa=abs(yaux1+90.)
        if (xglobal.and.xauxa.lt.0.001) then
          sglobal=.true.               ! field contains south pole
C Enhance the map scale by factor 3 (*2=6) compared to north-south
C map scale
          sizesouth=6.*(switchsouth+90.)/dy
          call stlmbr(southpolemap,-90.,0.)
          call stcm2p(southpolemap,0.,0.,switchsouth,0.,sizesouth,
     +    sizesouth,switchsouth,180.)
          switchsouthg=(switchsouth-ylat0)/dy
        else
          sglobal=.false.
          switchsouthg=999999.
        endif
        xauxa=abs(yaux2-90.)
        if (xglobal.and.xauxa.lt.0.001) then
          nglobal=.true.               ! field contains north pole
C Enhance the map scale by factor 3 (*2=6) compared to north-south
C map scale
          sizenorth=6.*(90.-switchnorth)/dy
          call stlmbr(northpolemap,90.,0.)
          call stcm2p(northpolemap,0.,0.,switchnorth,0.,sizenorth,
     +    sizenorth,switchnorth,180.)
          switchnorthg=(switchnorth-ylat0)/dy
        else
          nglobal=.false.
          switchnorthg=999999.
        endif
      endif ! gotGrid

      k=isec1(8)
      if(isec1(6).eq.131) iumax=max(iumax,nlev_ec-k+1)
      if(isec1(6).eq.135) iwmax=max(iwmax,nlev_ec-k+1)

      if(isec1(6).eq.129) then
        oronew=.true.
        do 20 j=0,ny-1
          do 21 i=0,nxfield-1
21          oro(i,j)=zsec4(nxfield*(ny-j-1)+i+1)/ga
          if (xglobal) oro(nx-1,j)=oro(0,j)
20        continue
      endif

      call grib_release(igrib)
      goto 10                      !! READ NEXT LEVEL OR PARAMETER
*
* CLOSING OF INPUT DATA FILE
*
30    call grib_close_file(ifile)

*     error message if no fields found with correct first longitude in it
      if (gotGrid.eq.0) then
        print*,'***ERROR: input file needs to contain GRiB1 formatted'//
     &'messages'
        stop
      endif

      nuvz=iumax
      nwz =iwmax
      if(nuvz.eq.nlev_ec) nwz=nlev_ec+1

      if (nx.gt.nxmax) then
        write(*,*) 'FLEXTRA error: Too many grid points in x direction.'
        write(*,*) 'Reduce resolution of wind fields.'
        write(*,*) 'Or change parameter settings in file includepar.'
        write(*,*) nx,nxmax
        error=.true.
        return
      endif

      if (ny.gt.nymax) then
        write(*,*) 'FLEXTRA error: Too many grid points in y direction.'
        write(*,*) 'Reduce resolution of wind fields.'
        write(*,*) 'Or change parameter settings in file includepar.'
        write(*,*) ny,nymax
        error=.true.
        return
      endif

      if (nuvz.gt.nuvzmax) then
        write(*,*) 'FLEXTRA error: Too many u,v grid points in z '//
     +'direction.'
        write(*,*) 'Reduce resolution of wind fields.'
        write(*,*) 'Or change parameter settings in file includepar.'
        write(*,*) nuvz+1,nuvzmax
        error=.true.
        return
      endif

      if (nwz.gt.nwzmax) then
        write(*,*) 'FLEXTRA error: Too many w grid points in z '//
     +'direction.'
        write(*,*) 'Reduce resolution of wind fields.'
        write(*,*) 'Or change parameter settings in file includepar.'
        write(*,*) nwz,nwzmax
        error=.true.
        return
      endif

C Output of grid info
*********************

      write(*,*)
      write(*,*)
      write(*,'(a,2i7)') '# of vertical levels: ',nuvz,nwz
      write(*,*)
      write(*,'(a)') 'Mother domain:'
      write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Longitude range: ',
     +xlon0,' to ',xlon0+(nx-1)*dx,'   Grid distance: ',dx
      write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range:  ',
     +ylat0,' to ',ylat0+(ny-1)*dy,'   Grid distance: ',dy
      write(*,*)


C Compute often used aux variables to convert geografical into grid coord.
***************************************************************************

      xthelp=180./pi/r_earth/dx
      ythelp=180./pi/r_earth/dy


* CALCULATE VERTICAL DISCRETIZATION OF ECMWF MODEL
* PARAMETER akm,bkm DESCRIBE THE HYBRID "ETA" COORDINATE SYSTEM
* wheight(i) IS THE HEIGHT OF THE i-th MODEL HALF LEVEL (=INTERFACE BETWEEN
* 2 MODEL LEVELS) IN THE "ETA" SYSTEM

      numskip=nlev_ec-nuvz  ! number of ecmwf model layers not used
                            ! by trajectory model
      do 40 i=1,nwz
        j=numskip+i
        k=nlev_ec+1+numskip+i
        akm(nwz-i+1)=zsec2(j)
        bkm(nwz-i+1)=zsec2(k)
40      wheight(nwz-i+1)=akm(nwz-i+1)/p0+bkm(nwz-i+1)

* CALCULATION OF uvheight, akz, bkz
* akz,bkz ARE THE DISCRETIZATION PARAMETERS FOR THE MODEL LEVELS
* uvheight(i) IS THE HEIGHT OF THE i-th MODEL LEVEL IN THE "ETA" SYSTEM

      do 45 i=1,nuvz
        uvheight(i)=0.5*(wheight(i+1)+wheight(i))
        akz(i)=0.5*(akm(i+1)+akm(i))
        bkz(i)=0.5*(bkm(i+1)+bkm(i))
45      continue

C If vertical coordinates decrease with increasing altitude, multiply by -1.
C This means that also the vertical velocities have to be multiplied by -1.
****************************************************************************

      if (uvheight(1).lt.uvheight(nuvz)) then
        zdirect=1.
      else
        zdirect=-1.
        do 55 i=1,nuvz
55        uvheight(i)=zdirect*uvheight(i)
        do 65 i=1,nwz
65        wheight(i)=zdirect*wheight(i)
      endif


C Compute minimum and maximum height of modelling domain
********************************************************

      heightmin=max(uvheight(1),wheight(1))
      heightmax=min(uvheight(nuvz),wheight(nwz))


      return

999   write(*,*)
      write(*,*) ' ###########################################'//
     &           '###### '
      write(*,*) '       TRAJECTORY MODEL SUBROUTINE GRIDCHECK:'
      write(*,*) ' CAN NOT OPEN INPUT DATA FILE '//wfname(ifn)
      write(*,*) ' ###########################################'//
     &           '###### '
      write(*,*)
      write(*,'(a)') '!!! PLEASE INSERT A NEW CD-ROM AND   !!!'
      write(*,'(a)') '!!! PRESS ANY KEY TO CONTINUE...     !!!'
      write(*,'(a)') '!!! ...OR TERMINATE FLEXTRA PRESSING !!!'
      write(*,'(a)') '!!! THE "X" KEY...                   !!!'
      write(*,*)
      read(*,'(a)') opt
      if(opt.eq.'X') then
        error=.true.
      else
        goto 5
      endif

      return
      end

      subroutine getmet(itime,xt,yt,zt,qqint,pvint,thint)
C                         i   i  i  i    i     i     i
********************************************************************************
*                                                                              *
*     Interpolation of meteorological data (i.e. specific humidity, potential  *
*     vorticity and potential temperature) onto trajectory positions.          *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     29 January 2000                                                          *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* itime [s]          current temporal position                                 *
* xt,yt,zt           coordinates of position for which data shall be interpolat*
* pvint              interpolated potential vorticity                          *
* qqint              interpolated specific humidity                            *
* thint              interpolated potential temperature                        *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer itime,indexf,ngrid,j
      real xt,yt,zt,xtn,ytn,qqint,pvint,thint


C  Determine the times of the wind fields needed for interpolation
******************************************************************

      if ((ldirect*memtime(1).lt.ldirect*itime).and.
     +(ldirect*memtime(2).ge.ldirect*itime)) then ! between 1st and 2nd
        indexf=1
      else if((ldirect*memtime(2).lt.ldirect*itime).and.
     +(ldirect*memtime(3).ge.ldirect*itime)) then ! between 2nd and 3rd
        indexf=2
      endif


C Determine which nesting level to be used
******************************************

      ngrid=0
      do 12 j=numbnests,1,-1
        if ((xt.gt.xln(j)).and.(xt.lt.xrn(j)).and.
     +  (yt.gt.yln(j)).and.(yt.lt.yrn(j))) then
          ngrid=j
          goto 13
        endif
12      continue
13    continue


C Do linear interpolation of the meteo data
*******************************************

      if (ngrid.eq.0) then         ! mother grid
        call lininterpol(qq,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,qqint)
        call lininterpol(pv,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,pvint)
        call lininterpol(th,nxmax,nymax,nuvzmax,nx,ny,nuvz,memind,
     +  uvheight,xt,yt,zt,memtime(indexf),memtime(indexf+1),itime,
     +  indexf,thint)

      else if (ngrid.gt.0) then      ! nested grid

C Determine nested grid coordinates
***********************************

        xtn=(xt-xln(ngrid))*xresoln(ngrid)
        ytn=(yt-yln(ngrid))*yresoln(ngrid)

        call lininterpoln(qqn,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,qqint)
        call lininterpoln(pvn,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,pvint)
        call lininterpoln(thn,maxnests,nxmaxn,nymaxn,nuvzmax,
     +  ngrid,nxn,nyn,nuvz,memind,uvheight,xtn,ytn,zt,memtime(indexf),
     +  memtime(indexf+1),itime,indexf,thint)

      endif

      return
      end

      subroutine openoutput(error)
C                             o
********************************************************************************
*                                                                              *
*   This routine opens the trajectory data output files.                       *
*                                                                              *
*     Authors: A. Stohl                                                        *
*                                                                              *
*     16 February 1994                                                         *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* compoint(maxpoint)   comment for each startpoint                             *
* datestring           date and time of model run                              *
* error                .true., if error ocurred in subprogram, else .false.    *
* numpoint             number of starting points                               *
*                                                                              *
* Constants:                                                                   *
* unittraj             unittraj+i are connected to trajectory output (point i) *
* unittraji            unittraji+i are connected to interpolated trajectories  *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer i,j,k,l
      logical error
      character datestring*24
     

      error=.false.


C Check, if output file names are unequivocal
*********************************************

      do 1 i=1,numpoint-1
        do 1 j=i+1,numpoint
          if (compoint(i)(1:20).eq.compoint(j)(1:20).and.
     +    (compoint(i)(41:45).eq.compoint(j)(41:45))) then
            write(*,*) 'ERROR: 2 STARTING POINTS HAVE IDENTICAL NAMES.'
            write(*,*) 'CHANGE ONE NAME: ',compoint(i)
            stop
          endif
1         continue


C Look for runtime
******************

C      call fdate(datestring)


C If possible, use the first 20 characters of the comment for the file 
C name identification.
*********************************************************************

C 1. if wanted, original trajectories (flexible time step)
**********************************************************

      if ((inter.eq.0).or.(inter.eq.2)) then
      do 10 i=1,numpoint
        k=index(compoint(i),' ')-1
        k=min(k,20)                        
        if (compoint(i)(41:41).ne.'U') then       ! no uncertainty trajectory
          open(unittraj+i,file=path(2)(1:len(2))//'T_'//compoint(i)
     +    (1:k),status='new',err=998)         
        else                                      ! uncertainty trajectory
          open(unittraj+i,file=path(2)(1:len(2))//'T_'//compoint(i)
     +(1:k)//'_U'//compoint(i)(42:45),status='new',err=998)          
        endif
        write(unittraj+i,'(i8,a)') 42+4*numbnests,
     +  '                                       Number of header lines'
        write(unittraj+i,'(a69)') '*************************************
     +********************************'
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a69)') '*               FLEXTRA V4.0  MODEL O         
     +UTPUT                          *'
        write(unittraj+i,'(a69)') '*                     FOR ECMWF WINDF
     +IELDS                          *'
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a69)') '*************************************
     +********************************'
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a,a,a)') '*            TIME OF COMPUTATION: 
     + ' ,datestring(1:24),'            *'
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a69)') '*************************************
     +********************************'
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        if (kind(i).eq.1) then
        write(unittraj+i,'(a69)') '*           TYPE OF TRAJECTORIES:  3-
     +DIMENSIONAL                    *'
        else if (kind(i).eq.2) then
        write(unittraj+i,'(a69)') '*           TYPE OF TRAJECTORIES:  ON
     + MODEL LAYERS                  *'
        else if (kind(i).eq.3) then
        write(unittraj+i,'(a69)') '*           TYPE OF TRAJECTORIES:  MI
     +XED LAYER                      *'
        else if (kind(i).eq.4) then
        write(unittraj+i,'(a69)') '*           TYPE OF TRAJECTORIES:  IS
     +OBARIC                         *'
        else if (kind(i).eq.5) then
        write(unittraj+i,'(a69)') '*           TYPE OF TRAJECTORIES:  IS
     +ENTROPIC                       *'
        endif
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a69)') '*************************************
     +********************************'
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a69)') '*             INTEGRATION SCHEME:  PE          
     +TTERSSEN                       *'
        if (inpolkind.eq.1) then
        write(unittraj+i,'(a69)') '*           INTERPOLATION METHOD:  ID
     +EAL                            *'
        else
        write(unittraj+i,'(a69)') '*           INTERPOLATION METHOD:  LI
     +NEAR                           *'
        endif
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a,f5.2,a)') '*          SPATIAL CFL CRITERION
     +: ',cfl,'                             *'
        write(unittraj+i,'(a,f5.2,a)') '*         TEMPORAL CFL CRITERION
     +: ',cflt,'                             *'
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a69)') '*************************************
     +********************************'
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a)') '* START POINT COMMENT: '//
     +  compoint(i)(1:40)//'     *'
        write(unittraj+i,'(a)') '* MODEL RUN COMMENT: '//
     +  runcomment(1:47)//'*'
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a69)') '*************************************
     +********************************'
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a69)') '* INFORMATION ON WIND FIELDS USED FOR
     + COMPUTATIONS:                 *'
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a,i6,a)') '* NORMAL INTERVAL BETWEEN WIND FIE
     +LDS: ',idiffnorm,' SECONDS               *'
        write(unittraj+i,'(a,i6,a)') '* MAXIMUM INTERVAL BETWEEN WIND FI
     +ELDS: ',idiffmax,' SECONDS              *'
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a29,2i4,a32)') '* NUMBER OF VERTICAL LEVELS: 
     +  ',nuvz,nwz,'                               *'
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a69)') '* MOTHER DOMAIN:                            
     +                               *'
        write(unittraj+i,'(a,f7.2,a,f7.2,a,f6.2,a)')
     +  '* LONGITUDE RANGE: ',xlon0, ' TO ',xlon0+(nx-1)*dx,
     +  '   GRID DISTANCE: ',dx,'       *'
        write(unittraj+i,'(a,f7.2,a,f7.2,a,f6.2,a)')
     +  '* LATITUDE RANGE:  ',ylat0, ' TO ',ylat0+(ny-1)*dy,
     +  '   GRID DISTANCE: ',dy,'       *'

      do 300 l=1,numbnests
        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a,i2,a)') '* NESTED DOMAIN NUMBER: ',l,'                       
     +                                     *'
        write(unittraj+i,'(a,f7.2,a,f7.2,a,f6.2,a)')
     +  '* LONGITUDE RANGE: ',xlon0n(l), ' TO ',
     +  xlon0n(l)+(nxn(l)-1)*dxn(l),
     +  '   GRID DISTANCE: ',dxn(l),'       *'
        write(unittraj+i,'(a,f7.2,a,f7.2,a,f6.2,a)')
     +  '* LATITUDE RANGE:  ',ylat0n(l), ' TO ',
     +  ylat0n(l)+(nyn(l)-1)*dyn(l),
     +  '   GRID DISTANCE: ',dyn(l),'       *'
300     continue

        write(unittraj+i,'(a69)') '*                                           
     +                               *'
        write(unittraj+i,'(a69)') '*************************************
     +********************************'
        write(unittraj+i,*)
10      continue
      endif


C 2. if wanted, interpolated trajectories (constant time step)
**************************************************************

      if (inter.ge.1) then
      do 20 i=1,numpoint
        k=index(compoint(i),' ')-1
        k=min(k,40)                        
        if (compoint(i)(41:41).ne.'U') then       ! no uncertainty trajectory
          open(unittraji+i,file=path(2)(1:len(2))//'TI_'//compoint(i)
     +    (1:k),status='new',err=999)         
        else                                      ! uncertainty trajectory
          open(unittraji+i,file=path(2)(1:len(2))//'TI_'//compoint(i)
     +(1:k)//'_U'//compoint(i)(42:45),status='new',err=999)          
        endif
        write(unittraji+i,'(i8,a)') 42+4*numbnests,
     +  '                                       Number of header lines'
       write(unittraji+i,'(a69)') '*************************************
     +********************************'
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a69)') '*                     FLEXTRA MODEL O         
     +UTPUT                          *'
       write(unittraji+i,'(a69)') '*                     FOR ECMWF WINDF
     +IELDS                          *'
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a69)') '*************************************
     +********************************'
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a,a,a)') '*            TIME OF COMPUTATION: 
     + ',datestring(1:24),'          *'
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a69)') '*************************************
     +********************************'
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
        if (kind(i).eq.1) then
       write(unittraji+i,'(a69)') '*           TYPE OF TRAJECTORIES:  3-
     +DIMENSIONAL                    *'
        else if (kind(i).eq.2) then
       write(unittraji+i,'(a69)') '*           TYPE OF TRAJECTORIES:  ON
     + MODEL LAYERS                  *'
        else if (kind(i).eq.3) then
       write(unittraji+i,'(a69)') '*           TYPE OF TRAJECTORIES:  MI
     +XED LAYER                      *'
        else if (kind(i).eq.4) then
       write(unittraji+i,'(a69)') '*           TYPE OF TRAJECTORIES:  IS
     +OBARIC                         *'
        else if (kind(i).eq.5) then
       write(unittraji+i,'(a69)') '*           TYPE OF TRAJECTORIES:  IS
     +ENTROPIC                       *'
        endif
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a69)') '*************************************
     +********************************'
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a69)') '*             INTEGRATION SCHEME:  PE          
     +TTERSSEN                       *'
       if (inpolkind.eq.1) then
       write(unittraji+i,'(a69)') '*           INTERPOLATION METHOD:  ID
     +EAL                            *'
       else
       write(unittraji+i,'(a69)') '*           INTERPOLATION METHOD:  LI
     +NEAR                           *'
       endif
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a,f5.2,a)') '*          SPATIAL CFL CRITERION
     +: ',cfl,'                             *'
       write(unittraji+i,'(a,f5.2,a)') '*         TEMPORAL CFL CRITERION
     +: ',cflt,'                             *'
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a69)') '*************************************
     +********************************'
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a)') '* START POINT COMMENT: '//
     + compoint(i)(1:40)//'     *'
        write(unittraji+i,'(a)') '* MODEL RUN COMMENT: '//
     +  runcomment(1:47)//'*'
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a69)') '*************************************
     +********************************'
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a69)') '* INFORMATION ON WIND FIELDS USED FOR
     + COMPUTATIONS:                 *'
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a,i6,a)') '* NORMAL INTERVAL BETWEEN WIND FIE
     +LDS: ',idiffnorm,' SECONDS               *'
       write(unittraji+i,'(a,i6,a)') '* MAXIMUM INTERVAL BETWEEN WIND FI
     +ELDS: ',idiffmax,' SECONDS              *'
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a29,2i4,a32)') '* NUMBER OF VERTICAL LEVELS: 
     +  ',nuvz,nwz,'                               *'
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a69)') '* MOTHER DOMAIN:                            
     +                               *'
       write(unittraji+i,'(a,f7.2,a,f7.2,a,f6.2,a)')
     +  '* LONGITUDE RANGE: ',xlon0, ' TO ',xlon0+(nx-1)*dx,
     +  '   GRID DISTANCE: ',dx,'       *'
       write(unittraji+i,'(a,f7.2,a,f7.2,a,f6.2,a)')
     +  '* LATITUDE RANGE:  ',ylat0, ' TO ',ylat0+(ny-1)*dy,
     +  '   GRID DISTANCE: ',dy,'       *'

      do 400 l=1,numbnests
       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a,i2,a)') '* NESTED DOMAIN NUMBER: ',l,'                       
     +                                     *'
       write(unittraji+i,'(a,f7.2,a,f7.2,a,f6.2,a)')
     +  '* LONGITUDE RANGE: ',xlon0n(l), ' TO ',
     +  xlon0n(l)+(nxn(l)-1)*dxn(l),
     +  '   GRID DISTANCE: ',dxn(l),'       *'
       write(unittraji+i,'(a,f7.2,a,f7.2,a,f6.2,a)')
     +  '* LATITUDE RANGE:  ',ylat0n(l), ' TO ',
     +  ylat0n(l)+(nyn(l)-1)*dyn(l),
     +  '   GRID DISTANCE: ',dyn(l),'       *'
400     continue

       write(unittraji+i,'(a69)') '*                                           
     +                               *'
       write(unittraji+i,'(a69)') '*************************************
     +********************************'
       write(unittraji+i,*)
20     continue
      endif

      return    

998   write(*,*)
      write(*,*) ' #### TRAJECTORY MODEL ERROR!   THE FILE       #### '
      write(*,*)
      write(*,*) '      '//path(2)(1:len(2))//'T_'//compoint(i)(1:k)
      write(*,*)
      write(*,*) ' #### (OR THIS FILE WITH A "_U" AT THE END)    #### '
      write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
      write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
      write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
      error=.true.
      return

999   write(*,*)
      write(*,*) ' #### TRAJECTORY MODEL ERROR!   THE FILE       #### '
      write(*,*)
      write(*,*) '      '//path(2)(1:len(2))//'TI_'//compoint(i)(1:k)
      write(*,*)
      write(*,*) ' #### (OR THIS FILE WITH A "_U" AT THE END)    #### '
      write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
      write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
      write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
      error=.true.

      return
      end

      subroutine readcommand(error)
C                              o
********************************************************************************
*                                                                              *
*     This routine reads the user specifications for the current model run.    *
*                                                                              *
*     Authors: A. Stohl                                                        *
*                                                                              *
*     2 February 1994                                                          *
*                                                                              *
*     10 January 1999  Update to facilitate free formatted input               *
*     (P. Seibert + A. Stohl)                                                  *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* bdate                beginning date as Julian date                           *
* edate                ending date as Julian date                              *
* error                .true., if error ocurred in subprogram, else .false.    *
* hhh                  hour                                                    *
* ibdate,ibtime        beginnning date and time (YYYYMMDD, HHMISS)             *
* ideltas [s]          modelling period                                        *
* iedate,ietime        ending date and time (YYYYMMDD, HHMISS)                 *
* interv [s]           interval between two trajectory calculations            *
* ldirect              -1 for backward, 1 for forward trajectories             *
* lentra [s]           length of one trajectory                                *
* line                 a line of text                                          *
* ldim                 number of steps along the interpolated trajectory       *
* mi                   minute                                                  *
* relaxtime            time constant at which random errors are relaxed        *
* ss                   second                                                  *
*                                                                              *
* Constants:                                                                   *
* unitcommand          unit connected to file COMMAND                          *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      logical error,old
      integer hhh,mi,ss
      double precision edate,juldate
      character*50 line


C Open the command file and read user options
*********************************************

      error=.false.

      open(unitcommand,file=path(1)(1:len(1))//'COMMAND',status='old',
     +err=999)

C Check the format of the COMMAND file (either in free format,
C or using formatted mask)
C Use of formatted mask is assumed if line 9 contains the word 'LABEL'
**********************************************************************

      call skplin(8,unitcommand)
      read (unitcommand,901) line
901   format (a)
      if (index(line,'LABEL') .eq. 0) then
        old = .false.
      else
        old = .true.
      endif
      rewind(unitcommand)

C Read parameters
*****************

      call skplin(6,unitcommand)
      if (old) call skplin(1,unitcommand)
      if (old) then
        read(unitcommand,'(3x,a50)') runcomment
      else
        read(unitcommand,*) runcomment
      endif
      if (old) call skplin(3,unitcommand)
      read(unitcommand,*) ldirect
      if (old) call skplin(3,unitcommand)
      read(unitcommand,*) lentra
      if (old) call skplin(3,unitcommand)
      read(unitcommand,*) ibdate,ibtime
      if (old) call skplin(3,unitcommand)
      read(unitcommand,*) iedate,ietime
      if (old) call skplin(3,unitcommand)
      read(unitcommand,*) interv         
      interv=max(interv,1)         ! minimum interval 1 second
      if (old) call skplin(3,unitcommand)
      read(unitcommand,*) inter,interstep
      if (old) call skplin(3,unitcommand)
      read(unitcommand,*) numbunc,distunc,relaxtime,epsu,epsv,epsw
      if (old) call skplin(3,unitcommand)
      read(unitcommand,*) inpolkind
      if (old) call skplin(3,unitcommand)
      read(unitcommand,*) cfl
      if (old) call skplin(3,unitcommand)
      read(unitcommand,*) cflt
      if (old) call skplin(3,unitcommand)
      read(unitcommand,*) modecet
      
      close(unitcommand)


C Check input dates
*******************

      if (iedate.lt.ibdate) then
        write(*,*) ' #### TRAJECTORY MODEL ERROR! BEGINNING DATE  #### ' 
        write(*,*) ' #### IS LARGER THAN ENDING DATE. CHANGE      #### '
        write(*,*) ' #### EITHER POINT 3 OR POINT 4 IN FILE       #### '
        write(*,*) ' #### "COMMAND".                              #### '
        error=.true.
        return
      else if (iedate.eq.ibdate) then
        if (ietime.lt.ibtime) then
        write(*,*) ' #### TRAJECTORY MODEL ERROR! BEGINNING TIME  #### ' 
        write(*,*) ' #### IS LARGER THAN ENDING TIME. CHANGE      #### '
        write(*,*) ' #### EITHER POINT 3 OR POINT 4 IN FILE       #### '
        write(*,*) ' #### "COMMAND".                              #### '
        error=.true.
        return

        endif
      endif


C Check CFL criterions
**********************

      if((cfl.lt.1.).or.(cflt.lt.1.)) then
        write(*,*) ' #### TRAJECTORY MODEL ERROR! CFL CRITERION   #### ' 
        write(*,*) ' #### MUST NOT BE SET LESS THEN 1 !!!         #### '
        error=.true.
        return
      endif


C Conversion of format HHHMISS to seconds
*****************************************

      hhh=lentra/10000
      mi=(lentra-10000*hhh)/100
      ss=lentra-10000*hhh-100*mi
      lentra=ldirect*(hhh*3600+60*mi+ss)

      hhh=interv/10000
      mi=(interv-10000*hhh)/100
      ss=interv-10000*hhh-100*mi
      interv=hhh*3600+60*mi+ss


C Compute number of time steps along interpolated trajectory
************************************************************

      if (interstep.lt.1) interstep=1
      ldim=ldirect*lentra/interstep+1

      if ((inter.ge.0).and.(ldim.gt.maxitime)) then
        write(*,*) ' #### TRAJECTORY MODEL ERROR! INTERPOLATION   #### ' 
        write(*,*) ' #### TO SUCH A SHORT TIME STEP IS NOT        #### '
        write(*,*) ' #### POSSIBLE. SET SSSSS IN POINT 7. OF FILE #### '
        write(*,*) ' #### "COMMAND" TO A GREATER VALUE.           #### '
        error=.true.
        return
      endif

      if ((inter.eq.1).and.(maxtime.lt.2*ldim+1)) then
        write(*,*) ' #### TRAJECTORY MODEL ERROR! INTERPOLATION   #### ' 
        write(*,*) ' #### TO SUCH A SHORT TIME STEP IS NOT        #### '
        write(*,*) ' #### SENSIBLE GIVEN CURRENT SETTING OF       #### '
        write(*,*) ' #### MAXTRA. SET SSSSS IN POINT 7. OF FILE   #### '
        write(*,*) ' #### "COMMAND" TO A GREATER VALUE.           #### '
        error=.true.
        return
      endif

C Compute modelling time in seconds and beginning date in Julian date
*********************************************************************

      if (ldirect.eq.1) then
        bdate=juldate(ibdate,ibtime)
        edate=juldate(iedate,ietime)
        ideltas=nint(86400.*(edate-bdate))+lentra
      else if (ldirect.eq.-1) then
        bdate=juldate(iedate,ietime)
        edate=juldate(ibdate,ibtime)
        ideltas=nint(86400.*(edate-bdate))+lentra
      else
        write(*,*) ' #### TRAJECTORY MODEL ERROR! DIRECTION IN    #### ' 
        write(*,*) ' #### FILE "COMMAND" MUST BE EITHER -1 OR 1.  #### '
        error=.true.
        return
      endif


      return    

999   write(*,*) ' #### TRAJECTORY MODEL ERROR! FILE "COMMAND"  #### ' 
      write(*,*) ' #### CANNOT BE OPENED IN THE DIRECTORY       #### '
      write(*,*) ' #### xxx/trajec/options                      #### '
      error=.true.

      return
      end

      subroutine checklimits(error)       
C                              o
********************************************************************************
*                                                                              *
*     This routine checks, if the current user specifications are within the   *
*     dimensional limits of the number of trajectories that have to be handled *
*     at the same time.                                                        *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     2 February 1994                                                          *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* error                  .true., if dimensions are exceeded, else .false.      *
* interv [s]             interval between two trajectory calculations          *
* lentra [s]             length of an individual trajectory                    *
* numtramax              wanted maximum number of trajectories                 *
*                                                                              *
* Constants:                                                                   *
* maxtra                 maximum allowable number of trajectories              *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer numtramax
      logical error

      error=.false.

1     format(1x,a6,i7,a43)

C Calculate maximum number of trajectories to be held in memory 
C If only one starting time is selected, numtramax=numpoint, otherwise it is
C =(number of starting points)*(length of trajectories)/(interval of starting
C times of trajectories)
*****************************************************************************

      if ((ibdate.eq.iedate).and.(ibtime.eq.ietime)) then
        numtramax=numpoint
      else
        numtramax=numpoint*int(float(abs(lentra))/float(interv)+1.)
      endif

      if (modecet.eq.3) then
        numtramax=1
      endif


C If numtramax is greater than the number allowed by maxtra, give a warning
C and stop the model execution.
***************************************************************************

      if (numtramax.gt.maxtra) then
        error=.true.
        write(*,*) '#####                !!!ERROR!!!                   #
     +####'
        write(*,*) '##### YOU WANT TO CALCULATE TOO MANY TRAJECTORIES: #
     +####'
        write(*,1) '##### ',numtramax,' ARE WANTED, BUT ONLY                 
     +     #####'
        write(*,1) '##### ',maxtra,' ARE POSSIBLE.                     
     +  #####'
        write(*,*) '##### YOU CAN AVOID THIS PROBLEM IN THREE WAYS:    #
     +####'
        write(*,*) '##### 1) REDUCE THE NUMBER OF STARTING POINTS IN   #
     +####'
        write(*,*) '#####    FILE "STARTPOINTS".                       #
     +####'
        write(*,*) '##### 2) REDUCE THE CALCULATION LENGTH OF THE      #
     +####'
        write(*,*) '#####    TRAJECTORIES IN FILE "COMMAND".           #
     +####'
        write(*,*) '##### 3) INCREASE THE TIME INTERVAL BETWEEN TWO    #
     +####'
        write(*,*) '#####    TRAJECTORY CALCULATIONS IN FILE "COMMAND".#
     +####'
      endif

      return
      end

      SUBROUTINE caldate(JULDATE,YYYYMMDD,HHMISS)
c                           i       o       o
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*                                                                             *
*     Calculates the Gregorian date from the Julian date                      *
*                                                                             *
*     AUTHOR: Andreas Stohl (21 January 1994), adapted from Numerical Recipes *
*                                                                             *
*     Variables:                                                              *
*     DD             Day                                                      *
*     HH             Hour                                                     *
*     HHMISS         Hour, Minute, Second                                     *
*     JA,JB,JC,JD,JE help variables                                           *
*     JALPHA         help variable                                            *
*     JULDATE        Julian Date                                              *
*     JULDAY         help variable                                            *
*     MI             Minute                                                   *
*     MM             Month                                                    *
*     SS             Seconds                                                  *
*     YYYY           Year                                                     *
*     YYYYMMDD       Year, Month, Day                                         *
*                                                                             *
*     Constants:                                                              *
*     IGREG          help constant                                            *
*                                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

      IMPLICIT NONE

      INTEGER YYYYMMDD,YYYY,MM,DD,HHMISS,HH,MI,SS
      INTEGER JULDAY,JA,JB,JC,JD,JE,IGREG,JALPHA
      DOUBLE PRECISION JULDATE
      PARAMETER (IGREG=2299161)

      JULDAY=INT(JULDATE)
      IF(JULDAY.GE.IGREG)THEN
        JALPHA=INT(((JULDAY-1867216)-0.25)/36524.25)
        JA=JULDAY+1+JALPHA-INT(0.25*JALPHA)
      ELSE
        JA=JULDAY
      ENDIF
      JB=JA+1524
      JC=INT(6680.+((JB-2439870)-122.1)/365.25)
      JD=365*JC+INT(0.25*JC)
      JE=INT((JB-JD)/30.6001)
      DD=JB-JD-INT(30.6001*JE)
      MM=JE-1
      IF (MM.GT.12) MM=MM-12
      YYYY=JC-4715
      IF (MM.GT.2) YYYY=YYYY-1
      IF (YYYY.LE.0) YYYY=YYYY-1

      YYYYMMDD=10000*YYYY+100*MM+DD
      HH=INT(24.*(JULDATE-FLOAT(JULDAY)))
      MI=INT(1440.*(JULDATE-FLOAT(JULDAY))-60.*FLOAT(HH))
      SS=NINT(86400.*(JULDATE-FLOAT(JULDAY))-3600.*FLOAT(HH))
     +-60.*FLOAT(MI)
      IF (SS.EQ.60) THEN  ! 60 seconds = 1 minute
        SS=0
        MI=MI+1
      ENDIF
      IF (MI.EQ.60) THEN
        MI=0
        HH=HH+1
      ENDIF
      HHMISS=10000*HH+100*MI+SS

      RETURN
      END

C CHANGES TO THE ROUTINES BY A. STOHL
C XI,XI0,ETA,ETA0 ARE DOUBLE PRECISION VARIABLES TO AVOID PROBLEMS
C AT POLES

	SUBROUTINE CC2GLL (STRCMP, XLAT,XLONG, UE,VN, UG,VG)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
	DOUBLE PRECISION XPOLG,YPOLG,ALONG,SLONG,CLONG,ROT
	REAL STRCMP(9)
	ALONG = CSPANF( XLONG - STRCMP(2), -180., 180.)
	IF (XLAT.GT.89.985) THEN
C*  NORTH POLAR METEOROLOGICAL ORIENTATION: "NORTH" ALONG PRIME MERIDIAN
	  ROT = - STRCMP(1) * ALONG + XLONG - 180.
	ELSEIF (XLAT.LT.-89.985) THEN
C*  SOUTH POLAR METEOROLOGICAL ORIENTATION: "NORTH" ALONG PRIME MERIDIAN
	  ROT = - STRCMP(1) * ALONG - XLONG
	ELSE
	  ROT = - STRCMP(1) * ALONG
	ENDIF
	SLONG = SIN( RADPDG * ROT )
	CLONG = COS( RADPDG * ROT )
	XPOLG = SLONG * STRCMP(5) + CLONG * STRCMP(6)
	YPOLG = CLONG * STRCMP(5) - SLONG * STRCMP(6)
	UG = YPOLG * UE + XPOLG * VN
	VG = YPOLG * VN - XPOLG * UE
	RETURN
	END

	SUBROUTINE CCRVLL (STRCMP, XLAT,XLONG, GX,GY)
C*  WRITTEN ON 9/20/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (REARTH=6 371.2)
	PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
	DOUBLE PRECISION XPOLG,YPOLG,TEMP,ALONG,SLONG,CLONG,CTEMP
	REAL STRCMP(9)
	ALONG = CSPANF( XLONG - STRCMP(2), -180., 180.)
	SLONG = SIN( RADPDG * STRCMP(1) * ALONG)
	CLONG = COS( RADPDG * STRCMP(1) * ALONG)
	XPOLG = - SLONG * STRCMP(5) + CLONG * STRCMP(6)
	YPOLG = CLONG * STRCMP(5) + SLONG * STRCMP(6)
        TEMP = SIN(RADPDG * XLAT)
        CTEMP = COS(RADPDG * XLAT)
        CURV = (STRCMP(1) - TEMP) / CTEMP / REARTH
        GX = CURV * XPOLG
        GY = CURV * YPOLG
	RETURN
	END

	SUBROUTINE CCRVXY (STRCMP, X,Y, GX,GY)
C*  WRITTEN ON 9/20/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (REARTH=6 371.2)
	PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
	REAL STRCMP(9)
	DOUBLE PRECISION XPOLG,YPOLG,TEMP,YMERC,EFACT,CURV
	TEMP = STRCMP(1) * STRCMP(7) /REARTH
	XPOLG = STRCMP(6) + TEMP * (STRCMP(3) - X)
	YPOLG = STRCMP(5) + TEMP * (STRCMP(4) - Y)
	TEMP = SQRT ( XPOLG ** 2 + YPOLG ** 2 )
	IF (TEMP.GT.0.) THEN
	  YMERC = - LOG( TEMP) /STRCMP(1)
	  EFACT = EXP(YMERC)
 	  CURV = ( (STRCMP(1) - 1.D0) * EFACT +
     A            (STRCMP(1) + 1.D0) / EFACT )
     B           * .5D0 / REARTH
	  GX = XPOLG * CURV / TEMP
	  GY = YPOLG * CURV / TEMP
	ELSE
	  IF (ABS(STRCMP(1)) .EQ. 1.) THEN
	    GX = 0.
	    GY = 0.
	  ELSE
	    GX = 1./REARTH
	    GY = 1./REARTH
	  ENDIF
	ENDIF
	RETURN
	END

	SUBROUTINE CG2CLL (STRCMP, XLAT,XLONG, UG,VG, UE,VN)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
	DOUBLE PRECISION XPOLG,YPOLG,ALONG,SLONG,CLONG,ROT
	REAL STRCMP(9)
	ALONG = CSPANF( XLONG - STRCMP(2), -180., 180.)
	IF (XLAT.GT.89.985) THEN
C*  NORTH POLAR METEOROLOGICAL ORIENTATION: "NORTH" ALONG PRIME MERIDIAN
	  ROT = - STRCMP(1) * ALONG + XLONG - 180.
	ELSEIF (XLAT.LT.-89.985) THEN
C*  SOUTH POLAR METEOROLOGICAL ORIENTATION: "NORTH" ALONG PRIME MERIDIAN
	  ROT = - STRCMP(1) * ALONG - XLONG
	ELSE
	  ROT = - STRCMP(1) * ALONG
	ENDIF
	SLONG = SIN( RADPDG * ROT )
	CLONG = COS( RADPDG * ROT )
	XPOLG = SLONG * STRCMP(5) + CLONG * STRCMP(6)
	YPOLG = CLONG * STRCMP(5) - SLONG * STRCMP(6)
	UE = YPOLG * UG - XPOLG * VG
	VN = YPOLG * VG + XPOLG * UG
	RETURN
	END

	SUBROUTINE CG2CXY (STRCMP, X,Y, UG,VG, UE,VN)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (REARTH=6 371.2)
	REAL STRCMP(9)
	DOUBLE PRECISION XPOLG,YPOLG,TEMP,XI0,ETA0,XI,ETA
	PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
	XI0 = ( X - STRCMP(3) ) * STRCMP(7) / REARTH
	ETA0 = ( Y - STRCMP(4) ) * STRCMP(7) /REARTH
	XI = XI0 * STRCMP(5) - ETA0 * STRCMP(6)
	ETA = ETA0 * STRCMP(5) + XI0 * STRCMP(6)
	RADIAL = 2. * ETA - STRCMP(1) * (XI*XI + ETA*ETA)
	IF (RADIAL.GT.STRCMP(8)) THEN
C*  CASE NORTH OF 89 DEGREES.  METEOROLOGICAL WIND DIRECTION DEFINITION
C*      CHANGES.
	  CALL CNXYLL(STRCMP, XI,ETA, XLAT,XLONG) 
C*  NORTH POLAR METEOROLOGICAL ORIENTATION: "NORTH" ALONG PRIME MERIDIAN
	  ROT = STRCMP(1) * (XLONG - STRCMP(2)) - XLONG - 180.
	  SLONG = - SIN( RADPDG * ROT )
	  CLONG = COS( RADPDG * ROT )
	  XPOLG = SLONG * STRCMP(5) + CLONG * STRCMP(6)
	  YPOLG = CLONG * STRCMP(5) - SLONG * STRCMP(6)
	ELSE IF (RADIAL.LT.STRCMP(9)) THEN
C*  CASE SOUTH OF -89 DEGREES.  METEOROLOGICAL WIND DIRECTION DEFINITION
C*      CHANGES.
	  CALL CNXYLL(STRCMP, XI,ETA, XLAT,XLONG) 
C*  SOUTH POLAR METEOROLOGICAL ORIENTATION: "NORTH" ALONG PRIME MERIDIAN
	  ROT = STRCMP(1) * (XLONG - STRCMP(2)) + XLONG
	  SLONG = - SIN( RADPDG * ROT )
	  CLONG = COS( RADPDG * ROT )
	  XPOLG = SLONG * STRCMP(5) + CLONG * STRCMP(6)
	  YPOLG = CLONG * STRCMP(5) - SLONG * STRCMP(6)
	ELSE
C* NORMAL CASE.  METEOROLOGICAL DIRECTION OF WIND RELATED TO TRUE NORTH.
	  XPOLG = STRCMP(6) - STRCMP(1) * XI0
	  YPOLG = STRCMP(5) - STRCMP(1) * ETA0
	  TEMP = SQRT ( XPOLG ** 2 + YPOLG ** 2 )
	  XPOLG = XPOLG / TEMP
	  YPOLG = YPOLG / TEMP
	END IF
	UE = ( YPOLG * UG - XPOLG * VG )
	VN = ( YPOLG * VG + XPOLG * UG )
	RETURN
	END

	REAL FUNCTION CGSZLL (STRCMP, XLAT,XLONG)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180D0/PI)
	REAL STRCMP(9)
	DOUBLE PRECISION SLAT,YMERC,EFACT
	IF (XLAT .GT. 89.985) THEN
C* CLOSE TO NORTH POLE
	  IF (STRCMP(1) .GT. 0.9999) THEN
C* AND TO GAMMA == 1.
	    CGSZLL = 2. * STRCMP(7)
	    RETURN
	  ENDIF
	  EFACT = COS(RADPDG * XLAT)
	  IF (EFACT .LE. 0.) THEN
	    CGSZLL = 0.
	    RETURN
	  ELSE
	    YMERC = - LOG( EFACT /(1. + SIN(RADPDG * XLAT)))
	  ENDIF
	ELSE IF (XLAT .LT. -89.985) THEN
C* CLOSE TO SOUTH POLE
	  IF (STRCMP(1) .LT. -0.9999) THEN
C* AND TO GAMMA == -1.0
	    CGSZLL = 2. * STRCMP(7)
	    RETURN
	  ENDIF
	  EFACT = COS(RADPDG * XLAT)
	  IF (EFACT .LE. 0.) THEN
	    CGSZLL = 0.
	    RETURN
	  ELSE
	    YMERC = LOG( EFACT /(1. - SIN(RADPDG * XLAT)))
	  ENDIF
	ELSE
	SLAT = SIN(RADPDG * XLAT)
	YMERC = LOG((1. + SLAT) / (1. - SLAT))/2.
C	EFACT = EXP(YMERC)
C	CGSZLL = 2. * STRCMP(7) * EXP (STRCMP(1) * YMERC)
C     C			 / (EFACT + 1./EFACT)
	ENDIF
	CGSZLL = STRCMP(7) * COS(RADPDG * XLAT) * EXP(STRCMP(1) *YMERC)
	RETURN
	END

	REAL FUNCTION CGSZXY (STRCMP, X,Y)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (REARTH=6 371.2,ALMST1=.9999999)
	REAL STRCMP(9)
	DOUBLE PRECISION YMERC,EFACT
	DOUBLE PRECISION XI0,ETA0,XI,ETA
	XI0 = ( X - STRCMP(3) ) * STRCMP(7) / REARTH
	ETA0 = ( Y - STRCMP(4) ) * STRCMP(7) /REARTH
	XI = XI0 * STRCMP(5) - ETA0 * STRCMP(6)
	ETA = ETA0 * STRCMP(5) + XI0 * STRCMP(6)
	RADIAL = 2. * ETA - STRCMP(1) * (XI*XI + ETA*ETA)
	EFACT = STRCMP(1) * RADIAL
	IF (EFACT .GT. ALMST1) THEN
	  IF (STRCMP(1).GT.ALMST1) THEN
	    CGSZXY = 2. * STRCMP(7)
	  ELSE
	    CGSZXY = 0.
	  ENDIF
	  RETURN
	ENDIF
	IF (ABS(EFACT) .LT. 1.E-2) THEN
	  TEMP = (EFACT / (2. - EFACT) )**2
	  YMERC = RADIAL / (2. - EFACT) * (1.    + TEMP *
     C				          (1./3. + TEMP *
     C				          (1./5. + TEMP *
     C				          (1./7. ))))
	ELSE
	  YMERC = - LOG( 1. - EFACT ) /2. /STRCMP(1)
	ENDIF
	IF (YMERC .GT. 6.) THEN
	  IF (STRCMP(1) .GT. ALMST1) THEN
	    CGSZXY = 2. * STRCMP(7)
	  ELSE
	    CGSZXY = 0.
	  ENDIF
	ELSE IF (YMERC .LT. -6.) THEN
	  IF (STRCMP(1) .LT. -ALMST1) THEN
	    CGSZXY = 2. * STRCMP(7)
	  ELSE
	    CGSZXY = 0.
	  ENDIF
	ELSE
	  EFACT = EXP(YMERC)
	  CGSZXY = 2. * STRCMP(7) * EXP (STRCMP(1) * YMERC)
     C				 / (EFACT + 1./EFACT)
	ENDIF
	RETURN
	END

	SUBROUTINE CLL2XY (STRCMP, XLAT,XLONG, X,Y)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (REARTH=6 371.2)
	REAL STRCMP(9)
	CALL CNLLXY(STRCMP, XLAT,XLONG, XI,ETA)
	X = STRCMP(3) + REARTH/STRCMP(7) *
     C		 (XI * STRCMP(5) + ETA * STRCMP(6) )
	Y = STRCMP(4) + REARTH/STRCMP(7) *
     C		 (ETA * STRCMP(5) - XI * STRCMP(6) )
	RETURN
	END

	SUBROUTINE CNLLXY (STRCMP, XLAT,XLONG, XI,ETA)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
C  MAIN TRANSFORMATION ROUTINE FROM LATITUDE-LONGITUDE TO
C  CANONICAL (EQUATOR-CENTERED, RADIAN UNIT) COORDINATES
	PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
	PARAMETER (ALMST1=.9999999)
	REAL STRCMP(9)
 	DOUBLE PRECISION GAMMA
	DOUBLE PRECISION DLONG,DLAT,SLAT,MERCY,GMERCY
	GAMMA = STRCMP(1)
	DLAT = XLAT
	DLONG = CSPANF(XLONG - STRCMP(2), -180., 180.)
	DLONG = DLONG * RADPDG
	GDLONG = GAMMA * DLONG
	IF (ABS(GDLONG) .LT. .01) THEN
C  CODE FOR GAMMA SMALL OR ZERO.  THIS AVOIDS ROUND-OFF ERROR OR DIVIDE-
C  BY ZERO IN THE CASE OF MERCATOR OR NEAR-MERCATOR PROJECTIONS.
	  GDLONG = GDLONG * GDLONG
	  SNDGAM = DLONG * (1. - 1./6. * GDLONG *
     C			   (1. - 1./20. * GDLONG *
     C			   (1. - 1./42. * GDLONG )))
	  CSDGAM = DLONG * DLONG * .5 *
     C			   (1. - 1./12. * GDLONG *
     C			   (1. - 1./30. * GDLONG * 
     C			   (1. - 1./56. * GDLONG )))
	ELSE
C CODE FOR MODERATE VALUES OF GAMMA
	  SNDGAM = SIN (GDLONG) /GAMMA
	  CSDGAM = (1. - COS(GDLONG) )/GAMMA /GAMMA
	ENDIF
	SLAT = SIN(RADPDG * DLAT)
	IF ((SLAT .GE. ALMST1) .OR. (SLAT .LE. -ALMST1)) THEN
	  ETA = 1./STRCMP(1)
	  XI = 0.
	  RETURN
	ENDIF
	MERCY = .5 * LOG( (1. + SLAT) / (1. - SLAT) )
	GMERCY = GAMMA * MERCY
	IF (ABS(GMERCY) .LT. .001) THEN
C  CODE FOR GAMMA SMALL OR ZERO.  THIS AVOIDS ROUND-OFF ERROR OR DIVIDE-
C  BY ZERO IN THE CASE OF MERCATOR OR NEAR-MERCATOR PROJECTIONS.
	  RHOG1 = MERCY * (1. - .5 * GMERCY *
     C			  (1. - 1./3. * GMERCY *
     C			  (1. - 1./4. * GMERCY ) ) )
	ELSE
C CODE FOR MODERATE VALUES OF GAMMA
	  RHOG1 = (1. - EXP(-GMERCY)) / GAMMA
	ENDIF
	ETA = RHOG1 + (1. - GAMMA * RHOG1) * GAMMA * CSDGAM
	XI = (1. - GAMMA * RHOG1 ) * SNDGAM
	END

	SUBROUTINE CNXYLL (STRCMP, XI,ETA, XLAT,XLONG)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
C  MAIN TRANSFORMATION ROUTINE FROM CANONICAL (EQUATOR-CENTERED,
C  RADIAN UNIT) COORDINATES
	PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
	PARAMETER (ALMST1=.9999999)
	REAL STRCMP(9)
	DOUBLE PRECISION GAMMA,TEMP,ARG1,ARG2,YMERC,ALONG,GXI,CGETA
        DOUBLE PRECISION XI,ETA
	GAMMA = STRCMP(1)
C  CALCULATE EQUIVALENT MERCATOR COORDINATE
	ODIST = XI*XI + ETA*ETA
	ARG2 = 2. * ETA - GAMMA * (XI*XI + ETA*ETA)
	ARG1 = GAMMA * ARG2
C Change by A. Stohl to avoid problems close to the poles
C IF (ARG1 .GE. ALMST1) THEN
C  DISTANCE TO NORTH (OR SOUTH) POLE IS ZERO (OR IMAGINARY ;) )
C XLAT = SIGN(90.,STRCMP(1))
C XLONG = STRCMP(2)
C RETURN
C ENDIF
	IF (ABS(ARG1) .LT. .01) THEN
C  CODE FOR GAMMA SMALL OR ZERO.  THIS AVOIDS ROUND-OFF ERROR OR DIVIDE-
C  BY ZERO IN THE CASE OF MERCATOR OR NEAR-MERCATOR PROJECTIONS.
	  TEMP = (ARG1 / (2. - ARG1) )**2
	  YMERC = ARG2 / (2. - ARG1) * (1.    + TEMP *
     C				       (1./3. + TEMP *
     C				       (1./5. + TEMP *
     C				       (1./7. ))))
	ELSE
C CODE FOR MODERATE VALUES OF GAMMA
	  YMERC = - LOG ( 1. - ARG1 ) /2. / GAMMA
	ENDIF
C  CONVERT YMERC TO LATITUDE
	TEMP = EXP( - ABS(YMERC) )
	XLAT = SIGN(ATAN2((1. - TEMP) * (1. + TEMP), 2. * TEMP), YMERC)
C  FIND LONGITUDES
	GXI = GAMMA*XI
	CGETA = 1. - GAMMA * ETA
	IF ( ABS(GXI) .LT. .01*CGETA ) THEN
C  CODE FOR GAMMA SMALL OR ZERO.  THIS AVOIDS ROUND-OFF ERROR OR DIVIDE-
C  BY ZERO IN THE CASE OF MERCATOR OR NEAR-MERCATOR PROJECTIONS.
	  TEMP = ( GXI /CGETA )**2
	  ALONG = XI / CGETA * (1.    - TEMP *
     C			       (1./3. - TEMP *
     C			       (1./5. - TEMP *
     C			       (1./7.   ))))
	ELSE
C CODE FOR MODERATE VALUES OF GAMMA
	  ALONG = ATAN2( GXI, CGETA) / GAMMA
	ENDIF
	XLONG = SNGL(STRCMP(2) + DGPRAD * ALONG)
	XLAT = XLAT * DGPRAD
	RETURN
	END

	SUBROUTINE CPOLLL (STRCMP, XLAT,XLONG, ENX,ENY,ENZ)
C*  WRITTEN ON 11/23/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (PI=3.14159265358979,RADPDG=PI/180.,DGPRAD=180./PI)
	DOUBLE PRECISION XPOLG,YPOLG,ALONG,SLONG,CLONG,ROT
	REAL STRCMP(9)
	ALONG = CSPANF( XLONG - STRCMP(2), -180., 180.)
	  ROT = - STRCMP(1) * ALONG
	SLONG = SIN( RADPDG * ROT )
	CLONG = COS( RADPDG * ROT )
	XPOLG = SLONG * STRCMP(5) + CLONG * STRCMP(6)
	YPOLG = CLONG * STRCMP(5) - SLONG * STRCMP(6)
	CLAT = COS(RADPDG * XLAT)
	ENX = CLAT * XPOLG
	ENY = CLAT * YPOLG
	ENZ = SIN(RADPDG * XLAT)
	RETURN
	END

	SUBROUTINE CPOLXY (STRCMP, X,Y, ENX,ENY,ENZ)
C*  WRITTEN ON 11/26/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (REARTH=6 371.2)
	PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
	REAL STRCMP(9)
	DOUBLE PRECISION XPOL,YPOL,TEMP,XI0,ETA0,XI,ETA,RADIAL
	DOUBLE PRECISION TEMP2,YMERC,ARG,OARG,CLAT
	XI0 = ( X - STRCMP(3) ) * STRCMP(7) / REARTH
	ETA0 = ( Y - STRCMP(4) ) * STRCMP(7) /REARTH
	XI = XI0 * STRCMP(5) - ETA0 * STRCMP(6)
	ETA = ETA0 * STRCMP(5) + XI0 * STRCMP(6)
	RADIAL = 2. * ETA -  STRCMP(1) * (XI*XI + ETA*ETA)
	TEMP = STRCMP(1) * RADIAL
	IF (TEMP .GE. 1.) THEN
	  ENX = 0.
	  ENY = 0.
	  ENZ = SIGN(1.,STRCMP(1))
	  RETURN
	ENDIF
	IF (ABS(TEMP).LT.1.E-2) THEN
	  TEMP2 = (TEMP / (2. - TEMP))**2
	  YMERC = RADIAL / (2. - TEMP) * (1. + TEMP2 *
     C					 (1./3. + TEMP2 *
     C					 (1./5. + TEMP2 *
     C					 (1./7.))))
	ELSE
	  YMERC = -.5 * LOG(1. - TEMP) / STRCMP(1)
	ENDIF
	ARG = EXP( YMERC )
	OARG = 1./ARG
	CLAT = 2./(ARG + OARG)
	ENZ = (ARG - OARG) * CLAT /2.
	TEMP = CLAT / SQRT(1. - TEMP)
	XPOL = - XI * STRCMP(1) * TEMP
	YPOL = (1. - ETA * STRCMP(1) ) * TEMP
	ENX = XPOL * STRCMP(5) + YPOL * STRCMP(6)
	ENY = YPOL * STRCMP(5) - XPOL * STRCMP(6)
	RETURN
	END

	REAL FUNCTION CSPANF (VALUE, BEGIN, END)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
C* REAL FUNCTION CSPANF RETURNS A VALUE IN THE INTERVAL (BEGIN,END]
C* WHICH IS EQUIVALENT TO VALUE, MOD (END - BEGIN).  IT IS USED TO
C* REDUCE PERIODIC VARIABLES TO A STANDARD RANGE.  IT ADJUSTS FOR THE
C* BEHAVIOR OF THE MOD FUNCTION WHICH PROVIDES POSITIVE RESULTS FOR
c* POSITIVE INPUT, AND NEGATIVE RESULTS FOR NEGATIVE INPUT
C* INPUT:
C*       VALUE - REAL NUMBER TO BE REDUCED TO THE SPAN
C*       BEGIN - FIRST VALUE OF THE SPAN
C*       END   - LAST VALUE OF THE SPAN
C* RETURNS:
C*       THE REDUCED VALUE
C* EXAMPLES:
C*      ALONG = CSPANF(XLONG, -180., +180.)
C*      DIR  = CSPANF(ANGLE, 0., 360.)
	REAL FIRST,LAST
	FIRST = MIN(BEGIN,END)
	LAST = MAX(BEGIN,END)
	VAL = MOD( VALUE - FIRST , LAST - FIRST)
	IF ( VAL . LE. 0.) THEN
	  CSPANF = VAL + LAST
	ELSE
	  CSPANF = VAL + FIRST
	ENDIF
	RETURN
	END

	SUBROUTINE CXY2LL (STRCMP, X,Y, XLAT,XLONG)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (REARTH=6 371.2)
        DOUBLE PRECISION XI0,ETA0,XI,ETA
	REAL STRCMP(9)
	XI0 = ( X - STRCMP(3) ) * STRCMP(7) / REARTH
	ETA0 = ( Y - STRCMP(4) ) * STRCMP(7) /REARTH
	XI = XI0 * STRCMP(5) - ETA0 * STRCMP(6)
	ETA = ETA0 * STRCMP(5) + XI0 * STRCMP(6)
	CALL CNXYLL(STRCMP, XI,ETA, XLAT,XLONG)
	XLONG = CSPANF(XLONG, -180., 180.)
	RETURN
	END

	REAL FUNCTION EQVLAT (XLAT1,XLAT2)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
	SIND(X) = SIN (RADPDG*X)
	SINL1 = SIND (XLAT1)
	SINL2 = SIND (XLAT2)
	IF (ABS(SINL1 - SINL2) .GT. .001) THEN
	  AL1 = LOG((1. - SINL1)/(1. - SINL2))
	  AL2 = LOG((1. + SINL1)/(1. + SINL2))
	ELSE
C  CASE LAT1 NEAR OR EQUAL TO LAT2
	  TAU = - (SINL1 - SINL2)/(2. - SINL1 - SINL2)
	  TAU = TAU*TAU
	  AL1  = 2. / (2. - SINL1 - SINL2) * (1.    + TAU *
     C 					     (1./3. + TAU *
     C					     (1./5. + TAU *
     C					     (1./7.))))
	  TAU =   (SINL1 - SINL2)/(2. + SINL1 + SINL2)
	  TAU = TAU*TAU
	  AL2  = -2. / (2. + SINL1 + SINL2) * (1.    + TAU *
     C 					      (1./3. + TAU *
     C					      (1./5. + TAU *
     C					      (1./7.))))
	ENDIF
	EQVLAT = ASIN((AL1 + AL2) / (AL1 - AL2))/RADPDG
	RETURN
	END

	SUBROUTINE STCM1P(STRCMP, X1,Y1, XLAT1,XLONG1,
     C XLATG,XLONGG, GRIDSZ, ORIENT)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
	REAL STRCMP(9)
	DO K=3,4
	  STRCMP (K) = 0.
	ENDDO
        TURN = RADPDG * (ORIENT - STRCMP(1) *
     C            CSPANF(XLONGG - STRCMP(2), -180., 180.) )
	STRCMP (5) = COS (TURN)
	STRCMP (6) = - SIN (TURN)
	STRCMP (7) = 1.
	STRCMP (7) = GRIDSZ * STRCMP(7)
     C             / CGSZLL(STRCMP, XLATG, STRCMP(2))
	CALL CLL2XY (STRCMP, XLAT1,XLONG1, X1A,Y1A)
	STRCMP(3) = STRCMP(3) + X1 - X1A
	STRCMP(4) = STRCMP(4) + Y1 - Y1A
	RETURN
	END

	SUBROUTINE STCM2P(STRCMP, X1,Y1, XLAT1,XLONG1,
     C X2,Y2, XLAT2,XLONG2)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	REAL STRCMP(9)
	DO K=3,6
	  STRCMP (K) = 0.
	ENDDO
	STRCMP (5) = 1.
	STRCMP (7) = 1.
	CALL CLL2XY (STRCMP, XLAT1,XLONG1, X1A,Y1A)
	CALL CLL2XY (STRCMP, XLAT2,XLONG2, X2A,Y2A)
	DEN = SQRT( (X1 - X2)**2 + (Y1 - Y2)**2 )
	DENA = SQRT( (X1A - X2A)**2 + (Y1A - Y2A)**2 )
	STRCMP(5) = ((X1A - X2A)*(X1 - X2) + (Y1A - Y2A) * (Y1 - Y2))
     C  /DEN /DENA
	STRCMP(6) = ((Y1A - Y2A)*(X1 - X2) - (X1A - X2A) * (Y1 - Y2))
     C  /DEN /DENA
	STRCMP (7) = STRCMP(7) * DENA / DEN
	CALL CLL2XY (STRCMP, XLAT1,XLONG1, X1A,Y1A)
	STRCMP(3) = STRCMP(3) + X1 - X1A
	STRCMP(4) = STRCMP(4) + Y1 - Y1A
	RETURN
	END

C*  GENERAL CONFORMAL MAP ROUTINES FOR METEOROLOGICAL MODELERS
C*  WRITTEN ON 3/31/94 BY

C* Dr. Albion Taylor
C* NOAA / OAR / ARL                  Phone: (301) 713-0295 x 132
C* Rm. 3151, 1315 East-West Highway  Fax:   (301) 713-0119
C* Silver Spring, MD 20910           E-mail: ADTaylor@arlrisc.ssmc.noaa.gov 

C*  SUBROUTINE STLMBR (STRCMP, TNGLAT, CLONG)
C*    THIS ROUTINE INITIALIZES THE MAP STRUCTURE ARRAY STRCMP TO
C*    THE FORM OF A SPECIFIC MAP PROJECTION
C*  INPUTS:
C*    TNGLAT - THE LATITUDE AT WHICH THE PROJECTION WILL BE TANGENT
C*             TO THE EARTH.  +90. FOR NORTH POLAR STEREOGRAPHIC,
C*             -90. FOR SOUTH POLAR STEREOGRAPHIC, 0. FOR MERCATOR,
C*             AND OTHER VALUES FOR LAMBERT CONFORMAL. 
C*             -90 <= TNGLAT <= 90.
C*    CLONG -  A LONGITUDE IN THE REGION UNDER CONSIDERATION.  LONGITUDES
C*             BETWEEN CLONG-180. AND CLONG+180.  WILL BE MAPPED IN ONE
C*             CONNECTED REGION
C*  OUTPUTS:
C*    STRCMP - A 9-VALUE MAP STRUCTURE ARRAY FOR USE WITH SUBSEQUENT
C*             CALLS TO THE COORDINATE TRANSFORM ROUTINES.
C*
C*  REAL FUNCTION EQVLAT (XLAT1,XLAT2)
C*    THIS FUNCTION IS PROVIDED TO ASSIST IN FINDING THE TANGENT LATITUDE
C*    EQUIVALENT TO THE 2-REFERENCE LATITUDE SPECIFICATION IN THE LEGEND
C*    OF MOST LAMBERT CONFORMAL MAPS.  IF THE MAP SPECIFIES "SCALE 
C*    1:XXXXX TRUE AT 40N AND 60N", THEN EQVLAT(40.,60.) WILL RETURN THE
C*    EQUIVALENT TANGENT LATITUDE.
C*  INPUTS:
C*    XLAT1,XLAT2:  THE TWO LATITUDES SPECIFIED IN THE MAP LEGEND
C*  RETURNS:
C*    THE EQUIVALENT TANGENT LATITUDE
C*  EXAMPLE:  CALL STLMBR(STRCMP, EQVLAT(40.,60.), 90.)

C*  SUBROUTINE STCM2P (STRCMP, X1,Y1, XLAT1,XLONG1,
C*          X2,Y2, XLAT2,XLONG2)
C*  SUBROUTINE STCM1P (STRCMP, X1,Y1, XLAT1,XLONG1,
C*          XLATG,XLONGG, GRIDSZ, ORIENT)
C*    THESE ROUTINES COMPLETE THE SPECIFICATION OF THE MAP STRUCTURE
C*    ARRAY BY CONFORMING THE MAP COORDINATES TO THE SPECIFICATIONS
C*    OF A PARTICULAR GRID.  EITHER STCM1P OR STCM2P MUST BE CALLED,
C*    BUT NOT BOTH
C*  INPUTS:
C*    STRCMP - A 9-VALUE MAP STRUCTURE ARRAY, SET TO A PARTICULAR MAP
C*             FORM BY A PREVIOUS CALL TO STLMBR
C*    FOR STCM2P:
C*      X1,Y1, X2,Y2 - THE MAP COORDINATES OF TWO POINTS ON THE GRID
C*      XLAT1,XLONG1, XLAT2,XLONG2 - THE GEOGRAPHIC COORDINATES OF THE
C*             SAME TWO POINTS
C*    FOR STCM1P:
C*      X1,Y1 - THE MAP COORDINATES OF ONE POINT ON THE GRID
C*      XLAT1,XLONG1 - THE GEOGRAPHIC COORDINATES OF THE SAME POINT
C*      XLATG,XLONGG - LATITUDE AND LONGITUDE OF REFERENCE POINT FOR
C*             GRIDSZ AND ORIENTATION SPECIFICATION.
C*      GRIDSZ - THE DESIRED GRID SIZE IN KILOMETERS, AT XLATG,XLONGG
C*      ORIENT - THE ANGLE, WITH RESPECT TO NORTH, OF A Y-GRID LINE, AT
C*             THE POINT XLATG,XLONGG
C*  OUTPUTS:
C*    STRCMP - A 9-VALUE MAP STRUCTURE ARRAY, FULLY SET FOR USE BY
C*             OTHER SUBROUTINES IN THIS SYSTEM

C*  SUBROUTINE CLL2XY (STRCMP, XLAT,XLONG, X,Y)
C*  SUBROUTINE CXY2LL (STRCMP, X,Y, XLAT,XLONG)
C*     THESE ROUTINES CONVERT BETWEEN MAP COORDINATES X,Y
C*     AND GEOGRAPHIC COORDINATES XLAT,XLONG
C*  INPUTS:
C*     STRCMP(9) - 9-VALUE MAP STRUCTURE ARRAY
C*     FOR CLL2XY:  XLAT,XLONG - GEOGRAPHIC COORDINATES
C*     FOR CXY2LL:  X,Y - MAP COORDINATES
C*  OUTPUTS:
C*     FOR CLL2XY:  X,Y - MAP COORDINATES
C*     FOR CXY2LL:  XLAT,XLONG - GEOGRAPHIC COORDINATES

C*  SUBROUTINE CC2GXY (STRCMP, X,Y, UE,VN, UG,VG)
C*  SUBROUTINE CG2CXY (STRCMP, X,Y, UG,VG, UE,VN)
C*  SUBROUTINE CC2GLL (STRCMP, XLAT,XLONG, UE,VN, UG,VG)
C*  SUBROUTINE CG2CLL (STRCMP, XLAT,XLONG, UG,VG, UE,VN)
C*     THESE SUBROUTINES CONVERT VECTOR WIND COMPONENTS FROM
C*     GEOGRAPHIC, OR COMPASS, COORDINATES, TO MAP OR
C*     GRID COORDINATES.  THE SITE OF THE WIND TO BE
C*     CONVERTED MAY BE GIVEN EITHER IN GEOGRAPHIC OR
C*     MAP COORDINATES.  WIND COMPONENTS ARE ALL IN KILOMETERS
C*     PER HOUR, WHETHER GEOGRAPHIC OR MAP COORDINATES.
C*  INPUTS:
C*    STRCMP(9) - 9-VALUE MAP STRUCTURE ARRAY
C*    FOR CC2GXY AND CG2CXY:  X,Y        -  MAP COORDINATES OF SITE
C*    FOR CC2GLL AND CG2CLL:  XLAT,XLONG -  GEOGRAPHIC COORDINATES OF SITE
C*    FOR CC2GXY AND CC2GLL:  UE,VN - EAST AND NORTH WIND COMPONENTS
C*    FOR CG2CXY AND CG2CLL:  UG,VG - X- AND Y- DIRECTION WIND COMPONENTS
C*  OUTPUTS:
C*    FOR CC2GXY AND CC2GLL:  UG,VG - X- AND Y- DIRECTION WIND COMPONENTS
C*    FOR CG2CXY AND CG2CLL:  UE,VN - EAST AND NORTH WIND COMPONENTS

C*  SUBROUTINE CCRVXY (STRCMP, X, Y,       GX,GY)
C*  SUBROUTINE CCRVLL (STRCMP, XLAT,XLONG, GX,GY)
C*    THESE SUBROUTINES RETURN THE CURVATURE VECTOR (GX,GY), AS REFERENCED
C*    TO MAP COORDINATES, INDUCED BY THE MAP TRANSFORMATION.  WHEN
C*    NON-LINEAR TERMS IN WIND SPEED ARE IMPORTANT, A "GEODESIC" FORCE
C*    SHOULD BE INCLUDED IN THE VECTOR FORM [ (U,U) G - (U,G) U ] WHERE THE
C*    INNER PRODUCT (U,G) IS DEFINED AS UX*GX + UY*GY.
C*  INPUTS:
C*    STRCMP(9) - 9-VALUE MAP STRUCTURE ARRAY
C*    FOR CCRVXY:  X,Y        -  MAP COORDINATES OF SITE
C*    FOR CCRVLL:  XLAT,XLONG -  GEOGRAPHIC COORDINATES OF SITE
C*  OUTPUTS:
C*    GX,GY       - VECTOR COEFFICIENTS OF CURVATURE, IN UNITS RADIANS
C*                  PER KILOMETER

C*  REAL FUNCTION CGSZLL (STRCMP, XLAT,XLONG)
C*  REAL FUNCTION CGSZXY (STRCMP, X,Y)
C*    THESE FUNCTIONS RETURN THE SIZE, IN KILOMETERS, OF EACH UNIT OF
C*    MOTION IN MAP COORDINATES (GRID SIZE).  THE GRID SIZE AT ANY
C*    LOCATION DEPENDS ON THAT LOCATION; THE POSITION MAY BE GIVEN IN
C*    EITHER MAP OR GEOGRAPHIC COORDINATES.
C*  INPUTS:
C*    STRCMP(9) - 9-VALUE MAP STRUCTURE ARRAY
C*    FOR CGSZXY:  X,Y        -  MAP COORDINATES OF SITE
C*    FOR CGSZLL:  XLAT,XLONG -  GEOGRAPHIC COORDINATES OF SITE
C*  RETURNS:
C*    GRIDSIZE IN KILOMETERS AT GIVEN SITE.

C*  SUBROUTINE CPOLXY (STRCMP, X,Y, ENX,ENY,ENZ)
C*  SUBROUTINE CPOLLL (STRCMP, XLAT,XLONG, ENX,ENY,ENZ)
C*    THESE SUBROUTINES PROVIDE 3-D VECTOR COMPONENTS OF A UNIT VECTOR
C*    IN THE DIRECTION OF THE NORTH POLAR AXIS.  WHEN MULTIPLIED
C*    BY TWICE THE ROTATION RATE OF THE EARTH (2 * PI/24 HR), THE
C*    VERTICAL COMPONENT YIELDS THE CORIOLIS FACTOR.
C*  INPUTS:
C*    STRCMP(9) - 9-VALUE MAP STRUCTURE ARRAY
C*    FOR CPOLXY:  X,Y        -  MAP COORDINATES OF SITE
C*    FOR CPOLLL:  XLAT,XLONG -  GEOGRAPHIC COORDINATES OF SITE
C*  RETURNS:
C*    ENX,ENY,ENZ THE DIRECTION COSINES OF A UNIT VECTOR IN THE
C*    DIRECTION OF THE ROTATION AXIS OF THE EARTH

C*  SUBROUTINE CNLLXY (STRCMP, XLAT,XLONG, XI,ETA)
C*  SUBROUTINE CNXYLL (STRCMP, XI,ETA, XLAT,XLONG)
C*    THESE SUBROUTINES PERFORM THE UNDERLYING TRANSFORMATIONS FROM
C*    GEOGRAPHIC COORDINATES TO AND FROM CANONICAL (EQUATOR CENTERED)
C*    COORDINATES.  THEY ARE CALLED BY CXY2LL AND CLL2XY, BUT ARE NOT
C*    INTENDED TO BE CALLED DIRECTLY

C*  REAL FUNCTION CSPANF (VALUE, BEGIN, END)
C*    THIS FUNCTION ASSISTS OTHER ROUTINES IN PROVIDING A LONGITUDE IN
C*    THE PROPER RANGE.  IT ADDS TO VALUE WHATEVER MULTIPLE OF 
C*    (END - BEGIN) IS NEEDED TO RETURN A NUMBER BEGIN < CSPANF <= END

	SUBROUTINE STLMBR(STRCMP, TNGLAT, XLONG)
C*  WRITTEN ON 3/31/94 BY Dr. Albion Taylor  NOAA / OAR / ARL
	PARAMETER (PI=3.14159265358979,RADPDG=PI/180,DGPRAD=180/PI)
	PARAMETER (REARTH=6 371.2)
	REAL STRCMP(9)
	STRCMP(1) = SIN(RADPDG * TNGLAT)
C*  GAMMA = SINE OF THE TANGENT LATITUDE
	STRCMP(2) = CSPANF( XLONG, -180., +180.)
C* LAMBDA_0 = REFERENCE LONGITUDE
	STRCMP(3) = 0.
C* X_0 = X- GRID COORDINATE OF ORIGIN (XI,ETA) = (0.,0.)
	STRCMP(4) = 0.
C* y_0 = Y-GRID COORDINATE OF ORIGIN (XI,ETA) = (0.,0.)
	STRCMP(5) = 1.
C* COSINE OF ROTATION ANGLE FROM XI,ETA TO X,Y
	STRCMP(6) = 0.
C* SINE OF ROTATION ANGLE FROM XI,ETA TO X,Y
	STRCMP(7) = REARTH
C* GRIDSIZE IN KILOMETERS AT THE EQUATOR
	CALL CNLLXY(STRCMP, 89.,XLONG, XI,ETA)
	STRCMP(8) = 2. * ETA - STRCMP(1) * ETA * ETA
C* RADIAL COORDINATE FOR 1 DEGREE FROM NORTH POLE
	CALL CNLLXY(STRCMP, -89.,XLONG, XI,ETA)
   	STRCMP(9) = 2. * ETA - STRCMP(1) * ETA * ETA
C* RADIAL COORDINATE FOR 1 DEGREE FROM SOUTH POLE
	RETURN
	END

      subroutine readpaths(error)
c                            o
********************************************************************************
*                                                                              *
*     Reads the pathnames, where input/output files are expected to be.        *
*     The file pathnames must be available in the current working directory.   *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     1 February 1994                                                          *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* error              .true., if file pathnames does not exist                  *
* len(numpath)       lengths of the path names                                 *
* path(numpath)      pathnames of input/output files                           *
*                                                                              *
* Constants:                                                                   *
* numpath            number of pathnames to be read in                         *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer i
      logical error

      error=.false.

C Read the pathname information stored in unitpath
**************************************************

      open(unitpath,file='pathnames',status='old',err=999)

      do 10 i=1,numpath
        read(unitpath,'(a)',err=998) path(i) 
10      len(i)=index(path(i),' ')-1

C Check whether any nested subdomains are to be used
****************************************************

      do 20 i=1,maxnests
        read(unitpath,'(a)') path(numpath+2*(i-1)+1) 
        read(unitpath,'(a)') path(numpath+2*(i-1)+2) 
        if (path(numpath+2*(i-1)+1)(1:5).eq.'=====') goto 30
        len(numpath+2*(i-1)+1)=index(path(numpath+2*(i-1)+1),' ')-1
20      len(numpath+2*(i-1)+2)=index(path(numpath+2*(i-1)+2),' ')-1


C Determine number of available nested domains
**********************************************

30    numbnests=i-1


      close(unitpath)
      return    

998   write(*,*) ' #### TRAJECTORY MODEL ERROR! ERROR WHILE     #### ' 
      write(*,*) ' #### READING FILE PATHNAMES.                 #### ' 

999   write(*,*) ' #### TRAJECTORY MODEL ERROR! FILE "pathnames"#### ' 
      write(*,*) ' #### CANNOT BE OPENED IN THE CURRENT WORKING #### '
      write(*,*) ' #### DIRECTORY.                              #### '
      error=.true.

      return
      end

      subroutine trajinterpol(numb,ldimi,orotra,orotraint)          
C                              i     o
********************************************************************************
*                                                                              *
*     This routine interpolates the trajectories to a constant time step.      *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     11 February 1994                                                         *
*                                                                              *
*     27 February 1999 Correction by Wuyin Lin to the cyclic                   *
*     boundary conditions                                                      *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* numb                 number of trajectory to be interpolated                 *
*                                                                              *
*                                                                              *
* Constants:                                                                   *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer numb,i,j,k,ldimi
      real orotra(maxtime),orotraint(maxitime),xtmp1,xtmp2

      ldimi=1
      do 10 i=1,ldim
10      ittraint(i)=ittra(numb,1)+(i-1)*ldirect*interstep

      xtraint(1)=xtra(numb,1)
      ytraint(1)=ytra(numb,1)
      ztraint(1)=ztra(numb,1)
      ptraint(1)=ptra(numb,1)
      htraint(1)=htra(numb,1)
      qqtraint(1)=qqtra(numb,1)
      pvtraint(1)=pvtra(numb,1)
      thtraint(1)=thtra(numb,1)
      orotraint(1)=orotra(1)

      k=2
      do 20 i=2,ldim
        do 30 j=k,nttra(numb)
          if (abs(ittra(numb,j)).ge.abs(ittraint(i)))then 

C Linear interpolation
C For x coordinate, special treatment when using cyclic boundary
C conditions to keep values below 360 deg
****************************************************************

            ldimi=i
            xtmp1=xtra(numb,j-1)
            xtmp2=xtra(numb,j)
            if (xglobal) then
              if (abs(xtra(numb,j-1)-xtra(numb,j)).gt.180.) then
                if (xtra(numb,j-1).lt.xtra(numb,j)) then
                  xtmp1=xtra(numb,j-1)+360.
                else
                  xtmp2=xtra(numb,j)+360.
                endif
              endif
            endif

            xtraint(i)=(float(abs(ittra(numb,j)-ittraint(i)))*
     +      xtmp1+float(abs(ittra(numb,j-1)-ittraint(i)))*
     +      xtmp2)/float(abs(ittra(numb,j)-ittra(numb,j-1)))

            if (xtraint(i).gt.360.) xtraint(i)=xtraint(i)-360.


            ytraint(i)=(float(abs(ittra(numb,j)-ittraint(i)))*
     +      ytra(numb,j-1)+float(abs(ittra(numb,j-1)-ittraint(i)))*
     +      ytra(numb,j))/float(abs(ittra(numb,j)-ittra(numb,j-1)))

            ztraint(i)=(float(abs(ittra(numb,j)-ittraint(i)))*
     +      ztra(numb,j-1)+float(abs(ittra(numb,j-1)-ittraint(i)))*
     +      ztra(numb,j))/float(abs(ittra(numb,j)-ittra(numb,j-1)))

            ptraint(i)=(float(abs(ittra(numb,j)-ittraint(i)))*
     +      ptra(numb,j-1)+float(abs(ittra(numb,j-1)-ittraint(i)))*
     +      ptra(numb,j))/float(abs(ittra(numb,j)-ittra(numb,j-1)))

            htraint(i)=(float(abs(ittra(numb,j)-ittraint(i)))*
     +      htra(numb,j-1)+float(abs(ittra(numb,j-1)-ittraint(i)))*
     +      htra(numb,j))/float(abs(ittra(numb,j)-ittra(numb,j-1)))

            qqtraint(i)=(float(abs(ittra(numb,j)-ittraint(i)))*
     +      qqtra(numb,j-1)+float(abs(ittra(numb,j-1)-ittraint(i)))*
     +      qqtra(numb,j))/float(abs(ittra(numb,j)-ittra(numb,j-1)))

            pvtraint(i)=(float(abs(ittra(numb,j)-ittraint(i)))*
     +      pvtra(numb,j-1)+float(abs(ittra(numb,j-1)-ittraint(i)))*
     +      pvtra(numb,j))/float(abs(ittra(numb,j)-ittra(numb,j-1)))

            thtraint(i)=(float(abs(ittra(numb,j)-ittraint(i)))*
     +      thtra(numb,j-1)+float(abs(ittra(numb,j-1)-ittraint(i)))*
     +      thtra(numb,j))/float(abs(ittra(numb,j)-ittra(numb,j-1)))

            orotraint(i)=(float(abs(ittra(numb,j)-ittraint(i)))*
     +      orotra(j-1)+float(abs(ittra(numb,j-1)-ittraint(i)))*
     +      orotra(j))/float(abs(ittra(numb,j)-ittra(numb,j-1)))

            k=j

            goto 20
          endif
30        continue

20      continue

      return    
      end

      subroutine uncertcoor()
********************************************************************************
*                                                                              *
*   This routine calculates the starting positions of the uncertainty traject. *
*                                                                              *
*     Authors: A. Stohl                                                        *
*                                                                              *
*     16 February 1994                                                         *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* compoint(maxpoint)             comment for each starting point               *
* numbunc                        number of uncertainty trajectories            *
* numpoint                       actual number of starting points              *
* phi                            angle, help variable                          *
* xpoint,ypoint,zpoint(maxpoint) x,y,z coordinates of starting points          *
*                                                                              *
* Constants:                                                                   *
* maxpoint                       maximum number of starting points             *
* pi                             PI=3.14                                       *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer i,j,k
      character*4 ii
      real phi


      do 20 i=1,numbunc
        phi=float(i)*2.*pi/float(numbunc)
        do 20 j=1,numpoint
          k=numpoint*i+j
          write(ii,'(i4.4)') i
          compoint(k)=compoint(j)(1:40)//'U'//ii
          xpoint(k)=xpoint(j)+distunc*sin(phi)
          ypoint(k)=ypoint(j)+distunc*cos(phi)
          zpoint(k)=zpoint(j)
          kind(k)=kind(j)
          kindz(k)=kindz(j)


C Check if starting positions are inside grid
*********************************************

          if (xpoint(k).gt.float(nx-1)) xpoint(k)=float(nx-1)-.00001
          if (ypoint(k).gt.float(ny-1)) ypoint(k)=float(ny-1)-.00001
          if (xpoint(k).lt.0.) xpoint(k)=.00001
          if (ypoint(k).lt.0.) ypoint(k)=.00001

20      continue

      numpoint=numpoint*(1+numbunc)

      return
      end

      subroutine readavailable(error)
C                                o
********************************************************************************
*                                                                              *
*   This routine reads the dates and times for which windfields are available. *
*                                                                              *
*     Authors: A. Stohl                                                        *
*                                                                              *
*     6 February 1994                                                          *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* bdate                beginning date as Julian date                           *
* beg                  beginning date for windfields                           *
* end                  ending date for windfields                              *
* error                .true., if error ocurred in subprogram, else .false.    *
* fname                filename of wind field, help variable                   *
* ideltas [s]          duration of modelling period                            *
* idiff                time difference between 2 wind fields                   *
* idiffnorm            normal time difference between 2 wind fields            *
* idiffmax [s]         maximum allowable time between 2 wind fields            *
* jul                  julian date, help variable                              *
* ldirect              -1 for backward, 1 for forward trajectories             *
* numbnests            actual number of nest levels                            *
* numbwf               actual number of wind fields                            *
* wfname(numbwfmax)    file names of needed wind fields                        *
* wfspec(numbwfmax)    file specifications of wind fields (e.g., if on disc)   *
* wftime(numbwfmax) [s]times of wind fields relative to beginning time         *
* wfname1,wfspec1,wftime1 = same as above, but only local (help variables)     *
*                                                                              *
* Constants:                                                                   *
* numbwfmax            maximum number of wind fields                           *
* unitavailab          unit connected to file AVAILABLE                        *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      logical error
      integer i,k,idiff,ldat,ltim,wftime1(numbwfmax),numbwfn(maxnests)
      integer wftime1n(maxnests,numbwfmax),wftimen(maxnests,numbwfmax)
      double precision juldate,jul,beg,end
      character*18 fname
      character*10 spec, wfspec1(numbwfmax)
      character*18 wfname1(numbwfmax)
      character*18 wfname1n(maxnests,numbwfmax)
      character*10 wfspec1n(maxnests,numbwfmax)
     


      error=.false.


C Windfields are only used, if they are within the modelling period.
C However, 1 additional day at the beginning and at the end is used for
C interpolation. -> Compute beginning and ending date for the windfields.
*************************************************************************

      if (ideltas.gt.0) then         ! forward trajectories
        beg=bdate-1.                  
        end=bdate+dble(float(ideltas)/86400.)+dble(float(idiffmax)/
     +  86400.)
      else                           ! backward trajectories
        beg=bdate+dble(float(ideltas)/86400.)-dble(float(idiffmax)/
     +  86400.)
        end=bdate+1.
      endif

C Open the wind field availability file and read available wind fields
C within the modelling period (mother grid)
**********************************************************************

      open(unitavailab,file=path(4)(1:len(4)),status='old',
     +err=999)

      do 10 i=1,3
10      read(unitavailab,*)
      
      numbwf=0
100     read(unitavailab,'(i8,1x,i6,2(6x,a18))',end=99) ldat,ltim,fname,
     +  spec
        jul=juldate(ldat,ltim)
        if ((jul.ge.beg).and.(jul.le.end)) then
          numbwf=numbwf+1
          if (numbwf.gt.numbwfmax) then      ! check exceedance of dimension
           write(*,*) 'Number of wind fields needed is too great.'
           write(*,*) 'Reduce modelling period (file "COMMAND") or'
           write(*,*) 'reduce number of wind fields (file "AVAILABLE").'
           goto 1000
          endif

          wfname1(numbwf)=fname(1:index(fname,' '))
          wfspec1(numbwf)=spec
          wftime1(numbwf)=nint((jul-bdate)*86400.)
        endif
        goto 100       ! next wind field

99    continue

      close(unitavailab)


C Open the wind field availability file and read available wind fields
C within the modelling period (nested grids)
**********************************************************************

      do 50 k=1,numbnests
        open(unitavailab,file=path(numpath+2*(k-1)+2)
     +  (1:len(numpath+2*(k-1)+2)),status='old',err=998)

        do 60 i=1,3
60        read(unitavailab,*)
      
        numbwfn(k)=0
700       read(unitavailab,'(i8,1x,i6,2(6x,a18))',end=699) ldat,
     +    ltim,fname,spec
          jul=juldate(ldat,ltim)
          if ((jul.ge.beg).and.(jul.le.end)) then
            numbwfn(k)=numbwfn(k)+1
            if (numbwfn(k).gt.numbwfmax) then      ! check exceedance of dimension
           write(*,*) 'Number of nested wind fields is too great.'
           write(*,*) 'Reduce modelling period (file "COMMAND") or'
           write(*,*) 'reduce number of wind fields (file "AVAILABLE").'
              goto 1000
            endif

            wfname1n(k,numbwfn(k))=fname
            wfspec1n(k,numbwfn(k))=spec
            wftime1n(k,numbwfn(k))=nint((jul-bdate)*86400.)
          endif
          goto 700       ! next wind field

699     continue

50      close(unitavailab)


C Check wind field times of file AVAILABLE (expected to be in temporal order)
*****************************************************************************

      if (numbwf.eq.0) then
        write(*,*) ' #### TRAJECTORY MODEL ERROR! NO WIND FIELDS  #### ' 
        write(*,*) ' #### AVAILABLE FOR SELECTED TIME PERIOD.     #### '
        error=.TRUE.
        return
      endif

      do 150 i=2,numbwf
        if (wftime1(i).le.wftime1(i-1)) then
          write(*,*) 'FLEXTRA ERROR: FILE AVAILABLE IS CORRUPT.'
          write(*,*) 'THE WIND FIELDS ARE NOT IN TEMPORAL ORDER.'
          write(*,*) 'PLEASE CHECK FIELD ',wfname1(i)
          error=.TRUE.
          return
        endif
150     continue


C Check wind field times of file AVAILABLE (expected to be in temporal order)
*****************************************************************************

      do 77 k=1,numbnests
        if (numbwfn(k).eq.0) then
        write(*,*) ' #### TRAJECTORY MODEL ERROR! NO WIND FIELDS  #### ' 
        write(*,*) ' #### AVAILABLE FOR SELECTED TIME PERIOD.     #### '
          error=.TRUE.
          return
        endif

        do 160 i=2,numbwfn(k)
          if (wftime1n(k,i).le.wftime1n(k,i-1)) then
          write(*,*) 'FLEXTRA ERROR: FILE AVAILABLE IS CORRUPT.'
          write(*,*) 'THE NESTED WIND FIELDS ARE NOT IN TEMPORAL ORDER.'
          write(*,*) 'PLEASE CHECK FIELD ',wfname1n(k,i)
          write(*,*) 'AT NESTING LEVEL ',k
            error=.TRUE.
            return
          endif
160     continue

77      continue


C For backward trajectories, reverse the order of the windfields
****************************************************************

      if (ideltas.ge.0) then
        do 200 i=1,numbwf
          wfname(i)=wfname1(i)
          wfspec(i)=wfspec1(i)
200       wftime(i)=wftime1(i)
        do 210 k=1,numbnests
          do 210 i=1,numbwfn(k)
            wfnamen(k,i)=wfname1n(k,i)
            wfspecn(k,i)=wfspec1n(k,i)
210         wftimen(k,i)=wftime1n(k,i)
      else
        do 300 i=1,numbwf
          wfname(numbwf-i+1)=wfname1(i)
          wfspec(numbwf-i+1)=wfspec1(i)
300       wftime(numbwf-i+1)=wftime1(i)
        do 310 k=1,numbnests
          do 310 i=1,numbwfn(k)
            wfnamen(k,numbwfn(k)-i+1)=wfname1n(k,i)
            wfspecn(k,numbwfn(k)-i+1)=wfspec1n(k,i)
310         wftimen(k,numbwfn(k)-i+1)=wftime1n(k,i)
      endif


C Check the time difference between the wind fields. If it is big, 
C write a warning message. If it is too big, terminate the trajectory.
**********************************************************************

      do 350 i=2,numbwf
        idiff=abs(wftime(i)-wftime(i-1))
        if (idiff.gt.idiffmax) then
          write(*,*) 'FLEXTRA WARNING: TIME DIFFERENCE BETWEEN TWO'
          write(*,*) 'WIND FIELDS IS TOO BIG FOR TRAJECTORY CALCULATION.
     &               '
          write(*,*) 'THEREFORE, TRAJECTORIES HAVE TO BE SKIPPED.'
        else if (idiff.gt.idiffnorm) then
          write(*,*) 'FLEXTRA WARNING: TIME DIFFERENCE BETWEEN TWO'
          write(*,*) 'WIND FIELDS IS BIG. THIS MAY CAUSE A DEGRADATION'
          write(*,*) 'OF TRAJECTORY QUALITY.'
        endif
350     continue

      do 360 k=1,numbnests
        if (numbwfn(k).ne.numbwf) then
          write(*,*) 'FLEXTRA ERROR: THE AVAILABLE FILES FOR THE'
          write(*,*) 'NESTED WIND FIELDS ARE NOT CONSISTENT WITH'
          write(*,*) 'THE AVAILABLE FILE OF THE MOTHER DOMAIN.  '
          write(*,*) 'ERROR AT NEST LEVEL: ',k
          goto 1000
        endif
        do 360 i=1,numbwf
          if (wftimen(k,i).ne.wftime(i)) then
            write(*,*) 'FLEXTRA ERROR: THE AVAILABLE FILES FOR THE'
            write(*,*) 'NESTED WIND FIELDS ARE NOT CONSISTENT WITH'
            write(*,*) 'THE AVAILABLE FILE OF THE MOTHER DOMAIN.  '
            write(*,*) 'ERROR AT NEST LEVEL: ',k
            goto 1000
          endif
360       continue


C Reset the times of the wind fields that are kept in memory to no time
***********************************************************************

      do 30 i=1,3
        memind(i)=i
30      memtime(i)=999999999

      return    

998   write(*,*) ' #### TRAJECTORY MODEL ERROR! FILE #### '
      write(*,'(a)') '     '//path(numpath+2*(k-1)+2)
     +(1:len(numpath+2*(k-1)+2))
      write(*,*) ' #### CANNOT BE OPENED             #### '
      error=.true.
      return

999   write(*,*) ' #### TRAJECTORY MODEL ERROR! FILE #### '
      write(*,'(a)') '     '//path(4)(1:len(4))
      write(*,*) ' #### CANNOT BE OPENED             #### '
1000  error=.true.

      return
      end

      subroutine readpoints(error)
***********************************************************************
*                                                                     * 
*             TRAJECTORY MODEL SUBROUTINE READPOINTS                  *
*                                                                     *
***********************************************************************
*                                                                     * 
*             AUTHOR:      G. WOTAWA                                  *
*             DATE:        1994-02-03                                 *
*             LAST UPDATE: 1996-06-21 A. Stohl                        *
*                                                                     * 
* Update: Vertical coordinate can now be given in meters above sea    * 
* level, meters above ground, and in hPa.                             * 
*                                                                     * 
*     10 January 1999  Update to facilitate free formatted input      *
*     (P. Seibert + A. Stohl)                                         *
*                                                                     * 
***********************************************************************
*                                                                     *
* DESCRIPTION:                                                        *
*                                                                     *
* READING OF TRAJECTORY STARTING/ENDING POINTS FROM DATA FILE         *
*                                                                     * 
* LINE                  a line of text                                * 
* NUMPOINT              number of trajectory starting/ending points   *
* XPOINT(maxpoint)      x-coordinates of starting/ending points       *
* YPOINT(maxpoint)      y-coordinates of starting/ending points       *
* ZPOINT(maxpoint)      z-coordinates of starting/ending points       *
* KINDZ(maxpoint)       kind of z coordinate (1:masl, 2:magl, 3:hPa)  *
* KIND(maxpoint)        kind of trajectory                            *
* COMPOINT(maxpoint)    comment for trajectory output                 *
*                                                                     *
***********************************************************************
*
      include 'includepar'
      include 'includecom'

      integer isum
      logical error,old
      integer kindhelp,kindzhelp
      real xhelp,yhelp,zhelp
      character*45 comhelp,line

      error=.false.
*
* OPENING OF FILE 'STARTPOINTS'
*

      open(unitpoin,file=path(1)(1:len(1))//'STARTPOINTS',
     &     status='old',err=999)

C Check the format of the STARTPOINTS file (either in free format,
C or using formatted mask)
C Use of formatted mask is assumed if line 28 contains the word '____'
**********************************************************************

      call skplin(27,unitpoin)
      read (unitpoin,901) line
901   format (a)
      if (index(line,'____') .eq. 0) then
        old = .false.
      else
        old = .true.
      endif
      rewind(unitpoin)

*
* READING OF STARTING/ENDING POINTS OF TRAJECTORIES
*
      call skplin(26,unitpoin)

10    continue
      isum=0
100   read(unitpoin,*,err=998,end=25) xhelp
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=25) yhelp
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=25) kindhelp
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=25) kindzhelp
      if (old) call skplin(2,unitpoin)
      read(unitpoin,*,err=998,end=25) zhelp
      if (old) call skplin(2,unitpoin)
      if (old) then
        read(unitpoin,'(a40)',err=998,end=25) comhelp(1:40)
      else
        read(unitpoin,*,err=998,end=25) comhelp(1:40)
      endif
      if (old) call skplin(1,unitpoin)
      call skplin(1,unitpoin)

      if((xhelp.eq.0.).and.(yhelp.eq.0.).and.
     &   (zhelp.eq.0.).and.(comhelp(1:8).eq.' '))
     &   goto 25


      if ((kindhelp.eq.3).and.(kindzhelp.ne.2)) then
        write(*,*) ' #### FLEXTRA MODEL ERROR! FOR MIXING LAYER   #### '
        write(*,*) ' #### TRAJECTORIES, THE Z COORDINATE MUST BE  #### '
        write(*,*) ' #### GIVEN IN METERS ABOVE GROUND.           #### '
        error=.true.
        return
      endif
  

      isum=isum+1
      if(isum.gt.maxpoint.or.isum*(numbunc+1).gt.maxpoint) then
         error=.true.
         write(*,*) '#### TRAJECTORY MODEL SUBROUTINE READPOINTS: '//
     &              '#### '
         write(*,*) '#### ERROR - TOO MANY STARTING POINTS        '//
     &              '#### '
         write(*,*) '#### REDUCE NUMBER OF STARTING POINTS OR     '//
     &              '#### '
         write(*,*) '#### CHANGE PARAMETERIZATION OF TRAJECTORY   '//
     &              '#### '
         write(*,*) '#### MODEL !!!                               '//
     &              '#### '
         goto 25
      endif
      xpoint(isum)=xhelp
      ypoint(isum)=yhelp
      kind(isum)=kindhelp
      kindz(isum)=kindzhelp
      zpoint(isum)=zhelp
C Conversion from hPa to Pa, if z coordinate is given in pressure units
      if (kindz(isum).eq.3) zpoint(isum)=zpoint(isum)*100. 
      compoint(isum)(1:40)=comhelp(1:40)
      goto 100
1     format(1x,a17,i6,a28)
25    close(unitpoin)
      numpoint=isum

      if ((numpoint*(numbunc+1)*(abs(lentra)/interv+1)).gt.maxtra) then
        write(*,*) ' #### TRAJECTORY MODEL ERROR! MODEL CAN NOT   #### ' 
        write(*,*) ' #### KEEP SO MANY TRAJECTORIES IN MEMORY.    #### '
        write(*,1) ' #### MAXIMUM:   ',maxtra,'                     ####
     + '
        write(*,1) ' #### CURRENTLY: ',numpoint*(numbunc+1)*(abs(lentra)
     +  /interv+1),'                      #### '
        write(*,*) ' #### YOU HAVE 3 POSSIBILITIES:               #### '
        write(*,*) ' #### 1) REDUCE NUMBER OF STARTING POINTS     #### '
        write(*,*) ' ####    (FILE "STARTPOINTS").                #### '
        write(*,*) ' #### 2) REDUCE THE LENGTH OF AN INDIVIDUAL   #### '
        write(*,*) ' ####    TRAJECTORY (FILE "COMMAND").         #### '
        write(*,*) ' #### 3) INCREASE THE TIME INTERVAL BETWEEN   #### '
        write(*,*) ' ####    TRAJECTORY STARTING TIMES (FILE      #### '
        write(*,*) ' ####    "COMMAND").                          #### '
        error=.true.
      endif


      return

998   error=.true.
         write(*,*) '#### TRAJECTORY MODEL SUBROUTINE READPOINTS: '//
     &              '#### '
         write(*,*) '#### FATAL ERROR - FILE "STARTPOINTS" IS     '//
     &              '#### '
         write(*,*) '#### CORRUPT. PLEASE CHECK YOUR INPUTS FOR   '//
     &              '#### '
         write(*,*) '#### MISTAKES OR GET A NEW "STARTPOINTS"-    '//
     &              '#### '
         write(*,*) '#### FILE ...                                '//
     &              '#### '
      return

999   error=.true.
      write(*,*)  
      write(*,*) ' ###########################################'//
     &           '###### '
      write(*,*) '    TRAJECTORY MODEL SUBROUTINE READPOINTS: '
      write(*,*)
      write(*,*) ' FATAL ERROR - FILE CONTAINING TRAJECTORY ST'//
     &           'ARTING '
      write(*,*) ' AND ENDING POINTS IS NOT AVAILABLE OR YOU A'//
     &           'RE NOT'
      write(*,*) ' PERMITTED FOR ANY ACCESS                   '
      write(*,*) ' ###########################################'//
     &           '###### '

      return
      end

      real function eta(psurf,pconst)
******************************************************************************
*                                                                            *
*     This routine computes vertical coordinate eta for a given pressure p.  *
*                                                                            *
*     Author: A. Stohl                                                       *
*                                                                            *
*      5 April 1994                                                          *
*      Last modification: G. Wotawa, 1994 - 04 -27                           *
*                                                                            *
******************************************************************************
* Variables:                                                                 *
* eta                   value of eta for given pressure                      *
* fract                 help variable for linear interpolation               *
* plevel1 [Pa]          pressure of level below wanted pressure              *
* plevel2 [Pa]          pressure of level above wanted pressure              *
* pconst [Pa]           pressure level of isobaric trajectory                *
* psurf [Pa]            surface level pressure                               *
* wheight(nwzmax)       height of ecmwf layer interfaces (eta coordinates)   *
******************************************************************************

      include 'includepar'
      include 'includecom'

      integer i
      real plevel1,plevel2,fract,psurf,pconst
      
      plevel1=akm(1)+bkm(1)*psurf
      if (plevel1.le.pconst) then  ! pressure higher than surface pressure
        eta=wheight(1)
      else                         ! normal case -> linear interpolation
        do 10 i=2,nwz              ! look, between which layers we are
          plevel2=akm(i)+bkm(i)*psurf
          if (plevel2.lt.pconst) then
            fract=(pconst-plevel2)/(plevel1-plevel2)
            eta=wheight(i)*(1.-fract)+wheight(i-1)*fract
            goto 100
          endif
10        plevel1=plevel2
        eta=wheight(nwz)           ! pressure lower than highest model layer
      endif

100   continue


      if (eta.gt.heightmax) eta=heightmax
      if (eta.lt.heightmin) eta=heightmin

      return
      end

      subroutine lininterpol(yy,nxmax,nymax,nzmax,nx,ny,nz,memind,
     +height,xt,yt,zt,itime1,itime2,itime,indexf,yint)
C                            i    i     i     i   i  i  i    i 
C       i    i  i  i    i      i      i     i    o
*****************************************************************************
*                                                                           *
*  Interpolation of 3-dimensional meteorological fields.                    *
*  In horizontal direction bilinear interpolation interpolation is used.    *
*  In the vertical and temporally a linear interpolation is used.           *
*                                                                           *
*  1,1 is the level below current position for the first time               *
*  1,2 is the level above current position for the first time               *
*  2,1 is the level below current position for the second time              *
*  2,2 is the level above current position for the second time              *
*                                                                           *
*                                                                           *
*     Author: A. Stohl                                                      *
*                                                                           *
*     30 May 1994                                                           *
*                                                                           *
*****************************************************************************
*                                                                           *
* Variables:                                                                *
*                                                                           *
* dt1,dt2              time differences between fields and current position *
* dz1,dz2              z distance between levels and current position       *
* height(nzmax)        heights of the model levels                          *
* indexf                indicates the number of the wind field to be read in *
* indexfh               help variable                                        *
* indz                 the level closest to the current trajectory position *
* indzh                help variable                                        *
* itime                current time                                         *
* itime1               time of the first wind field                         *
* itime2               time of the second wind field                        *
* ix,jy                x,y coordinates of lower left subgrid point          *
* memind(3)            points to the places of the wind fields              *
* nx,ny,nz             actual field dimensions in x,y and z direction       *
* nxmax,nymax,nzmax    maximum field dimensions in x,y and z direction      *
* xt                   current x coordinate                                 *
* yint                 the final interpolated value                         *
* yt                   current y coordinate                                 *
* yy(0:nxmax-1,0:nymax-1,nzmax,3)meteorological field used for interpolation*
* zt                   current z coordinate                                 *
*                                                                           *
*****************************************************************************

      implicit none

      integer nx,ny,nz,nxmax,nymax,nzmax,memind(3),i,m,n,ix,jy,ixp,jyp
      integer itime,itime1,itime2,indexf,indz,indexfh,indzh
      real yy(0:nxmax-1,0:nymax-1,nzmax,3),height(nzmax)
      real ddx,ddy,rddx,rddy,dz1,dz2,dt1,dt2,y(2),yh(2)
      real xt,yt,zt,yint
     

C Determine the level below the current position
************************************************

      do 5 i=1,nz-1
        if ((height(i).le.zt).and.(height(i+1).ge.zt)) then
          indz=i
          goto 6
        endif
5       continue
6     continue


C If point at border of grid -> small displacement into grid
************************************************************

      if (xt.ge.float(nx-1)) xt=float(nx-1)-0.00001
      if (yt.ge.float(ny-1)) yt=float(ny-1)-0.00001



***********************************************************************
C 1.) Bilinear horizontal interpolation
C This has to be done separately for 6 fields (Temporal(2)*Vertical(3))
***********************************************************************

C Determine the lower left corner and its distance to the current position
************************************************************************** 

      ix=int(xt)
      jy=int(yt)
      ixp=ix+1
      jyp=jy+1
      ddx=xt-float(ix)
      ddy=yt-float(jy)
      rddx=1.-ddx
      rddy=1.-ddy
     

C Vertical distance to the level below and above current position
*****************************************************************

      dz1=zt-height(indz)
      dz2=height(indz+1)-zt


C Loop over 2 time steps and 2 levels
*************************************
 
      do 10 m=1,2
        indexfh=memind(indexf+m-1)
        do 20 n=1,2
          indzh=indz+n-1

20        y(n)=rddx*rddy*yy(ix ,jy ,indzh,indexfh)
     +        + ddx*rddy*yy(ixp,jy ,indzh,indexfh)
     +        +rddx* ddy*yy(ix ,jyp,indzh,indexfh)
     +        + ddx* ddy*yy(ixp,jyp,indzh,indexfh)



***********************************
C 2.) Linear vertical interpolation
***********************************

10      yh(m)=(dz2*y(1)+dz1*y(2))/(dz1+dz2)

         

*************************************
C 3.) Temporal interpolation (linear)
*************************************

      dt1=float(itime-itime1)
      dt2=float(itime2-itime)

      yint=(yh(1)*dt2+yh(2)*dt1)/(dt1+dt2)


      return
      end

      subroutine intermix(xt,yt,zt,zconst,indexf,itime,iter,ngrid,
     +uint,vint)
C                         i  i  i    i      i     i    i      i
C      o    o
********************************************************************************
*                                                                              *
*     Interpolation routine for mixing layer trajectories.                     *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     27 April 1994                                                            *
*                                                                              *
*     Update: 23 December 1998 (Use of global domain and nesting)              *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* firstep            .true. for first iteration of petterssen                  *
* hmix               height of mixing layer in eta coordinates                 *
* idiff [s]          Temporal distance between the windfields used for interpol*
* induvz             index of the model layer beneath current position of traj.*
* init               .true. for first time step of trajectory                  *
* iter               number of iteration step                                  *
* itime [s]          current temporal position                                 *
* memtime(3) [s]     times of the wind fields in memory                        *
* pp [Pa]            pressure at mixing height                                 *
* ngrid              index which grid is to be used                            *

* nstop              =greater 0, if trajectory calculation is finished         *
* uint,vint [m/s]    interpolated wind components                              *
* xt,yt,zt           coordinates position for which wind data shall be calculat*
* zconst [m]         height of mixing layer                                    *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer i,itime,indexf,induvz,iter,ngrid
      real xt,yt,zt,zconst,uint,vint,uhelp,vhelp,qhelp
      real psint,xtn,ytn,hmix,weight,pp,ph1,ph2


C Determine nested grid coordinates
***********************************

      if (ngrid.gt.0) then
        xtn=(xt-xln(ngrid))*xresoln(ngrid)
        ytn=(yt-yln(ngrid))*yresoln(ngrid)
      endif


C Transformation from mixing height in [m] coordinate to height in eta coordinate.
C For this it is necessary to know the surface pressure.
**********************************************************************************

      if (ngrid.gt.0) then         ! nested grid
        call levlininterpoln(psn,maxnests,nxmaxn,nymaxn,1,ngrid,
     +  nxn,nyn,memind,xtn,ytn,1,memtime(indexf),memtime(indexf+1),
     +  itime,indexf,psint)
        hmix=zconst
        call etatrafo(xtn,ytn,hmix,memtime(indexf),memtime(indexf+1),
     +  itime,indexf,ngrid,psint)
      else                         ! mother grid
        call levlininterpol(ps,nxmax,nymax,1,nx,ny,memind,
     +  xt,yt,1,memtime(indexf),memtime(indexf+1),itime,indexf,psint)
        hmix=zconst
        call etatrafo(xt,yt,hmix,memtime(indexf),memtime(indexf+1),
     +  itime,indexf,ngrid,psint)
      endif


C Calculate the index of layers between which the mixed layer height is situated.
*********************************************************************************

      do 85 induvz=1,nuvz-1
        if (uvheight(induvz).ge.hmix) goto 86
85      continue
86    continue

C Mixed layer height is located between uvheight(induvz-1) and uvheight(induvz)
*******************************************************************************

C 1.) If mixed layer height is lower than the first model level
C     -> take wind data from first model level
***************************************************************

      if (induvz.eq.1) then
        zt=uvheight(1)
        if (ngrid.eq.0) then       ! mother grid
        if ((inpolkind.eq.1).and.(iter.ne.1)) then
          call levinterpol(uu,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,1,memtime(indexf),memtime(indexf+1),itime,
     +    indexf,uint)
          call levinterpol(vv,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,1,memtime(indexf),memtime(indexf+1),itime,
     +    indexf,vint)
        else                               ! linear interpolation
          call levlininterpol(uu,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,1,memtime(indexf),memtime(indexf+1),itime,
     +    indexf,uint)
          call levlininterpol(vv,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,1,memtime(indexf),memtime(indexf+1),itime,
     +    indexf,vint)
        endif

      else if (ngrid.gt.0) then      ! nested grid

        if ((inpolkind.eq.1).and.(iter.ne.1)) then
          call levinterpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,1,memtime(indexf),memtime(indexf+1),
     +    itime,indexf,uint)
          call levinterpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,1,memtime(indexf),memtime(indexf+1),
     +    itime,indexf,vint)
        else                               ! linear interpolation
          call levlininterpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,1,memtime(indexf),memtime(indexf+1),
     +    itime,indexf,uint)
          call levlininterpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,1,memtime(indexf),memtime(indexf+1),
     +    itime,indexf,vint)
        endif

        else                       ! polar stereographic grid
                                   ! only linear interpolation used
          call levlininterpol(uupol,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,1,memtime(indexf),memtime(indexf+1),itime,
     +    indexf,uint)
          call levlininterpol(vvpol,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,1,memtime(indexf),memtime(indexf+1),itime,
     +    indexf,vint)
        endif


C 2.) Normal case: mixed layer higher than the first model level
C     -> take average wind within mixed layer for trajectory displacement
*************************************************************************

      else
        weight=0.
        uhelp=0.
        vhelp=0.
        qhelp=0.
        ph1=psint

        do 140 i=1,induvz-2

C Interpolation of wind field data is done.
C -> Interpolated winds are weighted with the thicknesses of the layers
***********************************************************************

          if (ngrid.eq.0) then       ! mother grid
          if ((inpolkind.eq.1).and.(iter.ne.1)) then
            call levinterpol(uu,nxmax,nymax,nuvzmax,nx,ny,memind,
     +      xt,yt,i,memtime(indexf),memtime(indexf+1),itime,
     +      indexf,uint)
            call levinterpol(vv,nxmax,nymax,nuvzmax,nx,ny,memind,
     +      xt,yt,i,memtime(indexf),memtime(indexf+1),itime,
     +      indexf,vint)
          else                               ! bilinear interpolation
            call levlininterpol(uu,nxmax,nymax,nuvzmax,nx,ny,memind,
     +      xt,yt,i,memtime(indexf),memtime(indexf+1),itime,
     +      indexf,uint)
            call levlininterpol(vv,nxmax,nymax,nuvzmax,nx,ny,memind,
     +      xt,yt,i,memtime(indexf),memtime(indexf+1),itime,
     +      indexf,vint)
          endif

          else if (ngrid.gt.0) then      ! nested grid
            if ((inpolkind.eq.1).and.(iter.ne.1)) then
          call levinterpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,i,memtime(indexf),memtime(indexf+1),
     +    itime,indexf,uint)
          call levinterpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,i,memtime(indexf),memtime(indexf+1),
     +    itime,indexf,vint)
            else                               ! linear interpolation
          call levlininterpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,i,memtime(indexf),memtime(indexf+1),
     +    itime,indexf,uint)
          call levlininterpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +    nxn,nyn,memind,xtn,ytn,i,memtime(indexf),memtime(indexf+1),
     +    itime,indexf,vint)
            endif

          else                       ! polar stereographic grid
                                     ! only linear interpolation used
            call levlininterpol(uupol,nxmax,nymax,nuvzmax,nx,ny,memind,
     +      xt,yt,i,memtime(indexf),memtime(indexf+1),itime,
     +      indexf,uint)
            call levlininterpol(vvpol,nxmax,nymax,nuvzmax,nx,ny,memind,
     +      xt,yt,i,memtime(indexf),memtime(indexf+1),itime,
     +      indexf,vint)
          endif
          ph2=akm(i+1)+bkm(i+1)*psint
          weight=weight+ph1-ph2
          uhelp=uhelp+uint*(ph1-ph2)
          vhelp=vhelp+vint*(ph1-ph2)
140       ph1=ph2


        if (ngrid.eq.0) then         ! mother grid
        if ((inpolkind.eq.1).and.(iter.ne.1)) then
          call levinterpol(uu,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,induvz-1,memtime(indexf),memtime(indexf+1),itime,
     +    indexf,uint)
          call levinterpol(vv,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,induvz-1,memtime(indexf),memtime(indexf+1),itime,
     +    indexf,vint)
        else                               ! bilinear interpolation
          call levlininterpol(uu,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,induvz-1,memtime(indexf),memtime(indexf+1),itime,
     +    indexf,uint)
          call levlininterpol(vv,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,induvz-1,memtime(indexf),memtime(indexf+1),itime,
     +    indexf,vint)
        endif

        else if (ngrid.gt.0) then      ! nested grid

          if ((inpolkind.eq.1).and.(iter.ne.1)) then
            call levinterpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +      nxn,nyn,memind,xtn,ytn,induvz-1,memtime(indexf),
     +      memtime(indexf+1),itime,indexf,uint)
            call levinterpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,ngrid,
     +      nxn,nyn,memind,xtn,ytn,induvz-1,memtime(indexf),
     +      memtime(indexf+1),itime,indexf,vint)
          else                               ! linear interpolation
            call levlininterpoln(uun,maxnests,nxmaxn,nymaxn,nuvzmax,
     +      ngrid,nxn,nyn,memind,xtn,ytn,induvz-1,memtime(indexf),
     +      memtime(indexf+1),itime,indexf,uint)
            call levlininterpoln(vvn,maxnests,nxmaxn,nymaxn,nuvzmax,
     +      ngrid,nxn,nyn,memind,xtn,ytn,induvz-1,memtime(indexf),
     +      memtime(indexf+1),itime,indexf,vint)
          endif

        else                         ! polar stereographic grid
                                     ! only linear interpolation used
          call levlininterpol(uupol,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,induvz-1,memtime(indexf),memtime(indexf+1),itime,
     +    indexf,uint)
          call levlininterpol(vvpol,nxmax,nymax,nuvzmax,nx,ny,memind,
     +    xt,yt,induvz-1,memtime(indexf),memtime(indexf+1),itime,
     +    indexf,vint)
        endif
        ph2=pp(psint,hmix)
        weight=weight+ph1-ph2
        uhelp=uhelp+uint*(ph1-ph2)
        vhelp=vhelp+vint*(ph1-ph2)

        uint=uhelp/weight
        vint=vhelp/weight
      endif
      zt=hmix

      return
      end

      subroutine getfields(firststep,itime,indexf,idiff,nstop)
C                              i       i     o      o     o
********************************************************************************
*                                                                              *
*  This subroutine manages the 3 data fields to be kept in memory.             *
*  During the first time step of petterssen it has to be fulfilled that the    *
*  first data field must have |wftime|<itime, i.e. the absolute value of wftime*
*  must be smaller than the absolute value of the current time in [s].         *
*  The other 2 fields are the next in time after the first one.                *
*  Pointers (memind) are used, because otherwise one would have to resort the  *
*  wind fields, which costs a lot of computing time. Here only the pointers are*
*  resorted.                                                                   *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     29 April 1994                                                            *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* firststep            .true. for first time step of petterssen, else .false.  *
* idiff [s]            time difference between the two wind fieldse read in    *
* indj                 indicates the number of the wind field to be read in    *
* indmin               remembers the number of wind fields already treated     *
* memind(3)            pointer, on which place the wind fields are stored      *
* memtime(3) [s]       times of the wind fields, which are kept in memory      *
* itime [s]            current time since start date of trajectory calculation *
* ldirect              1 for forward trajectories, -1 for backward trajectories*
* nstop                > 0, if trajectory has to be terminated                 *
* nx,ny,nuvz,nwz       field dimensions in x,y and z direction                 *
* uu(0:nxmax-1,0:nymax-1,nuvzmax,3)   wind components in x-direction [m/s]     *
* vv(0:nxmax-1,0:nymax-1,nuvzmax,3)   wind components in y-direction [m/s]     *
* ww(0:nxmax-1,0:nymax-1,nwzmax,3)wind components in z-direction [deltaeta/s]  *
* tt(0:nxmax-1,0:nymax-1,nuvzmax,3)   temperature [K]                          *
* ps(0:nxmax-1,0:nymax-1,3)           surface pressure [Pa]                    *
*                                                                              *
* Constants:                                                                   *
* idiffnorm            normal time difference between 2 wind fields            *
* idiffmax             maximum allowable time difference between 2 wind fields *
*                                                                            *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer indj,indmin,l,itime,indexf,idiff,nstop,memhelp
      logical firststep
      save indmin

      data indmin/1/

 
C Check, if wind fields are available for the current time step
***************************************************************

      if ((ldirect*wftime(1).ge.ldirect*itime).or.
     +(ldirect*wftime(numbwf).le.ldirect*itime)) then
        write(*,*) 'FLEXTRA WARNING: NO WIND FIELDS ARE AVAILABLE.'
        write(*,*) 'A TRAJECTORY HAS TO BE TERMINATED.'
        nstop=4
        return
      endif


******************************************************************************
C For the first time step of petterssen, arrange the wind fields in such a way
C that 1st wind field is before itime and 2nd and 3rd are after itime.
******************************************************************************

      if (firststep) then
        if ((ldirect*memtime(1).lt.ldirect*itime).and.
     +  (ldirect*memtime(2).ge.ldirect*itime)) then

C The right wind fields are already in memory -> don't do anything
******************************************************************

          continue

        else if ((ldirect*memtime(2).lt.ldirect*itime).and.
     +  (ldirect*memtime(3).ge.ldirect*itime)) then


C Current time is between 2nd and 3rd wind field
C -> Resort wind field pointers, so that current time is between 1st and 2nd
****************************************************************************

          memhelp=memind(1)
          do 10 l=1,2
            memind(l)=memind(l+1)
10          memtime(l)=memtime(l+1)
          memind(3)=memhelp


C Read a new wind field and store it on place memind(3)
*******************************************************

          do 30 indj=indmin,numbwf-2
            if ((ldirect*wftime(indj).lt.ldirect*itime).and.
     +      (ldirect*wftime(indj+1).ge.ldirect*itime)) then
              call readwind(indj+2,memind(3))
              call readwind_nests(indj+2,memind(3))
              memtime(3)=wftime(indj+2)
              goto 40
            endif
30          continue
40        indmin=indj

        else

C No wind fields, which can be used, are currently in memory 
C -> read all 3 wind fields
************************************************************

          do 50 indj=indmin,numbwf-1
            if ((ldirect*wftime(indj).lt.ldirect*itime).and.
     +      (ldirect*wftime(indj+1).ge.ldirect*itime)) then
              memind(1)=1
              call readwind(indj,memind(1))
              call readwind_nests(indj,memind(1))
              memtime(1)=wftime(indj)
              memind(2)=2
              call readwind(indj+1,memind(2))
              call readwind_nests(indj+1,memind(2))
              memtime(2)=wftime(indj+1)
              memind(3)=3
              call readwind(indj+2,memind(3))
              call readwind_nests(indj+2,memind(3))
              memtime(3)=wftime(indj+2)
              goto 60
            endif
50          continue
60        indmin=indj

        endif

        indexf=1
        idiff=abs(memtime(2)-memtime(1))


*****************************************************************************
C For 2nd step of petterssen all necessary data fields are already in memory.
C Just look, if current temporal position is between the first two fields or
C between the 2nd and 3rd field.
*****************************************************************************

      else
        if ((ldirect*memtime(1).lt.ldirect*itime).and.    !between 1st and 2nd
     +  (ldirect*memtime(2).ge.ldirect*itime)) then
          indexf=1
          idiff=abs(memtime(2)-memtime(1))
        else if ((ldirect*memtime(2).lt.ldirect*itime).and. !between 2nd and 3rd
     +  (ldirect*memtime(3).ge.ldirect*itime)) then
          indexf=2
          idiff=abs(memtime(3)-memtime(2))
        endif
      endif

C Check the time difference between the wind fields. If it is too 
C big, terminate the trajectory. 
******************************************************************

      if (idiff.gt.idiffmax) nstop=3

      return
      end

      subroutine timemanager()                                  

********************************************************************************
*                                                                              *
* Handles the computation of trajectories, i.e. determines which               *
* trajectories have to be computed at what time.                               *
*                                                                              *
* Pointers (field numb(maxtra) are used to keep track of the trajectories.     *
* The pointers are kept sorted in the order of the next necessary time step,   *
* i.e., numb(1) points to the first trajectory that needs a time step.         *
* After doing the time step, the pointers are resorted, e.g., numb(2)          *
* changes to numb(1), numb(3) to numb(2), etc. Numb(1) is inserted between     *
* those two pointers, which need a time step before and after numb(1).         *
*                                                                              *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     6 February 1994                                                          *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* ideltas [s]        modelling period                                          *
* init               .true. for first time step of trajectory, false .else.    *
* interv [s]         interval between two trajectory starting times            *
* itime [s]          actual temporal position of calculation                   *
* ittra(maxtra,maxtime) temporal positions of trajectories                     *
* kind(maxtra)       type of trajectory (e.g. isobaric, 3-d, model layers,..)  *
* kindz(maxtra)      unit of height coordinate (1:masl, 2:magl, 3:hPa)         *
* ldirect            Temporal direction of trajectories (-1=backward,1=forward)*
* lentra             temporal length of one trajectory                         *
* levmem(maxtra) [K] height of isentropic trajectories                         *
* minstep            minimum time step (to prevent exceedance of dimensions)   *
* nextflight [s]     next time, initialization of FLIGHT trajectories is due   *
* npoint(maxtra)     index, which starting point the trajectory has            *
* nstop              = greater than 0 when trajectory calculation is finished  *
* ntstep [s]         time step of integration scheme                           *
* nttra(maxtra)      number of time steps which are already computed           *
* numb(maxtra)       pointer, which allows the identification of trajectories  *
* number             help variable                                             *
* numtra             actual number of trajectories in memory                   *
* xpoint(maxpoint), ypoint(maxpoint),zpoint(maxpoint) =                        *
* xpoint(maxpoint), ypoint(maxpoint),zpoint(maxpoint) =                        *
*                    starting positions of trajectories                        *
* xtra(maxtra,maxtime), ytra(maxtra,maxtime), ztra(maxtra,maxtime) =           *
*                    spatial positions of trajectories                         *
*                                                                              *
* Constants:                                                                   *
* maxtra             maximum number of trajectories                            *
* maxtime            maximum number of time steps                              *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer i,j,itime,ntstep,nstop(maxtra),lhelp,minstep,numb(maxtra)
      integer number,idummy,ldat,ltim,ninterv1,ninterv2,ninterv3
      real levmem(maxtra),gasdev
      logical init,unc,error
      double precision juldate
      save idummy

      data idummy/-7/


      do 5 i=1,maxtra
5       nttra(i)=0
      numtra=0                                      ! first: no trajectories


C Loop over the whole modelling period in time steps of seconds
***************************************************************

      do 10 itime=0,ideltas,ldirect
        if (mod(itime,3600).eq.0) write(*,*) itime,' SECONDS SIMULATED'


C Check whether some trajectories have already finished. If so, call output
C and make memory available for new trajectory.
***************************************************************************

        if (numtra.gt.0) then

          i=1
33        continue
          number=numb(i)
       
          if (abs(ittra(number,nttra(number))).gt.abs(itime)) goto 37
          if ((nstop(number).gt.0).and.               ! trajectory terminated
     +       (ittra(number,nttra(number)).eq.itime)) then     ! output time
c           if (modecet.ne.2) then                    ! don't make output for CETs
              call trajout(number,nstop(number))      ! output of trajectory
              nttra(number)=0                         ! reinitialize
              do 35 j=i,numtra-1                      ! resort the pointers
35              numb(j)=numb(j+1)
c           endif
            numtra=numtra-1                           ! forget one trajectory
            i=i-1
          endif
          if (i.lt.numtra) then
            i=i+1
            goto 33
          else
            goto 37 
          endif

37        continue
        endif



C Check whether new trajectories have to be started
C 1nd if: check if time within modeling period
C 2nd if: check if the interval interv has passed by (for NORMAL
C         trajectories) or if a FLIGHT traj. is due to be started
*****************************************************************

        if (abs(itime).le.abs(ideltas-lentra)) then
          if (modecet.eq.3) then       ! FLIGHT mode
41          continue
            if ((nextflight.eq.itime).and.(numtra.lt.maxtra)) then
              do 43 i=numtra,1,-1         ! shift pointers
43              numb(i+1)=numb(i)
              numtra=numtra+1             ! increase number of traj.

              j=1                         ! initialize FLIGHT traj.
42            continue
              if (nttra(j).eq.0) then
                numb(1)=j
                npoint(j)=1
                levmem(j)=zpoint(1)
                xtra(j,1)=xpoint(1)
                ytra(j,1)=ypoint(1)
                ztra(j,1)=zpoint(1)
                ittra(j,1)=itime
                nttra(j)=1
                kind(j)=kind(1)
                kindz(j)=kindz(1)
              else 
                j=j+1
                if (j.gt.maxtra) stop 'timemanager: too many trajectorie
     +s. Increase parameter maxtra and re-start'
                goto 42
              endif

C Read the next FLIGHT traj. 
****************************

              read(unitpoin,*,err=15,end=15) ldat,ltim
              read(unitpoin,*,err=15,end=15) xpoint(1)
              read(unitpoin,*,err=15,end=15) ypoint(1)
              read(unitpoin,*,err=15,end=15) zpoint(1)
              read(unitpoin,*,err=15,end=15)
              nextflight=nint(sngl(juldate(ldat,ltim)-bdate)*86400.)
              call coordtrafo(error)
              if (error) stop
              call subtractoro()
              if (kindz(1).eq.3) zpoint(1)=zpoint(1)*100.

              goto 41
            endif

          else if (mod(itime,interv).eq.0) then !non-FLIGHT mode, initialization due
            do 40 i=numtra,1,-1                       ! shift pointers
40            numb(i+numpoint)=numb(i)
            numtra=numtra+numpoint                    ! increase number of traj.


C Initialize new trajectories
*****************************

            j=1
            do 50 i=1,numpoint        ! search for available memory
55            continue
              if (nttra(j).eq.0) then
                numb(i)=j
                npoint(j)=i
                levmem(j)=zpoint(i)
                xtra(j,1)=xpoint(i)
                ytra(j,1)=ypoint(i)
                ztra(j,1)=zpoint(i)
                ittra(j,1)=itime
                nttra(j)=1
                kind(j)=kind(i)
                kindz(j)=kindz(i)
                randerroru(j)=gasdev(idummy)*epsu
                randerrorv(j)=gasdev(idummy)*epsv
                randerrorw(j)=gasdev(idummy)*epsw
              else 
                j=j+1
                goto 55
              endif
50            continue

          endif
        endif



C Check whether a time step of the first trajectory is necessary
****************************************************************

15      continue
        if (numtra.gt.0) then
        
        number=numb(1)

        if (ittra(number,nttra(number)).eq.itime) then

C minstep is the minimum possible time step. It is necessary to 
C guarantee that the sum of all time steps along the trajectory
C is smaller than maxtime (otherwise exceedance of dimensions).
***************************************************************

          lhelp=itime-ittra(number,1)         ! "age" of trajectory
          minstep=abs(lentra-lhelp)/(maxtime-nttra(number))+1


C Mark first time step of trajectory with variable init=.TRUE.
**************************************************************

          if (nttra(number).eq.1) then
            init=.true.
          else
            init=.false.
          endif


C Determine whether current trajectory is an uncertainty trajectory
*******************************************************************

          if (compoint(npoint(number))(41:41).eq.'U') then
            unc=.TRUE.
          else
            unc=.FALSE.
          endif
           

C Calculate the next step of the trajectory
*******************************************

          call petters(minstep,lhelp,itime,xtra(number,nttra(number)),
     +    ytra(number,nttra(number)),ztra(number,nttra(number)),
     +    ptra(number,nttra(number)),htra(number,nttra(number)),
     +    qqtra(number,nttra(number)),pvtra(number,nttra(number)),
     +    thtra(number,nttra(number)),
     +    xtra(number,nttra(number)+1),ytra(number,nttra(number)+1),
     +    ztra(number,nttra(number)+1),ptra(number,nttra(number)+1),
     +    htra(number,nttra(number)+1),qqtra(number,nttra(number)+1),
     +    pvtra(number,nttra(number)+1),thtra(number,nttra(number)+1),
     +    ntstep,nstop(number),
     +    levmem(number),init,kind(number),kindz(number),unc,
     +    randerroru(number),randerrorv(number),randerrorw(number))

          ittra(number,nttra(number)+1)=ittra(number,nttra(number))+
     +    ntstep

          nttra(number)=nttra(number)+1         ! one more time step


C If output is only due with constant time steps, disregard all points
C not needed for interpolation: delete previous time step
**********************************************************************

          if ((inter.eq.1).and.(nttra(number).ge.3)) then
            ninterv1=abs(ittra(number,nttra(number))-ittra(number,1))/
     +      interstep
            ninterv2=abs(ittra(number,nttra(number)-1)-ittra(number,1))/
     +      interstep
            ninterv3=abs(ittra(number,nttra(number)-2)-ittra(number,1))/
     +      interstep
            if ((ninterv1.eq.ninterv2).and.(ninterv1.eq.ninterv3)) then
              ittra(number,nttra(number)-1)=ittra(number,nttra(number))
              xtra(number,nttra(number)-1)=xtra(number,nttra(number))
              ytra(number,nttra(number)-1)=ytra(number,nttra(number))
              ztra(number,nttra(number)-1)=ztra(number,nttra(number))
              ptra(number,nttra(number)-1)=ptra(number,nttra(number))
              htra(number,nttra(number)-1)=htra(number,nttra(number))
              qqtra(number,nttra(number)-1)=qqtra(number,nttra(number))
              pvtra(number,nttra(number)-1)=pvtra(number,nttra(number))
              thtra(number,nttra(number)-1)=thtra(number,nttra(number))
              nttra(number)=nttra(number)-1
            endif
          endif

C If field dimension is reached, trajectory has to be terminated
****************************************************************

          if (nttra(number).eq.maxtime) nstop(number)=5


C If trajectory has ended, give the next time step the time of normal
C length of trajectory and wait for output of trajectory
*********************************************************************

          if (nstop(number).gt.0) then
            ittra(number,nttra(number))=ittra(number,1)+lentra
          endif


C Shift the trajectories in a way that the current trajectory can be
C inserted at the right position.
C The position is determined by the time, when the next integration step
C is necessary.
*************************************************************************

          do 20 i=1,numtra-1
            if (abs(ittra(numb(i+1),nttra(numb(i+1)))).lt.
     +      abs(ittra(number,nttra(number)))) then
              numb(i)=numb(i+1)
            else
              numb(i)=number                      ! insert the pointer
              goto 15                             ! leave loop
            endif
20          continue

C The next statement can only be reached, when the current trajectory is the
C last one that needs an integration step.
****************************************************************************

          numb(numtra)=number
          goto 15                                 ! check next trajectory
        endif
        endif


10     continue

      return
      end

      subroutine subtractoro()
********************************************************************************
*                                                                              *
*   This routine subtracts the height of the orography from the height above   *
*   sea level to give height above the model ground.                           *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     30 April 1994                                                            *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* dist                           distance of starting point to grid points     *
* maxnests                       maximum number of nesting levels              *
* ngrid                          nesting level to be used                      *
* numpoint                       actual number of starting points              *
* oro(0:nxmax-1,0:nymax-1)       orography (mother domain)                     *
* oron(0:nxmaxn-1,0:nymaxn-1,maxnests)  orography (nested grids)               *
* orohelp                        interpolated orography                        *
* sweight                        weight for linear interpolation               *
* xpoint,ypoint,zpoint(maxpoint) x,y,z coordinates of starting points          *
*                                                                              *
* Constants:                                                                   *
* maxpoint                       maximum number of starting points             *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer j,k,ngrid
      real orohelp,xtn,ytn

      
      do 10 k=1,numpoint          ! loop over all starting points

C Only subtract for those trajectories with z coordinates given in masl
***********************************************************************

        if (kindz(k).eq.1) then

C Determine which nesting level to be used
******************************************

          ngrid=0
          do 12 j=numbnests,1,-1
            if ((xpoint(k).gt.xln(j)).and.(xpoint(k).lt.xrn(j)).and.
     +      (ypoint(k).gt.yln(j)).and.(ypoint(k).lt.yrn(j))) then
              ngrid=j
              goto 13
            endif
12          continue
13        continue


C Interpolate orography to position of starting point
*****************************************************

          if (ngrid.eq.0) then
            call orolininterpol(oro,nxmax,nymax,nx,ny,xpoint(k),
     +      ypoint(k),orohelp)
          else
            xtn=(xpoint(k)-xln(ngrid))*xresoln(ngrid)
            ytn=(ypoint(k)-yln(ngrid))*yresoln(ngrid)
            call orolininterpoln(oron,maxnests,nxmaxn,nymaxn,ngrid,
     +      nxn,nyn,xtn,ytn,orohelp)
          endif


C Subtract orography from height, but don't accept negative heights
*******************************************************************

          zpoint(k)=zpoint(k)-orohelp
          zpoint(k)=max(0.,zpoint(k))
        endif
10      continue

      return
      end

      subroutine gridcheck_nests(error)
C                                  o
********************************************************************************
*                                                                              *
*     This routine checks the grid specification for the nested model domains. *
*     It is similar to subroutine gridcheck, which checks the mother domain.   *
*                                                                              *
*     Authors: A. Stohl, G. Wotawa                                             *
*                                                                              *
*     30 December 1998                                                         *
*                                                                      *
*     Updated:                                                         *
*                          2011-06, implemented reading of grib2 format*
*                                   analog to FLEXPART 8.22 routines   *
************************************************************************
      use grib_api

      include 'includepar'
      include 'includecom'

!HSO  parameters for grib_api
      integer ifile
      integer iret
      integer igrib
      integer gribVer,parCat,parNum,typSurf,valSurf,discipl
      integer gotGrib
      character*24 gribErrorMsg
      character*20 gribFunction
!HSO  end

      integer i,j,k,l,ifn,ifield,iumax,iwmax,numskip,nlev_ecn
      integer nuvzn,nwzn
      real akmn(nwzmax),bkmn(nwzmax),akzn(nuvzmax),bkzn(nuvzmax)
      real uvheightn(nuvzmax),wheightn(nwzmax)
      real xaux1,xaux2,yaux1,yaux2
      real*8 xaux1in,xaux2in,yaux1in,yaux2in
      logical error,oronew

* VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

C dimension of isec2 at least (22+n), where n is the number of parallels or
C meridians in a quasi-regular (reduced) Gaussian or lat/long grid

C dimension of zsec2 at least (10+nn), where nn is the number of vertical
C coordinate parameters

      integer isec0(2),isec1(56),isec2(22+nxmaxn+nymaxn),isec3(2)
      integer isec4(64),inbuff(jpack),ilen,iswap,ierr,iword,lunit
      real zsec2(60+2*nuvzmax),zsec3(2),zsec4(jpunp)
      character*1 yoper
!HSO  grib api error messages
      data gribErrorMsg/'Error reading grib file'/
      data gribFunction/'gridcheck_nests'/

      data yoper/'D'/

      error=.false.
      xresoln(0)=1.       ! resolution enhancement for mother grid
      yresoln(0)=1.       ! resolution enhancement for mother grid

C Loop about all nesting levels
*******************************

      do 300 l=1,numbnests
        oronew=.false.

        iumax=0
        iwmax=0
*
        if(ideltas.gt.0) then
          ifn=1
        else
          ifn=numbwf
        endif
*
* OPENING OF DATA FILE (GRIB CODE)
*
        ifile=0
        igrib=0
        iret=0

5       call grib_open_file(ifile,path(numpath+2*(l-1)+1)
     +   (1:len(numpath+2*(l-1)+1))//trim(wfnamen(l,ifn)),'r',iret)
        if (iret.ne.GRIB_SUCCESS) then
          goto 999   ! ERROR DETECTED
        endif

        gotGrib=0
        ifield=0
10        ifield=ifield+1
*
* GET NEXT FIELDS
*
        call grib_new_from_file(ifile,igrib,iret)
        if (iret.eq.GRIB_END_OF_FILE)  then
          goto 30    ! EOF DETECTED
        elseif (iret.ne.GRIB_SUCCESS) then
          goto 999   ! ERROR DETECTED
        endif

!     first see if we read GRIB1 or GRIB2
        call grib_get_int(igrib,'editionNumber',gribVer,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)

        if (gribVer.eq.1) then ! GRIB Edition 1
c     print*,'GRiB Edition 1'
c     read the grib2 identifiers
          call grib_get_int(igrib,'indicatorOfParameter',isec1(6),iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_int(igrib,'level',isec1(8),iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
c     change code for etadot to code for omega
          if (isec1(6).eq.77) then
            isec1(6)=135
          endif
        else
c     print*,'GRiB Edition 2'
c     read the grib2 identifiers
          call grib_get_int(igrib,'discipline',discipl,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_int(igrib,'parameterCategory',parCat,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_int(igrib,'parameterNumber',parNum,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_int(igrib,'typeOfFirstFixedSurface',typSurf,
     +     iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_int(igrib,'level',valSurf,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)

!     convert to grib1 identifiers
          isec1(6)=-1
          isec1(7)=-1
          isec1(8)=-1
          isec1(8)=valSurf     ! level
          if((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.105))then ! T
            isec1(6)=130         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.105))
     +     then ! U
            isec1(6)=131         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.105))
     +     then ! V
            isec1(6)=132         ! indicatorOfParameter
          elseif((parCat.eq.1).and.(parNum.eq.0).and.(typSurf.eq.105))
     +     then ! Q
            isec1(6)=133         ! indicatorOfParameter
          elseif((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.1))then !SP
            isec1(6)=134         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually eta dot
            isec1(6)=135         ! indicatorOfParameter
          elseif((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101))
     +     then !SLP
            isec1(6)=151         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.103))
     +     then ! 10U
            isec1(6)=165         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.103))
     +     then ! 10V
            isec1(6)=166         ! indicatorOfParameter
          elseif((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.103))
     +     then ! 2T
            isec1(6)=167         ! indicatorOfParameter
          elseif((parCat.eq.0).and.(parNum.eq.6).and.(typSurf.eq.103))
     +     then ! 2D
            isec1(6)=168         ! indicatorOfParameter
          elseif((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1))
     +     then ! SD
            isec1(6)=141         ! indicatorOfParameter
          elseif((parCat.eq.6).and.(parNum.eq.1)) then ! CC
            isec1(6)=164         ! indicatorOfParameter
          elseif((parCat.eq.1).and.(parNum.eq.9)) then ! LSP
            isec1(6)=142         ! indicatorOfParameter
          elseif((parCat.eq.1).and.(parNum.eq.10)) then ! CP
            isec1(6)=143         ! indicatorOfParameter
          elseif((parCat.eq.0).and.(parNum.eq.11).and.(typSurf.eq.1))
     +     then ! SHF
            isec1(6)=146         ! indicatorOfParameter
          elseif((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1))
     +     then ! SR
            isec1(6)=176         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.17)) then ! EWSS
            isec1(6)=180         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.18)) then ! NSSS
            isec1(6)=181         ! indicatorOfParameter
          elseif((parCat.eq.3).and.(parNum.eq.4)) then ! ORO
            isec1(6)=129         ! indicatorOfParameter
          elseif((parCat.eq.3).and.(parNum.eq.7)) then ! SDO
            isec1(6)=160         ! indicatorOfParameter
          elseif((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and.
     +      (typSurf.eq.1)) then ! LSM
            isec1(6)=172         ! indicatorOfParameter
          else
            print*,'***ERROR: undefined GRiB2 message found!',discipl,
     +        parCat,parNum,typSurf
          endif
        endif
!     get the size and data of the values array
        if (isec1(6).ne.-1) then
          call grib_get_real4_array(igrib,'values',zsec4,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
        endif

!HSO  get the required fields from section 2 in a gribex compatible manner
        if (ifield.eq.1) then
          call grib_get_int(igrib,'numberOfPointsAlongAParallel',
     >     isec2(2),iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_int(igrib,'numberOfPointsAlongAMeridian',
     >     isec2(3),iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_int(igrib,'numberOfVerticalCoordinateValues',
     >     isec2(12),iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
!HSO    get the size and data of the vertical coordinate array
          call grib_get_real4_array(igrib,'pv',zsec2,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          nxn(l)=isec2(2)
          nyn(l)=isec2(3)
          nlev_ecn=isec2(12)/2-1
        endif ! ifield

!HSO  get the second part of the grid dimensions only from GRiB1 messages
        if ((gribVer.eq.1).and.(gotGrib.eq.0)) then
          call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees'
     +       ,xaux1in,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_real8(igrib,'longitudeOfLastGridPointInDegrees',
     +       xaux2in,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees',
     +       yaux1in,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_real8(igrib,'latitudeOfFirstGridPointInDegrees',
     +       yaux2in,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          xaux1=xaux1in
          xaux2=xaux2in
          yaux1=yaux1in
          yaux2=yaux2in
          if(xaux1.gt.180) xaux1=xaux1-360.0
          if(xaux2.gt.180) xaux2=xaux2-360.0
          if(xaux1.lt.-180) xaux1=xaux1+360.0
          if(xaux2.lt.-180) xaux2=xaux2+360.0
          if (xaux2.lt.xaux1) xaux2=xaux2+360.
          xlon0n(l)=xaux1
          ylat0n(l)=yaux1
          dxn(l)=(xaux2-xaux1)/float(nxn(l)-1)
          dyn(l)=(yaux2-yaux1)/float(nyn(l)-1)
          gotGrib=1
        endif ! ifield.eq.1


        if(isec1(6).eq.129) oronew=.true.
        k=isec1(8)
        if(isec1(6).eq.131) iumax=max(iumax,nlev_ecn-k+1)
        if(isec1(6).eq.135) iwmax=max(iwmax,nlev_ecn-k+1)

        if(isec1(6).eq.129) then
          do 20 j=0,nyn(l)-1
            do 21 i=0,nxn(l)-1
21            oron(i,j,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)/ga
20          continue
        endif

        call grib_release(igrib)
        goto 10                  ! READ NEXT LEVEL OR PARAMETER
*
* CLOSING OF INPUT DATA FILE
*
30      call grib_close_file(ifile)

*     error message if no fields found with correct first longitude in it
        if (gotGrib.eq.0) then
          print*,'***ERROR: input file needs to contain GRiB1 formatted'
     +  //'messages'
          stop
        endif

        nuvzn=iumax
        nwzn=iwmax
        if(nuvzn.eq.nlev_ecn) nwzn=nlev_ecn+1

        if (nxn(l).gt.nxmaxn) then
      write(*,*) 'FLEXTRA error: Too many grid points in x direction.'
      write(*,*) 'Reduce resolution of wind fields (file GRIDSPEC)'
      write(*,*) 'for nesting level ',l

          error=.true.
          return
        endif

        if (nyn(l).gt.nymaxn) then
      write(*,*) 'FLEXTRA error: Too many grid points in y direction.'
      write(*,*) 'Reduce resolution of wind fields (file GRIDSPEC)'
      write(*,*) 'for nesting level ',l
          error=.true.
          return
        endif

        if ((nuvzn.gt.nuvzmax).or.(nwzn.gt.nwzmax)) then
      write(*,*) 'FLEXTRA error: Nested wind fields have too many'//
     +'vertical levels.'
      write(*,*) 'Problem was encountered for nesting level ',l
          error=.true.
          return
        endif


C Output of grid info
*********************

      write(*,'(a,i2)') 'Nested domain #: ',l
      write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Longitude range: ',
     +xlon0n(l),' to ',xlon0n(l)+(nxn(l)-1)*dxn(l),
     +'   Grid distance: ',dxn(l)
      write(*,'(a,f10.2,a1,f10.2,a,f10.2)') '  Latitude range:  ',
     +ylat0n(l),' to ',ylat0n(l)+(nyn(l)-1)*dyn(l),
     +'   Grid distance: ',dyn(l)
      write(*,*)


C Determine, how much the resolutions in the nests are enhanced as
C compared to the mother grid
******************************************************************

        xresoln(l)=dx/dxn(l)
        yresoln(l)=dy/dyn(l)

C Determine the mother grid coordinates of the corner points of the
C nested grids
C Convert first to geographical coordinates, then to grid coordinates
*********************************************************************

        xaux1=xlon0n(l)
        xaux2=xlon0n(l)+float(nxn(l)-1)*dxn(l)
        yaux1=ylat0n(l)
        yaux2=ylat0n(l)+float(nyn(l)-1)*dyn(l)

        xln(l)=(xaux1-xlon0)/dx
        xrn(l)=(xaux2-xlon0)/dx
        yln(l)=(yaux1-ylat0)/dy
        yrn(l)=(yaux2-ylat0)/dy


* CALCULATE VERTICAL DISCRETIZATION OF ECMWF MODEL
* PARAMETER akm,bkm DESCRIBE THE HYBRID "ETA" COORDINATE SYSTEM
* wheight(i) IS THE HEIGHT OF THE i-th MODEL HALF LEVEL (=INTERFACE BETWEEN
* 2 MODEL LEVELS) IN THE "ETA" SYSTEM

        numskip=nlev_ecn-nuvzn ! number of ECMWF model layers not used
                               ! by trajectory model
        do 40 i=1,nwzn
          j=numskip+i
          k=nlev_ecn+1+numskip+i
          akmn(nwzn-i+1)=zsec2(j)
          bkmn(nwzn-i+1)=zsec2(k)
40        wheightn(nwzn-i+1)=akmn(nwzn-i+1)/p0+bkmn(nwzn-i+1)

* CALCULATION OF uvheight, akz, bkz
* akz,bkz ARE THE DISCRETIZATION PARAMETERS FOR THE MODEL LEVELS
* uvheight(i) IS THE HEIGHT OF THE i-th MODEL LEVEL IN THE "ETA" SYSTEM

        do 45 i=1,nuvzn
          uvheightn(i)=0.5*(wheightn(i+1)+wheightn(i))
          akzn(i)=0.5*(akmn(i+1)+akmn(i))
45        bkzn(i)=0.5*(bkmn(i+1)+bkmn(i))


C If vertical coordinates decrease with increasing altitude, multiply by -1.
C This means that also the vertical velocities have to be multiplied by -1.
****************************************************************************

        if (uvheightn(1).lt.uvheightn(nuvzn)) then
          zdirect=1.
        else
          zdirect=-1.
          do 55 i=1,nuvz
55          uvheightn(i)=zdirect*uvheightn(i)
          do 65 i=1,nwz
65          wheightn(i)=zdirect*wheightn(i)
        endif


C Check, whether the heights of the model levels of the nested
C wind fields are consistent with those of the mother domain.
C If not, terminate model run.
**************************************************************

        do 75 i=1,nuvz
          if ((akzn(i).ne.akz(i)).or.(bkzn(i).ne.bkz(i)).or.
     +    (uvheightn(i).ne.uvheight(i))) then
      write(*,*) 'FLEXTRA error: The wind fields of nesting level',l
      write(*,*) 'are not consistent with the mother domain:'
      write(*,*) 'Differences in vertical levels detected.'
          error=.true.
          return
          endif
75        continue

        do 85 i=1,nwz
          if ((akmn(i).ne.akm(i)).or.(bkmn(i).ne.bkm(i)).or.
     +    (wheightn(i).ne.wheight(i))) then
      write(*,*) 'FLEXTRA error: The wind fields of nesting level',l
      write(*,*) 'are not consistent with the mother domain:'
      write(*,*) 'Differences in vertical levels detected.'
          error=.true.
          return
          endif
85        continue

        if (.not.oronew) then
          write(*,*) 'FLEXTRA error: Orography of nested domains'
          write(*,*) 'is missing in the wind field files.'
        endif

300     continue
      return


999   write(*,*)
      write(*,*) ' ###########################################'//
     &           '###### '
      write(*,*) '       TRAJECTORY MODEL SUBROUTINE GRIDCHECK:'
      write(*,*) ' CAN NOT OPEN INPUT DATA FILE '//wfnamen(l,ifn)
      write(*,*) ' FOR NESTING LEVEL ',k
      write(*,*) ' ###########################################'//
     &           '###### '
      error=.true.

      return
      end

      subroutine calcpv(n)
C
********************************************************************************
*                                                                              *
*  Calculation of potential vorticity on 3-d grid.                             *
*                                                                              *
*     Author: P. James                                                         *
*     3 February 2000                                                          *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* n                  temporal index for meteorological fields (1 to 3)         *
*                                                                              *
* Constants:                                                                   *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer n,ix,jy,i,j,k,kl,ii,jj,klvrp,klvrm,klpt,kup,kdn,kch
      integer jyvp,jyvm,ixvp,ixvm,jumpx,jumpy,jux,juy,ivrm,ivrp,ivr
      integer nlck
      real vx(2),uy(2),phi,tanphi,cosphi,dvdx,dudy,f
      real theta,thetap,thetam,dthetadp,dt1,dt2,dt,ppmk
      real height(nuvzmax),pvavr,ppml(nuvzmax)
      real thup,thdn

C Set number of levels to check for adjacent theta
      nlck=nuvz/3
      do 5 k=1,nuvz
        height(k)=akz(k)/p0+bkz(k)
5     continue
C *** Precalculate all theta levels for efficiency
        do 9 jy=0,ny-1
        do 14 kl=1,nuvz
        do 13 ix=0,nx-1
          ppmk=akz(kl)+bkz(kl)*ps(ix,jy,1,n)
          th(ix,jy,kl,n)=tt(ix,jy,kl,n)*(100000./ppmk)**kappa
13      continue
14      continue
9       continue
C
C Loop over entire grid
***********************
      do 10 jy=0,ny-1
        if (sglobal.and.jy.eq.0) goto 10
        if (nglobal.and.jy.eq.ny-1) goto 10
        phi = (ylat0 + jy * dy) * pi / 180.
        f = 0.00014585 * sin(phi)
        tanphi = tan(phi)
        cosphi = cos(phi)
C Provide a virtual jy+1 and jy-1 in case we are on domain edge (Lat)
          jyvp=jy+1
          jyvm=jy-1
          if (jy.eq.0) jyvm=0
          if (jy.eq.ny-1) jyvp=ny-1
C Define absolute gap length
          jumpy=2
          if (jy.eq.0.or.jy.eq.ny-1) jumpy=1
          if (sglobal.and.jy.eq.1) then
             jyvm=1
             jumpy=1
          end if
          if (nglobal.and.jy.eq.ny-2) then
             jyvp=ny-2
             jumpy=1
          end if
          juy=jumpy
C
        do 11 ix=0,nx-1
C Provide a virtual ix+1 and ix-1 in case we are on domain edge (Long)
          ixvp=ix+1
          ixvm=ix-1
          jumpx=2
          if (xglobal) then
             ivrp=ixvp
             ivrm=ixvm
             if (ixvm.lt.0) ivrm=ixvm+nx-1
             if (ixvp.ge.nx) ivrp=ixvp-nx+1
          else
            if (ix.eq.0) ixvm=0
            if (ix.eq.nx-1) ixvp=nx-1
            ivrp=ixvp
            ivrm=ixvm
C Define absolute gap length
            if (ix.eq.0.or.ix.eq.nx-1) jumpx=1
          end if
          jux=jumpx
C Precalculate pressure values for efficiency
          do 8 kl=1,nuvz
            ppml(kl)=akz(kl)+bkz(kl)*ps(ix,jy,1,n)
8         continue
C
C Loop over the vertical
************************

          do 12 kl=1,nuvz
            theta=th(ix,jy,kl,n)
            klvrp=kl+1
            klvrm=kl-1
            klpt=kl
C If top or bottom level, dthetadp is evaluated between the current
C level and the level inside, otherwise between level+1 and level-1
C
            if (klvrp.gt.nuvz) klvrp=nuvz
            if (klvrm.lt.1) klvrm=1
            thetap=th(ix,jy,klvrp,n)
            thetam=th(ix,jy,klvrm,n)
            dthetadp=(thetap-thetam)/(ppml(klvrp)-ppml(klvrm))
            
C Compute vertical position at pot. temperature surface on subgrid
C and the wind at that position
******************************************************************
C a) in x direction
            ii=0
            do 20 i=ixvm,ixvp,jumpx
              ivr=i
              if (xglobal) then
                 if (i.lt.0) ivr=ivr+nx-1
                 if (i.ge.nx) ivr=ivr-nx+1
              end if
              ii=ii+1
C Search adjacent levels for current theta value
C Spiral out from current level for efficiency
              kup=klpt-1
              kdn=klpt
              kch=0
40            continue
C Upward branch
              kup=kup+1
              if (kch.ge.nlck) goto 21     ! No more levels to check, 
C                                            ! and no values found
              if (kup.ge.nuvz) goto 41
              kch=kch+1
              k=kup
              thdn=th(ivr,jy,k,n)
              thup=th(ivr,jy,k+1,n)
          if (((thdn.ge.theta).and.(thup.le.theta)).or.
     +    ((thdn.le.theta).and.(thup.ge.theta))) then
                  dt1=abs(theta-thdn)
                  dt2=abs(theta-thup)
                  dt=dt1+dt2
                  if (dt.lt.eps) then   ! Avoid division by zero error
                    dt1=0.5             ! G.W., 10.4.1996
                    dt2=0.5
                    dt=1.0
                  endif
              vx(ii)=(vv(ivr,jy,k,n)*dt2+vv(ivr,jy,k+1,n)*dt1)/dt
                  goto 20
                endif
41            continue
C Downward branch
              kdn=kdn-1
              if (kdn.lt.1) goto 40
              kch=kch+1
              k=kdn
              thdn=th(ivr,jy,k,n)
              thup=th(ivr,jy,k+1,n)
          if (((thdn.ge.theta).and.(thup.le.theta)).or.
     +    ((thdn.le.theta).and.(thup.ge.theta))) then
                  dt1=abs(theta-thdn)
                  dt2=abs(theta-thup)
                  dt=dt1+dt2
                  if (dt.lt.eps) then   ! Avoid division by zero error
                    dt1=0.5             ! G.W., 10.4.1996
                    dt2=0.5
                    dt=1.0
                  endif
              vx(ii)=(vv(ivr,jy,k,n)*dt2+vv(ivr,jy,k+1,n)*dt1)/dt
                  goto 20
                endif
                goto 40
C This section used when no values were found
21          continue
C Must use vv at current level and long. jux becomes smaller by 1
            vx(ii)=vv(ix,jy,kl,n)
            jux=jux-1
C Otherwise OK
20          continue
          if (jux.gt.0) then
          dvdx=(vx(2)-vx(1))/float(jux)/(dx*pi/180.)
          else
          dvdx=vv(ivrp,jy,kl,n)-vv(ivrm,jy,kl,n)
          dvdx=dvdx/float(jumpx)/(dx*pi/180.)
C Only happens if no equivalent theta value
C can be found on either side, hence must use values
C from either side, same pressure level.
          end if

C b) in y direction

            jj=0
            do 50 j=jyvm,jyvp,jumpy
              jj=jj+1
C Search adjacent levels for current theta value
C Spiral out from current level for efficiency
              kup=klpt-1
              kdn=klpt
              kch=0
70            continue
C Upward branch
              kup=kup+1
              if (kch.ge.nlck) goto 51     ! No more levels to check, 
C                                          ! and no values found
              if (kup.ge.nuvz) goto 71
              kch=kch+1
              k=kup
              thdn=th(ix,j,k,n)
              thup=th(ix,j,k+1,n)
          if (((thdn.ge.theta).and.(thup.le.theta)).or.
     +    ((thdn.le.theta).and.(thup.ge.theta))) then
                  dt1=abs(theta-thdn)
                  dt2=abs(theta-thup)
                  dt=dt1+dt2
                  if (dt.lt.eps) then   ! Avoid division by zero error
                    dt1=0.5             ! G.W., 10.4.1996
                    dt2=0.5
                    dt=1.0
                  endif
                  uy(jj)=(uu(ix,j,k,n)*dt2+uu(ix,j,k+1,n)*dt1)/dt
                  goto 50
                endif
71            continue
C Downward branch
              kdn=kdn-1
              if (kdn.lt.1) goto 70
              kch=kch+1
              k=kdn
              thdn=th(ix,j,k,n)
              thup=th(ix,j,k+1,n)
          if (((thdn.ge.theta).and.(thup.le.theta)).or.
     +    ((thdn.le.theta).and.(thup.ge.theta))) then
                  dt1=abs(theta-thdn)
                  dt2=abs(theta-thup)
                  dt=dt1+dt2
                  if (dt.lt.eps) then   ! Avoid division by zero error
                    dt1=0.5             ! G.W., 10.4.1996
                    dt2=0.5
                    dt=1.0
                  endif
                  uy(jj)=(uu(ix,j,k,n)*dt2+uu(ix,j,k+1,n)*dt1)/dt
                  goto 50
                endif
                goto 70
C This section used when no values were found
51          continue
C Must use uu at current level and lat. juy becomes smaller by 1
            uy(jj)=uu(ix,jy,kl,n)
            juy=juy-1
C Otherwise OK
50          continue
          if (juy.gt.0) then
          dudy=(uy(2)-uy(1))/float(juy)/(dy*pi/180.)
          else
          dudy=uu(ix,jyvp,kl,n)-uu(ix,jyvm,kl,n)
          dudy=dudy/float(jumpy)/(dy*pi/180.)
          end if
C
          pv(ix,jy,kl,n)=dthetadp*(f+(dvdx/cosphi-dudy
     +    +uu(ix,jy,kl,n)*tanphi)/r_earth)*(-1.e6)*9.81
C
C Resest jux and juy
          jux=jumpx
          juy=jumpy
12        continue
11        continue                                                            
10        continue
C
C Fill in missing PV values on poles, if present
C Use mean PV of surrounding latitude ring
C
          if (sglobal) then
             do 80 kl=1,nuvz
                pvavr=0.
                do 81 ix=0,nx-1
                   pvavr=pvavr+pv(ix,1,kl,n)
81              continue
                pvavr=pvavr/float(nx)
                jy=0
                do 82 ix=0,nx-1
                   pv(ix,jy,kl,n)=pvavr
82              continue
80           continue
          end if
          if (nglobal) then
             do 90 kl=1,nuvz
                pvavr=0.
                do 91 ix=0,nx-1
                   pvavr=pvavr+pv(ix,ny-2,kl,n)
91              continue
                pvavr=pvavr/float(nx)
                jy=ny-1
                do 92 ix=0,nx-1
                   pv(ix,jy,kl,n)=pvavr
92              continue
90           continue
          end if
      return
      end

      subroutine trajout(numb,nstop)          
C                         i     i
********************************************************************************
*                                                                              *
*     This routine writes the output files.                                    *
*                                                                              *
*     Authors: A. Stohl                                                        *
*                                                                              *
*     2 February 1994                                                          *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* bdate                 beginning date of modelling period                     *
*                                                                              *
* idate,itime           date and time,help variables                           *
* inter                 output with flexible (0,2) or constant time step (1,2) *
* ldim                  number of interpolated time steps                      *
* maxnests              maximum number of nesting levels                       *
* ngrid                 nesting level to be used                               *
* npoint(maxtra)        number of starting point for each trajectory           *
* nstop                 error code                                             *
* nttra(maxtra)         number of time steps along the trajectory              *
* numb                  number of trajectory to be written to output file      *
* juldat                Julian starting date of trajectory                     *
* xtra,ytra,ztra(maxtra,maxtime)     grid coordinates of trajectory (flexible) *
* xtraint,ytraint,ztraint(maxitime)  grid coordinates of trajectory (flexible) *
*                                                                              *
* Constants:                                                                   *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer nstop,numb,idate,itime,i,j,ldimi,ngrid
      real orotra(maxtime),orotraint(maxitime),xtn,ytn
      double precision juldat


C If serious error has occurred, reduce the number of time steps by 1.
C This has to be done to exclude unrealistic values.
**********************************************************************

      if (nstop.gt.1) nttra(numb)=nttra(numb)-1


C Add the height of the orography to give height above sea level
****************************************************************

      do 10 i=1,nttra(numb)

C Determine which nesting level to be used
******************************************

        ngrid=0
        do 12 j=numbnests,1,-1
          if ((xtra(numb,i).gt.xln(j)).and.(xtra(numb,i).lt.xrn(j)).and.
     +    (ytra(numb,i).gt.yln(j)).and.(ytra(numb,i).lt.yrn(j))) then
            ngrid=j
            goto 13
          endif
12        continue
13      continue

        if (ngrid.eq.0) then
          call orolininterpol(oro,nxmax,nymax,nx,ny,xtra(numb,i),
     +    ytra(numb,i),orotra(i))
        else
          xtn=(xtra(numb,i)-xln(ngrid))*xresoln(ngrid)
          ytn=(ytra(numb,i)-yln(ngrid))*yresoln(ngrid)
          call orolininterpoln(oron,maxnests,nxmaxn,nymaxn,ngrid,
     +    nxn,nyn,xtn,ytn,orotra(i))
        endif
10    htra(numb,i)=htra(numb,i)+orotra(i)


C Conversion of grid coordinates to geografical coordinates
***********************************************************

      do 30 i=1,nttra(numb)
        call lamphi_ecmwf(xtra(numb,i),ytra(numb,i),xtra(numb,i),
     +  ytra(numb,i))
30      ptra(numb,i)=ptra(numb,i)/100.          ! conversion Pa -> hPa


C If trajectory information is wanted with constant time step, interpolate the
C trajectory to constant time step
******************************************************************************

      if (inter.ge.1) then
        call trajinterpol(numb,ldimi,orotra,orotraint)
      endif


C Calculate starting date and time of trajectory
************************************************

      juldat=bdate+dble(float(ittra(numb,1)))/86400.
      call caldate(juldat,idate,itime)


C Output of normal (non-CET) trajectories
*****************************************

      if (modecet.eq.1) then


C Output of trajectories with flexible time step
************************************************

      if ((inter.eq.0).or.(inter.eq.2)) then
        if (nttra(numb).eq.1) nttra(numb)=0
        write(unittraj+npoint(numb),'(a6,i8,a9,i8,a16,i1,a16,i5)') 
     +  'DATE: ',idate,'    TIME:',itime,'    STOP INDEX: ',nstop,
     +  '    # OF POINTS:',nttra(numb)
        write(unittraj+npoint(numb),67) '    SECS',
     +  '   LONGIT','   LATIT','    ETA','  PRESS','     Z',' Z-ORO',
     +'     PV',' THETA','       Q'
        do 40 i=1,nttra(numb)
40        write(unittraj+npoint(numb),66) 
     +    ittra(numb,i)-ittra(numb,1),xtra(numb,i),ytra(numb,i),
     +    ztra(numb,i)*zdirect,ptra(numb,i),htra(numb,i),
     +    htra(numb,i)-orotra(i),pvtra(numb,i),thtra(numb,i),
     +    qqtra(numb,i)
      endif


C Output of trajectories with constant time step
************************************************

      if (inter.ge.1) then                         
        if (ldimi.eq.1) ldimi=0
        write(unittraji+npoint(numb),'(a6,i8,a9,i8,a16,i1,a16,i5)') 
     +  'DATE: ',idate,'    TIME:',itime,'    STOP INDEX: ',nstop,
     +  '    # OF POINTS:',ldimi
        write(unittraji+npoint(numb),67) '    SECS',
     +  '   LONGIT','   LATIT','    ETA','  PRESS','     Z',' Z-ORO',
     +'     PV',' THETA','       Q'
        do 50 i=1,ldimi
50        write(unittraji+npoint(numb),66) 
     +    ittraint(i)-ittraint(1),xtraint(i),ytraint(i),ztraint(i)*
     +    zdirect,ptraint(i),htraint(i),htraint(i)-orotraint(i),
     +    pvtraint(i),thtraint(i),qqtraint(i)
      endif

C Output of CET or FLIGHT trajectories
**************************************

      else

C Output of trajectories with flexible time step
************************************************

      if ((inter.eq.0).or.(inter.eq.2)) then
        if (nttra(numb).eq.1) nttra(numb)=0
        write(unittraj,'(a6,i8,a9,i8,a16,i1,a16,i5)') 
     +  'DATE: ',idate,'    TIME:',itime,'    STOP INDEX: ',nstop,
     +  '    # OF POINTS:',nttra(numb)
        write(unittraj,67) '    SECS',
     +  '   LONGIT','   LATIT','    ETA','  PRESS','     Z',' Z-ORO',
     +'     PV',' THETA','       Q'
        do 140 i=1,nttra(numb)
140       write(unittraj,66) 
     +    ittra(numb,i)-ittra(numb,1),xtra(numb,i),ytra(numb,i),
     +    ztra(numb,i)*zdirect,ptra(numb,i),htra(numb,i),
     +    htra(numb,i)-orotra(i),pvtra(numb,i),thtra(numb,i),
     +    qqtra(numb,i)
      endif


C Output of trajectories with constant time step
************************************************

      if (inter.ge.1) then                         
        if (ldimi.eq.1) ldimi=0
        write(unittraji,'(a6,i8,a9,i8,a16,i1,a16,i5)') 
     +  'DATE: ',idate,'    TIME:',itime,'    STOP INDEX: ',nstop,
     +  '    # OF POINTS:',ldimi
        write(unittraji,67) '    SECS',
     +  '   LONGIT','   LATIT','    ETA','  PRESS','     Z',' Z-ORO',
     +'     PV',' THETA','       Q'
        do 150 i=1,ldimi
150       write(unittraji,66) 
     +    ittraint(i)-ittraint(1),xtraint(i),ytraint(i),ztraint(i)*
     +    zdirect,ptraint(i),htraint(i),htraint(i)-orotraint(i),
     +    pvtraint(i),thtraint(i),qqtraint(i)
      endif

      endif

66    format(i9,2f9.4,f7.4,f7.1,2f8.1,f8.3,f6.1,e9.2)
67    format(a9,a9,a9,a7,a7,a8,a8,a8,a6,a9)

      return    
      end

      subroutine readwind_nests(indj,n)
C                                i   i
************************************************************************
*                                                                      *
*     This routine reads the wind fields for the nested model domains. *
*     It is similar to subroutine readwind, which reads the mother
*     domain.                                                          *
*                                                                      *
*     Authors: A. Stohl, G. Wotawa                                     *
*                                                                      *
*     30 December 1998                                                 *
*                                                                      *
*     Update:                                                          *
*                          2011-06, implemented reading of grib2 format*
*                                   analog to FLEXPART8.22 routines    *
************************************************************************

      use grib_api
      include 'includepar'
      include 'includecom'

      integer indj,i,j,k,l,n,levdiff2,ifield,iumax,iwmax

!HSO  parameters for grib_api
      integer ifile
      integer iret
      integer igrib
      integer gribVer,parCat,parNum,typSurf,valSurf,discipl
      integer gotGrid
      character*24 gribErrorMsg
      character*20 gribFunction
!HSO  end

* VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

C dimension of isec2 at least (22+n), where n is the number of parallels or
C meridians in a quasi-regular (reduced) Gaussian or lat/long grid

C dimension of zsec2 at least (10+nn), where nn is the number of vertical
C coordinate parameters

      integer isec0(2),isec1(56),isec2(22+nxmaxn+nymaxn),isec3(2)
      integer isec4(64),inbuff(jpack),ilen,iswap,ierr,lunit,iword
      real zsec2(60+2*nuvzmax),zsec3(2),zsec4(jpunp)
      real xaux,yaux,xaux0,yaux0
      real*8 xauxin,yauxin

      character*1 yoper
      logical error

      data yoper/'D'/
!HSO  grib api error messages
      data gribErrorMsg/'Error reading grib file'/
      data gribFunction/'readwind_nests'/

      do 100 l=1,numbnests
        levdiff2=nlev_ec-nwz+1
        iumax=0
        iwmax=0

        ifile=0
        igrib=0
        iret=0
*
* OPENING OF DATA FILE (GRIB CODE)
*
5       call grib_open_file(ifile,path(numpath+2*(l-1)+1)
     +   (1:len(numpath+2*(l-1)+1))//trim(wfnamen(l,indj)),'r')
        if (iret.ne.GRIB_SUCCESS) then
          goto 888   ! ERROR DETECTED
        endif

        gotGrid=0
        ifield=0
C   loop fields
10      ifield=ifield+1
*
* GET NEXT FIELDS
*
        call grib_new_from_file(ifile,igrib,iret)
        if (iret.eq.GRIB_END_OF_FILE)  then
          goto 50    ! EOF DETECTED
        elseif (iret.ne.GRIB_SUCCESS) then
          goto 888   ! ERROR DETECTED
        endif

!     first see if we read GRIB1 or GRIB2
        call grib_get_int(igrib,'editionNumber',gribVer,iret)
        call grib_check(iret,gribFunction,gribErrorMsg)

        if (gribVer.eq.1) then ! GRIB Edition 1
c     print*,'GRiB Edition 1'
c     read the grib2 identifiers
          call grib_get_int(igrib,'indicatorOfParameter',isec1(6),
     +     iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_int(igrib,'level',isec1(8),iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
c     change code for etadot to code for omega
          if (isec1(6).eq.77) then
            isec1(6)=135
          endif
        else
c     print*,'GRiB Edition 2'
c     read the grib2 identifiers
          call grib_get_int(igrib,'discipline',discipl,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_int(igrib,'parameterCategory',parCat,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_int(igrib,'parameterNumber',parNum,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_int(igrib,'typeOfFirstFixedSurface',typSurf,
     +     iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_int(igrib,'level',valSurf,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
!     convert to grib1 identifiers
          isec1(6)=-1
          isec1(7)=-1
          isec1(8)=-1
          isec1(8)=valSurf     ! level
          if((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.105))then ! T
            isec1(6)=130         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.105))
     +     then ! U
            isec1(6)=131         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.105))
     +     then ! V
            isec1(6)=132         ! indicatorOfParameter
          elseif((parCat.eq.1).and.(parNum.eq.0).and.(typSurf.eq.105))
     +     then ! Q
            isec1(6)=133         ! indicatorOfParameter
          elseif((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.1))then !SP
            isec1(6)=134         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.32)) then ! W, actually eta dot
            isec1(6)=135         ! indicatorOfParameter
          elseif((parCat.eq.3).and.(parNum.eq.0).and.(typSurf.eq.101))
     +     then !SLP
            isec1(6)=151         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.2).and.(typSurf.eq.103))
     +     then ! 10U
            isec1(6)=165         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.3).and.(typSurf.eq.103))
     +     then ! 10V
            isec1(6)=166         ! indicatorOfParameter
          elseif((parCat.eq.0).and.(parNum.eq.0).and.(typSurf.eq.103))
     +     then ! 2T
            isec1(6)=167         ! indicatorOfParameter
          elseif((parCat.eq.0).and.(parNum.eq.6).and.(typSurf.eq.103))
     +     then ! 2D
            isec1(6)=168         ! indicatorOfParameter
          elseif((parCat.eq.1).and.(parNum.eq.11).and.(typSurf.eq.1))
     +     then ! SD
            isec1(6)=141         ! indicatorOfParameter
          elseif((parCat.eq.6).and.(parNum.eq.1)) then ! CC
            isec1(6)=164         ! indicatorOfParameter
          elseif((parCat.eq.1).and.(parNum.eq.9)) then ! LSP
            isec1(6)=142         ! indicatorOfParameter
          elseif((parCat.eq.1).and.(parNum.eq.10)) then ! CP
            isec1(6)=143         ! indicatorOfParameter
          elseif((parCat.eq.0).and.(parNum.eq.11).and.(typSurf.eq.1))
     +     then ! SHF
            isec1(6)=146         ! indicatorOfParameter
          elseif((parCat.eq.4).and.(parNum.eq.9).and.(typSurf.eq.1))
     +     then ! SR
            isec1(6)=176         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.17)) then ! EWSS
            isec1(6)=180         ! indicatorOfParameter
          elseif((parCat.eq.2).and.(parNum.eq.18)) then ! NSSS
            isec1(6)=181         ! indicatorOfParameter
          elseif((parCat.eq.3).and.(parNum.eq.4)) then ! ORO
            isec1(6)=129         ! indicatorOfParameter
          elseif((parCat.eq.3).and.(parNum.eq.7)) then ! SDO
            isec1(6)=160         ! indicatorOfParameter
          elseif((discipl.eq.2).and.(parCat.eq.0).and.(parNum.eq.0).and.
     +      (typSurf.eq.1)) then ! LSM
            isec1(6)=172         ! indicatorOfParameter
          else
            print*,'***ERROR: undefined GRiB2 message found!',discipl,
     +        parCat,parNum,typSurf
          endif
        endif ! GRIB version

!HSO  get the size and data of the values array
        if (isec1(6).ne.-1) then
          call grib_get_real4_array(igrib,'values',zsec4,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
        endif

!HSO  get the required fields from section 2 in a gribex compatible manner
        if(ifield.eq.1) then
        call grib_get_int(igrib,'numberOfPointsAlongAParallel',
     +     isec2(2),iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'numberOfPointsAlongAMeridian',
     1     isec2(3),iret)
        call grib_check(iret,gribFunction,gribErrorMsg)
        call grib_get_int(igrib,'numberOfVerticalCoordinateValues',
     +     isec2(12))
        call grib_check(iret,gribFunction,gribErrorMsg)
* CHECK GRID SPECIFICATIONS
        if(isec2(2).ne.nxn(l)) stop
     +    'READWIND: NX NOT CONSISTENT FOR A NESTING LEVEL'
        if(isec2(3).ne.nyn(l)) stop
     +    'READWIND: NY NOT CONSISTENT FOR A NESTING LEVEL'
        if(isec2(12)/2-1.ne.nlev_ec) stop 'READWIND: VERTICAL DISCRET
     +IZATION NOT CONSISTENT FOR A NESTING LEVEL'
        endif ! ifield
!HSO  get the second part of the grid dimensions only from GRiB1 messages
        if ((gribVer.eq.1).and.(gotGrid.eq.0)) then
          call grib_get_real8(igrib,'longitudeOfFirstGridPointInDegrees'
     +     ,xauxin,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          call grib_get_real8(igrib,'latitudeOfLastGridPointInDegrees',
     +     yauxin,iret)
          call grib_check(iret,gribFunction,gribErrorMsg)
          xaux=xauxin
          yaux=yauxin
          xaux0=xlon0n(l)
          yaux0=ylat0n(l)
          if(xaux.lt.0.) xaux=xaux+360.
          if(yaux.lt.0.) yaux=yaux+360.
          if(xaux0.lt.0.) xaux0=xaux0+360.
          if(yaux0.lt.0.) yaux0=yaux0+360.
          if(xaux.ne.xaux0)
     +     stop 'READWIND: LOWER LEFT LONGITUDE NOT CONSISTENT FOR A NES
     +TING LEVEL'
          if(yaux.ne.yaux0)
     +      stop 'READWIND: LOWER LEFT LATITUDE NOT CONSISTENT FOR A NEST
     +ING LEVEL'
          gotGrid=1
        endif

          do 20 j=0,nyn(l)-1
            do 20 i=0,nxn(l)-1
              k=isec1(8)
              if(isec1(6).eq.130) ttn(i,j,nlev_ec-k+1,n,l)=    !! TEMPERATURE
     &        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
              if(isec1(6).eq.131) uun(i,j,nlev_ec-k+1,n,l)=    !! U VELOCITY
     &        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
              if(isec1(6).eq.132) vvn(i,j,nlev_ec-k+1,n,l)=    !! V VELOCITY
     &        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
              if(isec1(6).eq.133) then
                qqn(i,j,nlev_ec-k+1,n,l)=                      !! HUMIDITY
     &          zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
                if (qqn(i,j,nlev_ec-k+1,n,l).lt.0.)
     &          qqn(i,j,nlev_ec-k+1,n,l)=0.
c             this is necessary because the gridded data may contain
c             spurious negative values
              endif
              if(isec1(6).eq.134) psn(i,j,1,n,l)=              !! SURF. PRESS.
     &        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
              if(isec1(6).eq.135) wwn(i,j,nlev_ec-k+1,n,l)=    !! W VELOCITY
     &        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
              if(isec1(6).eq.129) oron(i,j,l)=                 !! ECMWF OROGRAPHY
     &        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)/ga
              if(isec1(6).eq.131) iumax=max(iumax,nlev_ec-k+1)
              if(isec1(6).eq.135) iwmax=max(iwmax,nlev_ec-k+1)
20            continue

        call grib_release(igrib)
        goto 10                      !! READ NEXT LEVEL OR PARAMETER
*
* CLOSING OF INPUT DATA FILE
*
50      call grib_close_file(ifile)
*     error message if no fields found with correct first longitude in it
        if (gotGrid.eq.0) then
          print*,'***ERROR: input file needs to contain GRiB1 formatted'
     +     //'messages'
          stop
        endif

        if(levdiff2.eq.0) then
          iwmax=nlev_ec+1
          do 60 j=0,nyn(l)-1
            do 60 i=0,nxn(l)-1
60            wwn(i,j,nlev_ec+1,n,l)=0.
        endif


        if(iumax.ne.nuvz) stop
     +  'READWIND: NUVZ NOT CONSISTENT FOR A NESTING LEVEL'
        if(iwmax.ne.nwz) stop
     +  'READWIND: NWZ NOT CONSISTENT FOR A NESTING LEVEL'



C Calculate potential temperature and potential vorticity on whole grid
***********************************************************************
        call calcpv_nests(l,n)

100   continue  ! END OF NESTS LOOP

      return
888   write(*,*) ' #### TRAJECTORY MODEL ERROR! WINDFIELD       #### '
      write(*,*) ' #### ',wfname(indj),'                    #### '
      write(*,*) ' #### IS NOT GRIB FORMAT !!!                  #### '
      stop 'Execution terminated'


999   write(*,*)
      write(*,*) ' ###########################################'//
     &           '###### '
      write(*,*) '       TRAJECTORY MODEL SUBROUTINE GRIDCHECK:'
      write(*,*) ' CAN NOT OPEN INPUT DATA FILE '//wfnamen(l,indj)
      write(*,*) ' FOR NESTING LEVEL ',l
      write(*,*) ' ###########################################'//
     &           '###### '
      error=.true.

      end

      FUNCTION juldate(YYYYMMDD,HHMISS)
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*                                                                             *
*     Calculates the Julian date                                              *
*                                                                             *
*     AUTHOR: Andreas Stohl (15 October 1993)                                 *
*                                                                             *
*     Variables:                                                              *
*     DD             Day                                                      *
*     HH             Hour                                                     *
*     HHMISS         Hour, minute + second                                    *
*     JA,JM,JY       help variables                                           *
*     JULDATE        Julian Date                                              *
*     JULDAY         help variable                                            *
*     MI             Minute                                                   *
*     MM             Month                                                    *
*     SS             Second                                                   *
*     YYYY           Year                                                     *
*     YYYYMMDDHH     Date and Time                                            *
*                                                                             *
*     Constants:                                                              *
*     IGREG          help constant                                            *
*                                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

      IMPLICIT NONE

      INTEGER YYYYMMDD,YYYY,MM,DD,HH,MI,SS,HHMISS
      INTEGER JULDAY,JY,JM,JA,IGREG
      DOUBLE PRECISION JULDATE
      PARAMETER (IGREG=15+31*(10+12*1582))

      YYYY=YYYYMMDD/10000
      MM=(YYYYMMDD-10000*YYYY)/100
      DD=YYYYMMDD-10000*YYYY-100*MM
      HH=HHMISS/10000
      MI=(HHMISS-10000*HH)/100
      SS=HHMISS-10000*HH-100*MI

      IF (YYYY.EQ.0) PAUSE 'There is no Year Zero.'
      IF (YYYY.LT.0) YYYY=YYYY+1
      IF (MM.GT.2) THEN
        JY=YYYY
        JM=MM+1
      ELSE
        JY=YYYY-1
        JM=MM+13
      ENDIF
      JULDAY=INT(365.25*JY)+INT(30.6001*JM)+DD+1720995
      IF (DD+31*(MM+12*YYYY).GE.IGREG) THEN
        JA=INT(0.01*JY)
        JULDAY=JULDAY+2-JA+INT(0.25*JA)
      ENDIF

      JULDATE=DBLE(FLOAT(JULDAY))+DBLE(FLOAT(HH)/24.)+
     +DBLE(FLOAT(MI)/1440.)+DBLE(FLOAT(SS)/86400.)

      RETURN
      END

      subroutine readwind_nests(indj,n)
C                                i   i
********************************************************************************
*                                                                              *
*     This routine reads the wind fields for the nested model domains.         *
*     It is similar to subroutine readwind, which reads the mother domain.     *
*                                                                              *
*     Authors: A. Stohl, G. Wotawa                                             *
*                                                                              *
*     30 December 1998                                                         *
********************************************************************************


      include 'includepar'
      include 'includecom'

      integer indj, n

      IF(NUMBNESTS.NE.0)
     & STOP 'SORRY: FLEXTRA (NCEP) CAN NOT BE OPERATED WITH NESTING'

      end

      subroutine pvinterpol 
     &    (pv, xt,yt,itime1,itime2,itime, pvint)
C           i   i  i     i     i    i       o

C  Special interpolation subroutine for pot. vorticity on a small subgrid   
C  In horizontal direction bilinear interpolation interpolation is used.    
C  Temporally a linear interpolation is used.                               
C                                                                           
C  Variables:
C  pv (nx,ny,nt)   potential vorticity on 2*2*2 subgrid
C  xt,yt           horizontal position in interval [0:1,0:1]
C                  to which the interpolation is to be made
C  itime1,itime2   time in seconds for which PV is given
C  itime           time in seconds for which PV is desired
C  pvint           interpolated value of PV
C
C     Author: Petra Seibert                                                 
C     based on subroutine lininterpol.f by A. Stohl from  30 May 1994     
C     Date: 3 May 1995

      dimension pv(2,2,2), pvt(2) 

C     bilinear horizontal interpolation

      ddx = xt
      ddy = yt

      rddx = 1.-ddx
      rddy = 1.-ddy

C     loop over 2 time levels

      do 20 n=1,2
        pvt(n) = rddx * rddy * pv(1,1,n)
     +          + ddx * rddy * pv(2,1,n)
     +          +rddx * ddy  * pv(1,2,n)
     +          + ddx * ddy  * pv(2,2,n)
20      continue

C     temporal interpolation (linear)

      dt1 = float( itime - itime1 )
      dt2 = float( itime2 - itime )
      pvint = (pvt(1) * dt2 + pvt(2) * dt1) / (dt1 + dt2)

      return
      end

      subroutine coordtrafo(error)
***********************************************************************
*                                                                     * 
*             TRAJECTORY MODEL SUBROUTINE COORDTRAFO                  *
*                                                                     *
***********************************************************************
*                                                                     * 
*             AUTHOR:      G. WOTAWA                                  *
*             DATE:        1994-02-07                                 *
*             LAST UPDATE: ----------                                 *
*                                                                     * 
***********************************************************************
*                                                                     *
* DESCRIPTION: This subroutine transforms x and y coordinates of      *
* trajectory starting points to grid coordinates.                     *
*                                                                     *
***********************************************************************
*
      include 'includepar'
      include 'includecom'

      integer i,j
      logical error

      error=.false.

      if(numpoint.eq.0) goto 30
*
* TRANSFORM X- AND Y- COORDINATES OF STARTING POINTS TO GRID COORDINATES
*

      do 10 i=1,numpoint
         xpoint(i)=(xpoint(i)-xlon0)/dx
         if (xglobal) then
           if (xpoint(i).gt.float(nx-1)) xpoint(i)=xpoint(i)-float(nx-1)
           if (xpoint(i).lt.0.) xpoint(i)=xpoint(i)+float(nx-1)
         endif
10       ypoint(i)=(ypoint(i)-ylat0)/dy

15    continue
*
* CHECK IF STARTING POINTS ARE WITHIN DOMAIN
*
      do 25 i=1,numpoint

        if((xpoint(i).lt.0.).or.(xpoint(i).gt.float(nx-1)).or.
     &      (ypoint(i).lt.0.).or.(ypoint(i).gt.float(ny-1))) then

        write(*,*) ' NOTICE: STARTING POINT OUT OF DOMAIN HAS '//
     &              'BEEN DETECTED --> '
        write(*,*) ' IT IS REMOVED NOW ... '
        write(*,*) ' COMMENT: ',compoint(i)

          if(i.lt.numpoint) then

            do 20 j=i+1,numpoint

              xpoint(j-1)=xpoint(j)
              ypoint(j-1)=ypoint(j)
              zpoint(j-1)=zpoint(j)
              kind(j-1)=kind(j)
              kindz(j-1)=kindz(j)
20            compoint(j-1)=compoint(j)         

          endif

          numpoint=numpoint-1
          if(numpoint.gt.0) goto 15

        endif

25    continue

30    if(numpoint.eq.0) then

         error=.true.
         write(*,*) ' TRAJECTORY MODEL SUBROUTINE COORDTRAFO: '//
     &              'ERROR ! '
         write(*,*) ' NO TRAJECTORY STARTING POINTS ARE GIVEN !!!'

      endif

      return
      end 

      subroutine orolininterpoln(yy,maxnests,nxmax,nymax,ngrid,nxn,nyn,
     +xt,yt,yint)
C                                i     i       i     i     i    i   i
C     i  i   o
*****************************************************************************
*                                                                           *
*  Interpolation of nested meteorological fields on 2-d model layers.       *
*  A bilinear interpolation interpolation is used.                          *
*                                                                           *
*                                                                           *
*     Author: A. Stohl                                                      *
*                                                                           *
*     30 May 1994                                                           *
*                                                                           *
*****************************************************************************
*                                                                           *
* Variables:                                                                *
*                                                                           *
* height(nzmax)        heights of the model levels                          *
* ix,jy                x,y coordinates of lower left subgrid point          *
* maxnests             maximum allowed number of nests                      *
* ngrid                currently used number of nests                       *
* nxn,nyn              actual field dimensions in x,y and z direction       *
* nxmax,nymax,nzmax    maximum field dimensions in x,y and z direction      *
* xt                   current x coordinate                                 *
* yint                 the final interpolated value                         *
* yt                   current y coordinate                                 *
* yy(0:nxmax-1,0:nymax-1) meteorological field used for interpolation       *
* zt                   current z coordinate                                 *
*                                                                           *
*****************************************************************************

      implicit none

      integer maxnests,nxn(maxnests),nyn(maxnests),nxmax,nymax,ngrid
      integer ix,jy,ixp,jyp
      real yy(0:nxmax-1,0:nymax-1,maxnests)
      real ddx,ddy,rddx,rddy
      real xt,yt,yint
     


C If point at border of grid -> small displacement into grid
************************************************************

      if (xt.ge.float(nxn(ngrid)-1)) xt=float(nxn(ngrid)-1)-0.00001
      if (yt.ge.float(nyn(ngrid)-1)) yt=float(nyn(ngrid)-1)-0.00001



***********************************************************************
C 1.) Bilinear horizontal interpolation
C This has to be done separately for 2 fields (Temporal)
********************************************************

C Determine the lower left corner and its distance to the current position
************************************************************************** 

      ix=int(xt)
      jy=int(yt)
      ixp=ix+1
      jyp=jy+1
      ddx=xt-float(ix)
      ddy=yt-float(jy)
      rddx=1.-ddx
      rddy=1.-ddy
     

C Loop over 2 time steps
************************
 
      yint=rddx*rddy*yy(ix ,jy ,ngrid)
     +    + ddx*rddy*yy(ixp,jy ,ngrid)
     +    +rddx* ddy*yy(ix ,jyp,ngrid)
     +    + ddx* ddy*yy(ixp,jyp,ngrid)



      return
      end

      subroutine levlininterpoln(yy,maxnests,nxmax,nymax,nzmax,ngrid,
     +nxn,nyn,memind,xt,yt,level,itime1,itime2,itime,index,yint)
C                                i     i       i     i     i     i
C      i   i    i    i  i    i     i      i      i     i    i
*****************************************************************************
*                                                                           *
*  Interpolation of meteorological fields on 2-d model layers.              *
*  In horizontal direction bilinear interpolation interpolation is used.    *
*  Temporally a linear interpolation is used.                               *
*                                                                           *
*  1 first time                                                             *
*  2 second time                                                            *
*                                                                           *
*                                                                           *
*     Author: A. Stohl                                                      *
*                                                                           *
*     30 May 1994                                                           *
*                                                                           *
*****************************************************************************
*                                                                           *
* Variables:                                                                *
*                                                                           *
* dt1,dt2              time differences between fields and current position *
* dz1,dz2              z distance between levels and current position       *
* height(nzmax)        heights of the model levels                          *
* index                indicates the number of the wind field to be read in *
* indexh               help variable                                        *
* indz                 the level closest to the current trajectory position *
* indzh                help variable                                        *
* itime                current time                                         *
* itime1               time of the first wind field                         *
* itime2               time of the second wind field                        *
* ix,jy                x,y coordinates of lower left subgrid point          *
* level                level at which interpolation shall be done           *
* memind(3)            points to the places of the wind fields              *
* nx,ny                actual field dimensions in x,y and z direction       *
* nxmax,nymax,nzmax    maximum field dimensions in x,y and z direction      *
* xt                   current x coordinate                                 *
* yint                 the final interpolated value                         *
* yt                   current y coordinate                                 *
* yy(0:nxmax,0:nymax,nzmax,3) meteorological field used for interpolation   *
* zt                   current z coordinate                                 *
*                                                                           *
*****************************************************************************

      implicit none

      integer maxnests,nxn(maxnests),nyn(maxnests),nxmax,nymax,nzmax
      integer ngrid,memind(3),m,ix,jy,ixp,jyp
      integer itime,itime1,itime2,level,index,indexh
      real yy(0:nxmax-1,0:nymax-1,nzmax,3,maxnests)
      real ddx,ddy,rddx,rddy,dt1,dt2,y(2)
      real xt,yt,yint
     


C If point at border of grid -> small displacement into grid
************************************************************

      if (xt.ge.float(nxn(ngrid)-1)) xt=float(nxn(ngrid)-1)-0.00001
      if (yt.ge.float(nyn(ngrid)-1)) yt=float(nyn(ngrid)-1)-0.00001



***********************************************************************
C 1.) Bilinear horizontal interpolation
C This has to be done separately for 2 fields (Temporal)
********************************************************

C Determine the lower left corner and its distance to the current position
************************************************************************** 

      ix=int(xt)
      jy=int(yt)
      ixp=ix+1
      jyp=jy+1
      ddx=xt-float(ix)
      ddy=yt-float(jy)
      rddx=1.-ddx
      rddy=1.-ddy
     

C Loop over 2 time steps
************************
 
      do 10 m=1,2
        indexh=memind(index+m-1)

10      y(m)=rddx*rddy*yy(ix ,jy ,level,indexh,ngrid)
     +      + ddx*rddy*yy(ixp,jy ,level,indexh,ngrid)
     +      +rddx* ddy*yy(ix ,jyp,level,indexh,ngrid)
     +      + ddx* ddy*yy(ixp,jyp,level,indexh,ngrid)


*************************************
C 2.) Temporal interpolation (linear)
*************************************

      dt1=float(itime-itime1)
      dt2=float(itime2-itime)

      yint=(y(1)*dt2+y(2)*dt1)/(dt1+dt2)


      return
      end
